unit MainFormUnit;
{
{ Copy right 2002 Sergei Khomutov.
The TsesDataSet demonstration with using Borland BDE.
}
{
The sample demonstrates the following main features of the TsesDataSet:
- ability to borrow a database table structure;
- Sort, Seek and other the TsesDataSet methods.

Consider to use the following way to create "on-fly" structure at design time:
1. export the desired table to the text file;
2. place on the Form the TsesSataSet;
3. set the TsesDataSet OpenMode property to omStructureData;
4. set the TsesDataSet FileName property to the created text file;
5. set the TsesDataSet Active property to True, then set it to False again;
6. see the TsesDataSet sesFields property, it must contain the new created structure;
7. also, you got the text data in the TsesDataSet DataStrings property.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesDataSetUnit, ExtCtrls, Buttons, StdCtrls, Grids, DBGrids, DBCtrls, Db,
  DBTables, ComCtrls, sesEditUnit, CheckLst, ActnList, FileCtrl;

type

TSearchRecord = record
 SearchFields:String;
 SearchValues:String;
 Found:Boolean;
 LocateOptions:TLocateOptions;
 SeekOption:TSeekOption;
 goForward:Boolean;
 end;

  TMainForm = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    Splitter1: TSplitter;
    DataSource2: TDataSource;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    sesDataSet1: TsesDataSet;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    AliasEdit: TsesEdit;
    sesLogger1: TsesLogger;
    Splitter2: TSplitter;
    Panel4: TPanel;
    AutoOpen: TCheckBox;
    SpeedButton2: TSpeedButton;
    ActionList1: TActionList;
    OpenTableAction: TAction;
    GroupBox2: TGroupBox;
    Splitter3: TSplitter;
    Panel5: TPanel;
    sesEditDir: TsesEdit;
    Panel6: TPanel;
    SpeedButton8: TSpeedButton;
    DBNavigator3: TDBNavigator;
    DBGrid2: TDBGrid;
    ExtEdit: TsesEdit;
    AutoOpenFile: TCheckBox;
    SelectedFile: TsesEdit;
    OpenTextFile: TAction;
    ExportToTextFile: TAction;
    DBGrid3: TDBGrid;
    DataSource3: TDataSource;
    sesDataSet2: TsesDataSet;
    SpeedButton1: TSpeedButton;
    DeleteTextFile: TAction;
    SpeedButton3: TSpeedButton;
    Panel1: TPanel;
    SortTextFile: TAction;
    SortTextButton: TSpeedButton;
    SeekValuesButton: TSpeedButton;
    SeekValuesAgainButton: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SeekValues: TAction;
    SeekAgainValues: TAction;
    SaveTextAs: TAction;
    OpenedFilePanel: TPanel;
    SortFileList: TAction;
    SpeedButton5: TSpeedButton;
    clbTables: TListBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sesDataSet1AfterScroll(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure AliasEditChange(Sender: TObject);
    procedure OpenTableActionExecute(Sender: TObject);
    procedure clbTablesClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sesEditDirPickButtonClick(Sender: TObject);
    procedure OpenTextFileExecute(Sender: TObject);
    procedure sesEditDirChange(Sender: TObject);
    procedure SelectedFileChange(Sender: TObject);
    procedure sesDataSet2AfterScroll(DataSet: TDataSet);
    procedure ExportToTextFileExecute(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure DeleteTextFileExecute(Sender: TObject);
    procedure SortTextFileExecute(Sender: TObject);
    procedure SeekValuesExecute(Sender: TObject);
    procedure SeekAgainValuesExecute(Sender: TObject);
    procedure SaveTextAsExecute(Sender: TObject);
    procedure SortFileListExecute(Sender: TObject);
  private
    { Private declarations }
    SearchRecord:TSearchRecord;
    procedure ExportToFile;
    procedure OpenTable;
    procedure OpenText;
    procedure DisplayHint(Sender: TObject);
    procedure FillFileList;
  public
    { Public declarations }
  procedure SeekRecord(DataSet:TDataSet);
  end;

var
  MainForm: TMainForm;

implementation

uses ExportFieldFilterFormUnit, SeekFormUnit, SortFormUnit;

{$R *.DFM}

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//look at a one way to store/restore the form position:
// see also the OnShow restoring method
sesLogger1.SaveControlRect(Self);

If Table1.Active then Table1.Close;

If sesDataSet1.Active then sesDataSet1.Close;

If sesDataSet2.Active then sesDataSet2.Close;

end;

procedure TMainForm.SeekRecord(DataSet:TDataSet);
var
I:Integer;
List:TStringList;
V:Variant;
S:String;
sesDataSet:TsesDataSet;
sesDS:Boolean;
RecNumber:Integer;
begin
//
SearchRecord.Found := False;
If SearchRecord.SearchFields = '' then Exit;
If DataSet Is TsesDataSet then
   begin
   sesDataSet:=TsesDataSet(Dataset);
   sesDS:=True;
   end;
try
List:=TStringList.Create;
List.Text := SearchRecord.SearchValues;
If List.Count = 1 then
   begin
   S:= List[0];
   V:=S;
   end
   else
   begin
   V := VarArrayCreate([0, List.Count-1], varVariant);
   for I:=0 to List.Count-1 do
       V[I] := List[I];

   end;

      SearchRecord.Found := sesDataSet.Seek(SearchRecord.SearchFields, V, SearchRecord.LocateOptions,
                   SearchRecord.SeekOption, SearchRecord.goForward);

finally
List.Free;
end;
end;

procedure TMainForm.sesDataSet1AfterScroll(DataSet: TDataSet);
begin
If not sesDataSet1.Active then
   StatusBar1.Panels[0].Text := 'Close'
   else
   StatusBar1.Panels[0].Text :=IntToStr(sesDataSet1.RecNo)+':'+
                               IntToStr(sesDataSet1.RecordCount);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
Session.GetAliasNames(AliasEdit.PickList);
Application.OnHint := DisplayHint;
end;

procedure TMainForm.DisplayHint(Sender: TObject);
begin
  StatusBar1.Panels[1].Text := GetLongHint(Application.Hint);
end;

procedure TMainForm.AliasEditChange(Sender: TObject);
begin
Session.GetTableNames(AliasEdit.Text,'',True,False, clbTables.Items);
end;

procedure TMainForm.OpenTableActionExecute(Sender: TObject);
begin
OpenTable;
end;

procedure TMainForm.OpenTable;
var
I:Integer;
begin
If clbTables.Items.Count = 0 then Exit;
I := clbTables.ItemIndex;
If I = -1 then Exit;
If Table1.Active then Table1.Close;
Table1.TableName := clbTables.Items[I];
Table1.Open;

end;

procedure TMainForm.clbTablesClick(Sender: TObject);
begin
If AutoOpen.Checked then
OpenTable;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
sesEditDir.Text := ExtractFileDir(Application.ExeName);
sesLogger1.Complete;
sesEditDir.OnChange := sesEditDirChange;

//look at a one way to store/restore the form position:
// see also the OnClose storing method
sesLogger1.ReadControlRect(Self);

end;

procedure TMainForm.sesEditDirPickButtonClick(Sender: TObject);
var
Dir:String;
begin
OpenDialog1.Filter := 'Ext files(*.'+ExtEdit.Text+')|*.'+ExtEdit.Text;
OpenDialog1.InitialDir := sesEditDir.Text;
OpenDialog1.FileName := 'DirName.'+ExtEdit.Text;
If OpenDialog1.Execute then
   begin
   sesEditDir.Text := ExtractFileDir(OpenDialog1.FileName);
   FillFileList;
   end;
{ Who knows, what is the way to force SelectDirectory to filter files by Ext?
 if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
    begin
        sesEditDir.Text := Dir;
        FillFileList;
    end;
}
end;

procedure TMainForm.OpenText;
var
FName:String;
  Handle: THandle;
  FindData: TWin32FindData;

begin
OpenedFilePanel.Caption := '';
If SelectedFile.Text = '' then Exit;
FName := sesEditDir.Text + '\'+SelectedFile.Text;

If FileExists(FName) then
   begin
   sesDataSet1.Close;
   sesDataSet1.OpenMode := omStructureData;
   sesDataSet1.FileName := FName;
   sesDataSet1.Open;
   OpenedFilePanel.Caption := FName;
   end
   else
   begin
   OpenedFilePanel.Caption := 'The file '+FName+' does not exist...';
   end;

end;

procedure TMainForm.OpenTextFileExecute(Sender: TObject);
begin
OpenText;
end;

procedure TMainForm.ExportToFile;
var
S,S1:String;
I:Integer;
F2:TsesFieldDef;
F1:TField;
V:Variant;
begin
If not Table1.Active then Exit;
ExportFieldFilterForm.Memo1.Clear;
Table1.GetFieldNames(ExportFieldFilterForm.Memo1.Lines);
If ExportFieldFilterForm.ShowModal = mrOK then
   begin
try
   Screen.Cursor := crHourGlass;
   Table1.DisableControls;
   sesDataSet1.DisableControls;
   With ExportFieldFilterForm.Memo1 do
      begin

      // locks the saving action
      sesDataSet1.FileName := '';
      sesDataSet1.Close;
      // forms the FieldFilter
      S := '';
      for I:=0 to Lines.Count-1 do
          begin
          If I = Lines.Count-1 then
             S :=S+ Lines[I]             else
             S := S + Lines[I] + ';';
          end;
       sesDataSet1.Import(S,Table1);
       sesDataSet1.Open;
       Table1.First;
                        While not Table1.Eof do
                        begin
                        sesDataSet1.Append;
                        for I:=0 to sesDataSet1.sesFields.Count-1 do
                            begin
                            S:= sesDataSet1.Fields[I].FieldName;
                            sesDataSet1.FieldByName(S).Value := Table1.FieldByName(S).Value;
                            end;
                        sesDataSet1.Post;
                        Table1.Next;
                        end;
      end; // with
finally
   Table1.First;
   Table1.EnableControls;
   sesDataSet1.First;
   sesDataSet1.EnableControls;
   I := Pos('.',Table1.TableName);
   S1 := Copy(Table1.TableName,1, I);
   S := sesEditDir.Text + '\' + S1 +ExtEdit.Text;
   sesDataSet1.SaveToFile(S,True);
   FillFileList;
   V := S1 +ExtEdit.Text;
   sesDataSet2.Locate('FileName', V, []);
   Screen.Cursor := crDefault;
end;

   end;
end;

procedure TMainForm.sesEditDirChange(Sender: TObject);
begin
FillFileList;
end;

procedure TMainForm.FillFileList;
var
  sr: TSearchRec;
  FileAttrs: Integer;
  Search:String;
begin
try
Screen.Cursor := crHourGlass;
If sesDataSet1.Active then
       begin
       sesDataSet1.Close;
       OpenedFilePanel.Caption := '';
       end;

If not sesDataSet2.Active then
                               sesDataSet2.Open;
   sesDataSet2.DisableControls;
   //look at a some way to empty the TsesDataSet:
   //1.begins at the first record
   sesDataSet2.First;
   //2. retries the deletion of the all records
   While not sesDataSet2.Eof do
             sesDataSet2.Delete;
   //the end of the empty process of the TsesDataSet

If sesEditDir.Text = '' then Exit; // nothing to fill

If not DirectoryExists(sesEditDir.Text) then Exit; // also nothing to fill

//considers only files with ExtEdit.Text extension
Search := sesEditDir.Text+'\'+'*.'+ExtEdit.Text;

//only "normal" files are retrieved, excluding system, readonly, etc.
FileAttrs := 0;

//FindFirst searches the all "*.ext" files in the given folder...
  if FindFirst(Search, FileAttrs, sr) = 0 then
  begin
  //the first occurence was found...
      sesDataSet2.Append;
      sesDataSet2.FieldByName('FileName').AsString := sr.Name;
      sesDataSet2.FieldByName('FileSize').AsInteger := sr.Size;
      sesDataSet2.FieldByName('Changed').AsString := DateTimeToStr(FileDateToDateTime(sr.Time));
      sesDataSet2.Post;
      //fills the file list the remaining files in the folder
      while FindNext(sr) = 0 do
      begin
        sesDataSet2.Append;
        sesDataSet2.FieldByName('FileName').AsString := sr.Name;
        sesDataSet2.FieldByName('FileSize').AsInteger := sr.Size;
        sesDataSet2.FieldByName('Changed').AsString := DateTimeToStr(FileDateToDateTime(sr.Time));
        sesDataSet2.Post;
      end;
      //releases the allocated by FindFirst resources...
      FindClose(sr);

  end;


finally
Screen.Cursor := crDefault;
sesDataSet2.EnableControls;
//invokes the first "AfterScrollEvent" handler to open the first listed file, if any...
sesDataSet2.First;
end;

end;

procedure TMainForm.SelectedFileChange(Sender: TObject);
begin
If AutoOpenFile.Checked then
OpenText;
end;

procedure TMainForm.sesDataSet2AfterScroll(DataSet: TDataSet);
begin
If (not sesDataSet2.Active) or (sesDataSet2.RecordCount = 0) then
   begin
   SelectedFile.Text := '';
   Exit;
   end;
If sesDataSet2.ControlsDisabled then
   begin
   SelectedFile.Text := '';
   Exit;
   end;

SelectedFile.Text := sesDataSet2.FieldByName('FileName').AsString;
end;

procedure TMainForm.ExportToTextFileExecute(Sender: TObject);
begin
ExportToFile;
end;

procedure TMainForm.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
ExportToTextFile.Enabled := (Table1.Active);
DeleteTextFile.Enabled := (SelectedFile.Text <> '');
SortTextFile.Enabled := (sesDataSet1.Active);
SeekValues.Enabled := (sesDataSet1.Active);
SaveTextAs.Enabled := (sesDataSet1.Active);
OpenTextFile.Enabled := (SelectedFile.Text <> '');
SeekAgainValues.Enabled := (sesDataSet1.Active) and(SearchRecord.Found);
Handled := True;
end;

procedure TMainForm.DeleteTextFileExecute(Sender: TObject);
var
S:String;
begin
If SelectedFile.Text = '' then Exit;
S:= sesEditDir.Text + '\'+SelectedFile.Text;
If FileExists(S) then
   begin
   DeleteFile(S);
   sesDataSet2.Delete;
   end;
end;

procedure TMainForm.SortTextFileExecute(Sender: TObject);
var
SortList:String;
begin
try

//fills the avaiable field list the the TsesDataSet, which contains the selected text files
SortForm.SetFieldsList(sesDataSet1);

If SortForm.ShowModal = mrOK then
   begin
   Screen.Cursor := crHourGlass;

   //retrieves the formed field list, which will take part in sorting...
   //the example of same list: 'CustNo;EmpNo;SaleDate'
   SortList := SortForm.GetSortList;

   If SortList <> '' then
     sesDataSet1.Sort(SortList,SortForm.rgAscending.ItemIndex=0,
     SortForm.CaseInSensitive.Checked, SortForm.StringSuffix.Checked);
   end;
finally
Screen.Cursor := crDefault;

end;
end;

procedure TMainForm.SeekValuesExecute(Sender: TObject);
var
Search,SearchFields:String;
I:Integer;
List:TStringList;
LocateOptions:TLocateOptions;
DataSet:TDataSet;
begin

SearchRecord.SearchFields := '';
   DataSet := sesDataSet1;
SeekForm.SetSearchSet(DataSet);
If SeekForm.ShowModal = mrOK then
   begin
   If not SeekForm.sesDataSet1.Modified then Exit;
   List:=TStringList.Create;
   SearchRecord.LocateOptions := [];
   If SeekForm.chbCase.Checked then
      SearchRecord.LocateOptions := SearchRecord.LocateOptions + [loCaseInSensitive];
   If SeekForm.chbPartialKey.Checked then
      SearchRecord.LocateOptions := SearchRecord.LocateOptions + [loPartialKey];

   SearchFields := '';
   SeekForm.sesDataSet1.First;
   While not SeekForm.sesDataSet1.Eof do
       begin
       Search := SeekForm.sesDataSet1.FieldByName('SearchValue').AsString;
       If Search <> '' then
          begin
          SearchFields := SearchFields +
                          SeekForm.sesDataSet1.FieldByName('FieldName').AsString +
                          ';';
          List.Add(Search);
          end;
       SeekForm.sesDataSet1.Next;
       end;
   If (SearchFields = '') or (List.Count = 0) then
      begin
      List.Free;
      Exit;
      end;
   I:= Length(SearchFields);
   If SearchFields[I] = ';' then
      SearchFields := Copy(SearchFields,1,I-1);
   SearchRecord.SearchFields := SearchFields;
   SearchRecord.SearchValues := List.Text;
   If SeekForm.rgStart.ItemIndex = 0 then
      SearchRecord.SeekOption := soFirst
      else
      SearchRecord.SeekOption := soCurrent;
   If SeekForm.rgDirection.ItemIndex = 0 then
      SearchRecord.goForward := True
      else
      SearchRecord.goForward := False;

   SeekRecord(DataSet);
   List.Free;
   end;

end;



procedure TMainForm.SeekAgainValuesExecute(Sender: TObject);
begin
   SearchRecord.SeekOption := soIgnoreCurrent;
   SeekRecord(sesDataSet1);
end;

procedure TMainForm.SaveTextAsExecute(Sender: TObject);
var
S:String;
V:Variant;
begin
If SelectedFile.Text = '' then Exit;
S:= sesEditDir.Text + '\'+SelectedFile.Text;
SaveDialog1.FileName := S;
If SaveDialog1.Execute then
   begin
   If not sesDataSet1.SaveToFile(SaveDialog1.FileName,True) then
      begin
      ShowMessage('Saving to file '+SaveDialog1.FileName+
      ' has failed...');
      Exit;
      end;
   If S <> SaveDialog1.FileName then
      begin
      FillFileList;
      V:= ExtractFileName(SaveDialog1.FileName);
      sesDataSet2.Locate('FileName',V,[]);
      end;
   end;
end;

procedure TMainForm.SortFileListExecute(Sender: TObject);
begin
sesDataSet2.Sort('FileName', True, True,False);
end;

end.
