unit SeekFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Buttons, ExtCtrls, Db, sesDataSetUnit, DBCtrls;

type
  TSeekForm = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    DBGrid1: TDBGrid;
    sesDataSet1: TsesDataSet;
    DataSource1: TDataSource;
    SpeedButton1: TSpeedButton;
    DBNavigator1: TDBNavigator;
    GroupBox1: TGroupBox;
    rgStart: TRadioGroup;
    rgDirection: TRadioGroup;
    GroupBox2: TGroupBox;
    chbCase: TCheckBox;
    chbPartialKey: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure sesDataSet1BeforeDelete(DataSet: TDataSet);
    procedure sesDataSet1AfterInsert(DataSet: TDataSet);
    procedure SpeedButton1Click(Sender: TObject);
    procedure sesDataSet1BeforeInsert(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    AllowEdit:Boolean;
    procedure SetSearchSet(const DataSet:TDataSet);
  end;

var
  SeekForm: TSeekForm;

implementation

{$R *.DFM}

procedure TSeekForm.SetSearchSet(const DataSet:TDataSet);
var
I:Integer;
begin
AllowEdit := True;
sesDataSet1.First;
While not sesDataSet1.Eof do
      sesDataSet1.Delete;
If not DataSet.Active then Exit;
for I:=0 to DataSet.FieldCount-1 do
    begin
    sesDataSet1.Append;
    sesDataSet1.FieldByName('SearchValue').AsString := '';
    sesDataSet1.FieldByName('FieldName').AsString := DataSet.Fields[I].FieldName;
    sesDataSet1.FieldByName('FieldCaption').AsString := DataSet.Fields[I].DisplayLabel;
    Case DataSet.Fields[I].DataType Of
    ftString:sesDataSet1.FieldByName('DataType').AsString := 'ftString';
    ftFmtMemo,ftMemo:sesDataSet1.FieldByName('DataType').AsString := 'ftMemo';
    ftInteger: sesDataSet1.FieldByName('DataType').AsString := 'ftInteger';
    ftWord:sesDataSet1.FieldByName('DataType').AsString := 'ftWord';
    ftDate:sesDataSet1.FieldByName('DataType').AsString := 'ftDate';
    ftTime:sesDataSet1.FieldByName('DataType').AsString := 'ftTime';
    ftDateTime:sesDataSet1.FieldByName('DataType').AsString := 'ftDateTime';
    ftAutoInc:sesDataSet1.FieldByName('DataType').AsString := 'ftAutoInc';
    ftCurrency:sesDataSet1.FieldByName('DataType').AsString := 'ftCurrency';
    else
    sesDataSet1.FieldByName('DataType').AsString := 'ftUnknown';

    end; // case
    sesDataSet1.Post;
    end;
sesDataSet1.First;
AllowEdit := False;
sesDataSet1.Modified := False;
end;
procedure TSeekForm.BitBtn1Click(Sender: TObject);
begin
If (sesDataSet1.State = dsEdit) or (sesDataSet1.State = dsInsert) then
   sesDataSet1.Post;
end;

procedure TSeekForm.SpeedButton2Click(Sender: TObject);
begin
If (sesDataSet1.State = dsEdit) or (sesDataSet1.State = dsInsert) then
   sesDataSet1.Post;

end;

procedure TSeekForm.sesDataSet1BeforeDelete(DataSet: TDataSet);
begin
If not AllowEdit then Abort;
end;

procedure TSeekForm.sesDataSet1AfterInsert(DataSet: TDataSet);
begin
If not AllowEdit then Abort;
end;

procedure TSeekForm.SpeedButton1Click(Sender: TObject);
begin
sesDataSet1.First;
While not sesDataSet1.Eof do
    begin
    sesDataSet1.Edit;
    sesDataSet1.FieldByName('SearchValue').AsString := '';
    sesDataSet1.Post;
    sesDataSet1.Next;
    end;
sesDataSet1.First;
end;

procedure TSeekForm.sesDataSet1BeforeInsert(DataSet: TDataSet);
begin
If not AllowEdit then Abort;
end;

end.
