unit MainUnit;
{ Copy right 2002 Sergei Khomutov.
The Safe Editing Style demonstration with using Borland BDE.

To use this sample you must have the installed Borland DBDEMOS database on your desktop.

This is the canonic sample of interaction between
TsesLogger(group of TsesEdits) and BDE database.
 Be free to use this sample in the your database applications.
}
{
       Data flow diagram.
       ------------------

       External data storage: DBDemos local database
       ^
       |  SQL statements
       V
       ViewDataQuery
            |
            V
      *******************
      *******************               The internal Data Memory Storage
      The records Viewer:                              |
      ReadOnly DBGrid1     On Update                   V
      ******************* <----------  The record fields Viewer&Editor
      ................... ---------->  ***   ****  ******* ******* ***
      *******************  On scroll   ***   The TsesLogger TsesEdis
                                       ***   group ******* ******* ***


 Conclusions.
 The first, the data flow has the only one fraught with danger interval during
 the really update process within a single dataset's record.
 The second, the main center of the data editing actions is placed on the
 TsesLogger TsesEdits group, where we must provide the highest possible efforts
 to prevent the entering of invalid data to the external database.
 The third, no penalties to use this sample for SQL remote databases. 
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, sesEditUnit, Grids, DBGrids, ExtCtrls, StdCtrls, Db, ComCtrls,
  Buttons, ActnList, DBActns, ImgList;

type
// defines the type of Memory Data State:
TMDS = (mdsBrowse, mdsEdit, mdsInsert, mdsAppend);


  TMainForm = class(TForm)
    Panel1: TPanel;
    gbEditBox: TGroupBox;
    Splitter1: TSplitter;
    GroupBox3: TGroupBox;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    eOrderNo: TsesEdit;
    sesLogger1: TsesLogger;
    eCustNo: TsesEdit;
    eSaleDate: TsesEdit;
    eShipDate: TsesEdit;
    eEmpNo: TsesEdit;
    eShipToContact: TsesEdit;
    eShipToAddr1: TsesEdit;
    eShipToAddr2: TsesEdit;
    eShipToCity: TsesEdit;
    eShipToState: TsesEdit;
    eShipToZip: TsesEdit;
    eShipToCountry: TsesEdit;
    eShipToPhone: TsesEdit;
    eShipVia: TsesEdit;
    ePO: TsesEdit;
    ePaymentMethod: TsesEdit;
    eItemsTotal: TsesEdit;
    eTaxRate: TsesEdit;
    eFreight: TsesEdit;
    eAmountPaid: TsesEdit;
    stEdits: TStatusBar;
    ActionList1: TActionList;
    eTerms: TsesEdit;
    Panel6: TPanel;
    chbAutoAdd: TCheckBox;
    Panel7: TPanel;
    chbShowHint: TCheckBox;
    Panel8: TPanel;
    stMain: TStatusBar;
    EditButton: TSpeedButton;
    CancelEdit: TAction;
    CancelButton: TSpeedButton;
    PostButton: TBitBtn;
    ButtonIcons: TImageList;
    AppendButton: TSpeedButton;
    InsertButton: TSpeedButton;
    DeleteButton: TSpeedButton;
    RefreshButton: TSpeedButton;
    PostAction: TAction;
    EditAction: TAction;
    AppendAction: TAction;
    InsertAction: TAction;
    DeleteAction: TAction;
    RefreshAction: TAction;
    DBGrid1: TDBGrid;
    procedure eOrderNoEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure eOrderNoExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ViewDatasetPostExecute(Sender: TObject);
    procedure ViewDatasetEditExecute(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure CancelEditExecute(Sender: TObject);
    procedure ViewDatasetAppendExecute(Sender: TObject);
    procedure ViewDatasetDeleteExecute(Sender: TObject);
    procedure ViewDatasetInsertExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ViewDatasetRefreshExecute(Sender: TObject);
  private
    { Private declarations }
  //shows hints
  procedure AppShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
  //cancels all edits mode
  procedure CancelEditProc;
  // closes and reopens the ViewDataset
  procedure ViewDatasetRefreshRecors;
  // shows the current Memory Data State
  procedure ShowMDS;
  // add a new record
  procedure ViewDatasetAddRecord(Append:Boolean);
  public
    { Public declarations }
  // retrives the data from the View DataSet and passes to TsesEdits
  procedure ViewDataQueryAfterScroll(DataSet: TDataSet);

  end;

var
  MainForm: TMainForm;
  // holds the current MDS
  mdsState:TMDS=mdsBrowse;
  Commit:Boolean; // the successful apply update Flag
  BDEErrorMessage:String ='';

implementation

uses DemosDataModuleUnit;

{$R *.DFM}

procedure TMainForm.ShowMDS;
begin
Case mdsState Of
mdsBrowse: stMain.Panels[1].Text := 'Browse';
mdsEdit : stMain.Panels[1].Text := 'Edit';
mdsInsert : stMain.Panels[1].Text := 'Insert';
mdsAppend : stMain.Panels[1].Text := 'Append';
end; // Case of MDS
end;

procedure TMainForm.eOrderNoEnter(Sender: TObject);
begin
// provide the user an additional information from Edit.PickList, if any,
// by means Edit.GetPickListCaption method...
If TsesEdit(Sender).PickListKind <> plNone then
   stEdits.SimpleText := TsesEdit(Sender).GetPickListCaption(True)
   else
   stEdits.SimpleText := 'We can add nothing to a Display label...';
TsesEdit(Sender).sesFrame.BevelOuter := bvLowered;

end;

procedure TMainForm.AppShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
begin
CanShow := chbShowHint.Checked;
stMain.Panels[2].Text := HintStr;
end;
procedure TMainForm.FormCreate(Sender: TObject);
begin
Application.OnShowHint := AppShowHint;

With DemosDataModule do
begin
//be sure to activate the PickDataSet first of all

// "live" PickDataset:
CustNoQuery.Open;
EmpNoQuery.Open;

// the main master query for the ViewDataset table
ViewDataQuery.Open;
//sets the database options to use transaction method:
if not(ViewDataQuery.Database.IsSQLBased) and
   not (ViewDataQuery.Database.TransIsolation = tiDirtyRead) then
       ViewDataQuery.Database.TransIsolation := tiDirtyRead; // only for local databases...
//links the scroll event of the ViewDataQuery to procedure ViewDataQueryAfterScroll
ViewDataQuery.AfterScroll := ViewDataQueryAfterScroll;
//shows the first record
ViewDataQuery.First;

end; // with

end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
With DemosDataModule do
begin
ViewDataQuery.Close;
CustNoQuery.Close;
EmpNoQuery.Close;
end;
end;

procedure TMainForm.eOrderNoExit(Sender: TObject);
begin
//
stEdits.SimpleText := '';
TsesEdit(Sender).sesFrame.BevelOuter := bvRaised;
end;

procedure TMainForm.ViewDataQueryAfterScroll(DataSet: TDataSet);
var
I:Integer;
S:String;
Field:TField;
begin
With DemosDataModule do
                        begin

 // fills the TsesEdit group the actual data from the ViewDataset table
// As the all fields of the ViewDataset table have the corresponding TsesEdit,
// we can decide this task by very simple way:

//1. prevents this operation, if program process of the ViewDataset executes:
If ViewDataQuery.ControlsDisabled then Exit;

//2. prevents to refill the TsesEdits during scrolling just after Insert or Append
If ViewDataQuery.State = dsInsert then Exit;

//3. assigns the all TsesEdits the fields's values
for I:=0 to sesLogger1.EditsCount - 1 do
    begin
    //2.1. all TsesEdit have a name, that is the same, as a corresponding field,
    // excluding the prefix "e"
    S:= Copy(sesLogger1.Edits[I].Name,2,25); // it is the right field name
    //2.2. find out this field in the ViewDataset
    Field := ViewDataQuery.FindField(S);
    If Field = nil then continue; // ignores the invalid field name due to our mistake, may be
    //2.3. assigns the Field.Value the corresponding TsesEdit:
    sesLogger1.Edits[I].Value := Field.Value;
    //2.4. sets the flag Modified to False to prevent unuseful post operation
    sesLogger1.Edits[I].Modified := False;
    end;

//4. in every case, try to check up the all assigned values:
sesLogger1.Complete;


//5. shows the current cursor position and records number
stMain.Panels[0].Text := IntToStr(ViewDataQuery.RecNo) + ':' + IntToStr(ViewDataQuery.RecordCount);

                        end; // With DemosDataModule do
    // that's all!

end;

procedure TMainForm.FormShow(Sender: TObject);
begin
DBGrid1.SetFocus;
ShowMDS;
end;

procedure TMainForm.ViewDatasetPostExecute(Sender: TObject);
var
PostNeeded:Boolean;
I:Integer;
Field:TField;
E:TsesEdit;
begin
//1. checks up is there uncompleted edit

If not sesLogger1.Complete then
   begin
   // there are some Edits with uncompleted edit, so, we can not post edits to ViewDataset
   // informs the user and exists
   Application.MessageBox(PChar('The edition is not completed!'+#13+#10+
   'Retry edit or click CancelEdit...'), PChar(Caption),MB_ICONSTOP);
   //gets the first uncompleted TsesEdit in the the sesLogger1 linked TsesEdits
   E := sesLogger1.IsEditCompleted;
   sesLogger1.PassFocusTo(E);
   Exit;
   end;


//2.Post may be not needed
PostNeeded := False;

With DemosDataModule do
                        begin

//*** take into consideration, that no practically danger links with
// whether Edit or Append or Insert operation due to the assigned to True
// CachedUpdates property of the ViewDataQuery, because BDE does not send
// any requests to the Database.

//3. parses the edit operations
Case mdsState Of
mdsEdit:   //3.1. sets the ViewDataset to Edit mode
           ViewDataQuery.Edit;
mdsAppend: //3.1. sets the ViewDataset to Insert mode and appends a new record
           ViewDataQuery.Append;
mdsInsert: //3.1. sets the ViewDataset to Insert mode and inserts a new record
           ViewDataQuery.Insert;
end; // case mdsState

 //3.2. loop for all TsesEdits to save the changes to the ViewDataset fields
 for I:=0 to sesLogger1.EditsCount -1 do
     begin
     //3.2.1. Post is not needed, if all Edits is not modified
     If sesLogger1.Edits[I].Modified then
        begin
        //3.2.2. fires the Flag
        PostNeeded := True;
        //3.2.3. write a new value of the TSesEdit to the ViewDataset Field
        Field := ViewDataQuery.FindField(Copy(sesLogger1.Edits[I].Name,2,25));
        If Field <> nil then // tests in every case!
           Field.Value := sesLogger1.Edits[I].Value;
        end;
     end;


If PostNeeded then
begin

//4. at last, try to post the changes to the database table
//4.1. Start transaction is mandatory!
//So, we have to retrieve the Max value for the OrderNo field,
If (mdsState <> mdsEdit) then
begin
// the MaxOrderNoQuery calculates the Max value of the OrderNo field from the ViewDataset
//opens the MaxOrderNoQuery to get the actual data
MaxOrderNoQuery.Open;
I:=MaxOrderNoQuery.Fields[0].AsInteger + 1;
// and carries this value to the OrderNo field,
ViewDataQuery.FieldByName('OrderNo').AsInteger := I;
// and assign this one to the eOrderNo TsesEdit:
eOrderNo.Text := IntToStr(I);
// closes the MaxOrderNoQuery
MaxOrderNoQuery.Close;
end;

//************** The fraught with danger contact with BDE database. BEGIN.
// This is the really dangerous phase of the data editing.
// What may we lose? Only the entered by the user data WITHIN RECORD's CONTEXT may be lost,
// but no danger exists to corrupt the Database data...

//4.2. starts the database non-named transaction to have the possibility
// to roll back the invalid changes from the database
ViewDataQuery.Database.StartTransaction;

//4.3. sets the Flag successful Commit to True to hope the success
Commit := True;
    try
    // in this case the "try" is not prevent the BDE error message,
    // if exception will raise, so, the user will see a possible
    // BDE error message. Consider to use the localized version of BDE!
    ViewDataQuery.ApplyUpdates; //4.4. try to write the updates to the database;
    except
    Commit := False; //4.5. resets the Commit Flag to False due to a database error
    ViewDataQuery.Database.Rollback; //4.6. rolls back any writes to the database
    end;
    If Commit then
       begin
       ViewDataQuery.Database.Commit; //4.7. on success, commit the changes;
       ViewDataQuery.CommitUpdates;  //4.8. clears Cache buffer
       end
       else
       begin
       ViewDataQuery.Cancel; //4.9. cancels an any edit mode
       ViewDataQuery.CancelUpdates; //4.10. clears Cache buffer and restores the prior state of the Dataset
       eCustNo.SetFocus; //4.11. sets focus on the first TsesEdit,
       //so, the user must deside for whether to cancel or not the edit process...
       Exit;
       end;
//************** The fraught with danger contact with BDE database. END.

end // PostNeeded
else
begin
//5. no changes has been made, so, Cancel Edit or Insert mode
ViewDataQuery.Cancel; //5.1. cancels an any edit mode
CancelEditProc; //5.2. adjusts controls
Exit;
end;
                        end; // With DemosDataModule do

//6. consider the ability to organize a "batch" Insert/Append operation
If (not chbAutoAdd.Checked) or (mdsState = mdsEdit) then
   begin
   //6. restores the mdsState to mdsBrowse mode
   mdsState := mdsBrowse;
   //7. returns focus to the ViewDataset Viewer
   DBGrid1.Enabled := True;
   DBGrid1.SetFocus;
   //8. repaints DBGid1
   DBGrid1.Repaint;
   end
   else
   begin
   // 9. continues the Appending or Inserting new records
   ViewDatasetAddRecord(mdsState = mdsAppend);
   end;
end;


procedure TMainForm.ViewDatasetEditExecute(Sender: TObject);
var
Field:TField;
Edit:TsesEdit;
begin
//1. try to set focus on the selected on the DBGrid1 field
If DBGrid1.Focused then
begin
        Field := DBGrid1.SelectedField;

        If (DBGrid1.Focused) and (Field <> nil) then
           begin
           Edit := sesLogger1.EditByName('e'+Field.FieldName);
           If Edit <> nil then
           //prevets focus setting on the eOrderNo edit, read only
           If Edit.Name <> 'eOrderNo' then
              Edit.SetFocus
              else
              eCustNo.SetFocus;

           end
           else
           // sets focus on the first Edit
           eCustNo.SetFocus;
end;

//2. prevents the user's casual action to change the current cursor position
DBGrid1.Enabled := False;

//3. sets the Edit state of the Memory Data State:
mdsState := mdsEdit;
end;

procedure TMainForm.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
//shows the current MDS
ShowMDS;
//determines whether ViewDatasetEdit action is enabled or disable
EditAction.Enabled := (mdsState = mdsBrowse);
//determines whether CancelEdit action is enabled or disable
CancelEdit.Enabled := (mdsState <> mdsBrowse);
//determines whether ViewDatasetPost action is enabled or disable
PostAction.Enabled := (mdsState <> mdsBrowse);
//determines whether ViewDatasetAppend action is enabled or disable
AppendAction.Enabled := (mdsState = mdsBrowse);
//determines whether ViewDatasetInsert action is enabled or disable
InsertAction.Enabled := (mdsState = mdsBrowse);
//determines whether ViewDatasetDelete action is enabled or disable
DeleteAction.Enabled := (mdsState = mdsBrowse);

//determines whether ViewDatasetRefresh action is enabled or disable
RefreshAction.Enabled := (mdsState = mdsBrowse);

Handled := True;
end;

procedure TMainForm.CancelEditProc;
begin


//1. restores the all TsesEdits values from the current record of the ViewDataset
With DemosDataModule do
ViewDataQueryAfterScroll(ViewDataQuery);

//2. restore the DBGrid1.Enables fo user's actions
DBGrid1.Enabled := True;

//3. sets the MDS to mdsBrowse;
mdsState := mdsBrowse;

//4. takes the focus from the focused TSesEdit regardless its data validity and
// passes it to the DBGrid
sesLogger1.PassFocusTo(DBGrid1);

//5. repaints DBGid1
DBGrid1.Repaint;
end;

procedure TMainForm.CancelEditExecute(Sender: TObject);
begin
CancelEditProc;
end;

procedure TMainForm.ViewDatasetAppendExecute(Sender: TObject);
begin
ViewDatasetAddRecord(True);
end;

procedure TMainForm.ViewDatasetAddRecord(Append:Boolean);
begin
//1. sets focus on the first Edit always
eCustNo.SetFocus;

//2. sets the current cursor at the last record, if Append
If Append then
   With DemosDataModule do
        ViewDataQuery.Last;

//3. prevents the user's casual action to change the current cursor position
DBGrid1.Enabled := False;

//4. resets the all TsesEdits to its InitState
sesLogger1.InitEdits;

//5. sets the Append or Insert state of the Memory Data State:
If Append then
   mdsState := mdsAppend
   else
   mdsState := mdsInsert;

end;

procedure TMainForm.ViewDatasetDeleteExecute(Sender: TObject);
var
Commit:Boolean;
begin
With DemosDataModule do
                        begin

ViewDataQuery.Database.StartTransaction;
Commit := True;
    try
    ViewDataQuery.Delete;
    ViewDataQuery.ApplyUpdates; {4.2. try to write the updates to the database};
    ViewDataQuery.Database.Commit; {4.3. on success, commit the changes};
    except
    ViewDataQuery.Database.Rollback; {4.4. on failure, undo the changes};
    Commit := False;
    end;
  If Commit then
  ViewDataQuery.CommitUpdates {4.5. on success, clear the cache}
  else
  begin
  //4.6. I do not know, what do we tell the user?
  Application.MessageBox(PChar('The attempt to delete the selected record failed...'+#13+#10+
   'Retry delete to try again...'), PChar(Caption),MB_ICONSTOP);
  //but, what can you add?
  Exit;
  end;

                        end; // With DemosDataModule do

end;

procedure TMainForm.ViewDatasetInsertExecute(Sender: TObject);
begin
ViewDatasetAddRecord(False);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
If mdsState <> mdsBrowse then
   If Application.MessageBox(PChar('The your edition is not completed!'+#13+#10+
   'Do you want to return to the Edit box?'),
      PChar(Caption),MB_ICONQUESTION+MB_OKCANCEL) = IDOK then
      CanClose := False;
//you may pay attention, we do not need to test the ViewDataset for
// any pending changes, because this one is on the dsBrowse state almost always!
// What does the user cancel or post in this case? The data in the TsesEdits group
// memory storage only may be lost or posted... See the query to the user above...
end;

procedure TMainForm.ViewDatasetRefreshExecute(Sender: TObject);
begin
ViewDatasetRefreshRecors;
end;

procedure TMainForm.ViewDatasetRefreshRecors;
begin
With DemosDataModule do
                        begin
     ViewDataQuery.Close;
     ViewDataQuery.Open;
     ViewDataQuery.First;
                        end;
end;

end.
