unit DataStringsDialogUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesDataSetUnit,StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, Db, ComCtrls,
  sesSystem,sesEditUnit, ActnList, DBActns, ImgList;

type

TStruStatus  = record
 Empty:Boolean;
 Count:Integer;
 Restructured:Boolean;
 RecNo:Integer;
 dsState:Integer; // 0 - browse; 1 - Edit; 2 - Append; 3 - Insert
 end;

  TDataStringsDialog = class(TForm)
    Panel1: TPanel;
    SaveButton: TBitBtn;
    CancelButton: TBitBtn;
    GroupBox2: TGroupBox;
    DataSource1: TDataSource;
    Splitter1: TSplitter;
    ActionList1: TActionList;
    stBar: TStatusBar;
    Panel2: TPanel;
    ButtonIcons: TImageList;
    EditAction: TAction;
    InsertAction: TAction;
    AppendAction: TAction;
    PostAction: TAction;
    CancelEditAction: TAction;
    EditButton: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    CheckBox1: TCheckBox;
    SpeedButton6: TSpeedButton;
    sesDataSet1: TsesDataSet;
    PostButton: TBitBtn;
    DBGrid1: TDBGrid;
    DeleteAction: TAction;
    GroupBox1: TGroupBox;
    Memo: TMemo;
    AutoAdd: TCheckBox;
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sesDataSet1AfterScroll(DataSet: TDataSet);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure AppendActionExecute(Sender: TObject);
    procedure PostActionExecute(Sender: TObject);
    procedure EditActionExecute(Sender: TObject);
    procedure InsertActionExecute(Sender: TObject);
    procedure CancelEditActionExecute(Sender: TObject);
    procedure DeleteActionExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);

  private
    { Private declarations }
    procedure AddRecord(Append:Boolean);
    procedure OutInfo;
  public
    { Public declarations }
    sesDataSet:TsesDataSet;
    Structure:String;
    EnterStatus,Status:TStruStatus;
    function MemoToDataSet:Boolean;
  end;

var
  DataStringsDialog: TDataStringsDialog=nil;

implementation

{$R *.DFM}

procedure TDataStringsDialog.FormHide(Sender: TObject);
begin
sesDataSet1.Close;
end;


procedure TDataStringsDialog.FormShow(Sender: TObject);
begin
//MemoToDataSet;
DBGrid1.SetFocus;
end;


procedure TDataStringsDialog.OutInfo;
var
Field:TField;
begin
With stBar do
  begin
  Panels[0].Text :=IntToStr(sesDataSet1.RecNo) + ':'+
                   IntToStr(sesDataSet1.RecordCount);
  Field:=DBGrid1.SelectedField;
  If Field = nil then
     begin
     Panels[2].Text:= 'Field is not selected...';
     Exit;
     end;
  With Field do
  begin
  If FieldName='fOrder' then
     begin
     Panels[2].Text:= 'The field order in the structure(not editable)...';
     end
     else
  If FieldName='fName' then
     begin
     Panels[2].Text:= 'Name of the field: up 25 alphanumeric symbols, the first must be alpha...';
     end
     else
  If FieldName='fType' then
     begin
     Panels[2].Text:= 'DataType of the field: pick up from the possible values list...';
     end
     else
  If FieldName='fLabel' then
     begin
     Panels[2].Text:= 'Display label for data-aware controls.';
     end
     else
  If FieldName='fWidth' then
     begin
     Panels[2].Text:= 'Controls the field display width, given and calculated by characters...';
     end
     else
  If FieldName='fSize' then
     begin
     Panels[2].Text:= 'Data size for String type only(bytes)...';
     end
     else
  If FieldName='fRequired' then
     begin
     Panels[2].Text:= 'The field is required: 0 or 1 must be used(pick up from list)...';
     end
     else
  If FieldName='fAlignment' then
     begin
     Panels[2].Text:= 'The text alignment of the field for data-aware controls(pick up from list)...';
     end;
  end; // with Field
  If Status.Restructured then
     Panels[1].Text := 'Modified'
     else
     Panels[1].Text := '';
  end; // with stBar
end;
procedure TDataStringsDialog.sesDataSet1AfterScroll(DataSet: TDataSet);
begin
If sesDataSet1.Active then
OutInfo;

end;

procedure TDataStringsDialog.DBGrid1ColEnter(Sender: TObject);
begin
OutInfo;
end;

function TDataStringsDialog.MemoToDataSet:Boolean;
var
I:Integer;
begin
Result := False;
If sesDataSet1.Active then
        sesDataSet1.Close;
sesDataSet1.ClearData;
sesDataSet1.ClearStructure;

If not sesDataSet1.StringToStructure(Structure) then
   begin
   Application.MessageBox('Invalid dataset structure.It is impossible to continue...','DataStrings',MB_ICONSTOP);
   Exit;
   end;

If Memo.Lines.Count = 0 then
   begin
   sesDataSet1.Open;
   EnterStatus.Empty := True;
   EnterStatus.Count := 0;
   EnterStatus.Restructured := False;
   EnterStatus.dsState := 0;
   Status := EnterStatus;
   Result := True;
   Exit;
   end;

for I:=0 to Memo.Lines.Count-1 do
    sesDataSet1.DataStrings.Add(Memo.Lines[I]);

try
sesDataSet1.Open;
except
If Application.MessageBox(PChar('Data is not corresponded the structure.'+#13+#10+
'Clear all data?'),
'DataStrings',MB_ICONWARNING+MB_OKCANCEL + MB_DEFBUTTON2) = IDOK then
    begin
    If sesDataSet1.Active then
       sesDataSet1.Close;
    sesDataSet1.ClearData;
    sesDataSet1.Open;
    Result := True;
    Exit;
    end;


Result := False;
Exit;
end;

   sesDataSet1.First;
   EnterStatus.Empty := False;
   EnterStatus.Count := sesDataSet1.RecordCount;
   EnterStatus.Restructured := False;
   EnterStatus.dsState := 0;
   Status := EnterStatus;
OutInfo;
Result := True;
end;

procedure TDataStringsDialog.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
SaveButton.Enabled := sesDataSet1.Modified;
If sesDataSet1.Modified then
   stBar.Panels[1].Text := 'Modified'
   else
   stBar.Panels[1].Text := '';

    EditAction.Enabled := (Status.dsState = 0);
    AppendAction.Enabled := (Status.dsState = 0);
    InsertAction.Enabled := (Status.dsState = 0);
    CancelEditAction.Enabled := not  (Status.dsState = 0);
    PostAction.Enabled := (sesDataSet1.State = dsEdit) or (sesDataSet1.State = dsInsert);
    DeleteAction.Enabled := (Status.dsState = 0) and (sesDataSet1.RecordCount > 0);

Handled := True;
end;


procedure TDataStringsDialog.CheckBox1Click(Sender: TObject);
begin
Self.ShowHint := CheckBox1.Checked;
end;

procedure TDataStringsDialog.AppendActionExecute(Sender: TObject);
begin
AddRecord(True);
end;

procedure TDataStringsDialog.PostActionExecute(Sender: TObject);
begin
   If sesDataSet1.State <> dsBrowse then
      sesDataSet1.Post;
   Status.Empty := False;
   Status.Count := sesDataSet.RecordCount;
   Status.Restructured := True;
   Case Status.dsState Of
   1: Status.dsState := 0;
   2: AddRecord(False);
   3: AddRecord(True);
   end; // Case Status.dsState Of

end;
procedure TDataStringsDialog.EditActionExecute(Sender: TObject);
begin
//1. sets the status flag of edit mode
Status.dsState := 1;

//2. stores the current cursor dataset position
Status.RecNo := sesDataset1.RecNo;

//3. tests the current dataset state and resets it into dsBrowse, if any...
If((sesDataSet1.State = dsEdit) or(sesDataSet1.State = dsInsert)) then
  sesDataSet1.Cancel;

//4. sets the dataset the Edit mode
sesDataSet1.Edit;
end;

procedure TDataStringsDialog.InsertActionExecute(Sender: TObject);
begin
AddRecord(False);
end;

procedure TDataStringsDialog.AddRecord(Append:Boolean);
begin
//1. sets the status flag of edit mode
If Append then
Status.dsState := 3
else
Status.dsState := 2;

//2. stores the current cursor dataset position
If not Append then
Status.RecNo := sesDataset1.RecNo;

//3. tests the current dataset state and resets it into dsBrowse, if any...
If((sesDataSet1.State = dsEdit) or(sesDataSet1.State = dsInsert)) then
  sesDataSet1.Cancel;

//4. adds a new record into the dataset
If Append then
sesDataSet1.Append
else
sesDataSet1.Insert;


//5. sets focus on the first editors by order...
DBGrid1.SelectedIndex := 0;

end;

procedure TDataStringsDialog.CancelEditActionExecute(Sender: TObject);
begin
sesDataSet1.Cancel;
Status.dsState := 0;
DBGrid1.SetFocus;
end;

procedure TDataStringsDialog.DeleteActionExecute(Sender: TObject);

begin
sesDataSet1.Delete;
DBGrid1.SetFocus;
end;

procedure TDataStringsDialog.FormDestroy(Sender: TObject);
begin
If sesDataSet1.Active then sesDataSet1.Close;
Memo.Lines.Clear;
end;

procedure TDataStringsDialog.SaveButtonClick(Sender: TObject);
var
I:Integer;
S:String;
begin
Memo.Lines.Clear;
sesDataSet1.First;
While not sesDataSet1.Eof do
  begin
  S:='';
  for I:=0 to sesDataSet1.FieldCount - 1 do
      begin
      If I = sesDataSet1.FieldCount - 1 then
         S := S + sesDataSet1.Fields[I].AsString
         else
         S := S + sesDataSet1.Fields[I].AsString + sesFieldSeparator;
      end;
  Memo.Lines.Add(S);
  sesDataSet1.Next;
  end;
ModalResult := mrOK;
end;

end.

