unit SoundPlayUnit;

interface

uses
  FileCtrl,MMSystem,Windows,Classes,sesSystem,MPlayer,sYSuTILS,IniFiles;

const
SPVersion='SP 1.0 ';
type
  TSoundPlay = class(TThread)
  private
    { Private declarations }
// Unit MPPlayer

  MCIOpened: Boolean; //    MCI device
  FElementName: string;//   - ()
    FCapabilities: TMPDevCapsSet;
    FCanPlay: Boolean;
    FCanStep: Boolean;
    FCanEject: Boolean;
    FCanRecord: Boolean;
    FHasVideo: Boolean;
    FFlags: Longint;
    FWait: Boolean; //  
    FNotify: Boolean;
    FUseWait: Boolean;
    FUseNotify: Boolean;
    FUseFrom: Boolean;
    FUseTo: Boolean;
    FDeviceID: Word;
    FDeviceType: TMPDeviceTypes;
    FTo: Longint;
    FFrom: Longint;
    FError: Longint;
//*     Unit MPPlayer

  protected
    procedure Execute; override;
    procedure PlaySound;
    procedure SPOpen;
    procedure SPClose;
    procedure SPGetDeviceCaps;
    procedure SPPlay;
  public
  end;

var
  PlayList:TFastList; //   
  MPActive:Boolean; //     
  MPStep:Integer; //     
  Player:TMediaPlayer; //  
  MessageToPlay:String; //   
  IniFile:TMemIniFile; //  
  IniFileName:String; //  -   Windows
  al,al1:TFastList; //  
  WavesDir:String; //    
  IniSection:String; // -   
  StartPlay:Boolean; //     
  SubProc:TSoundPlay; //      
  PlayType:SmallInt; //      :
  {
  0 - ;
  1 - ;
  2 -     StringToPlay.
  }
  StringToPlay:String; //    wav    "@"

  SPError:SmallInt; //     
{
0 -  
1 -   SoundMessages.ini   Windows
2 -    -()
3 -  - Sounds
4 -  - Warnings
5 -  - Alarms
6 -  WavesDir  
7 -   ()
}
   PlayContinuously:Boolean; //      PlayList
   //  
   SoundPlayer_D:Double;
   SoundPlayer_I:Integer;
   SoundPlayer_S,SoundPlayer_S1,SoundPlayer_S2,SoundPlayer_S3:String;
   //*  

//   
// .     
procedure  PlaySoundMessage(aPlayContinuously:Boolean);


// .  
procedure SoundPlayerOpen;
// .     
procedure DestroySoundPlayer;
//.     
procedure ResetSoundPlay;
//*   


implementation


//   
// .     
procedure  PlaySoundMessage(aPlayContinuously:Boolean);
begin
If MPActive=False then Exit;
If SubProc <> nil then
   ResetSoundPlay;

PlayContinuously := aPlayContinuously;
try
   SubProc:=TSoundPlay.Create(True);
   SubProc.FreeOnTerminate:=False;
   SubProc.Priority:= tpLowest;	//tpIdle;
   SubProc.Resume;
except
Exit;
end;
end;


//  
procedure SoundPlayerOpen;
begin
MPActive:=False;
// Initialize Variable
SPError:=0;
try
al:=TFastList.Create;
al1:=TFastList.Create;
PlayList:=TFastList.Create;
   except
   SPError:=7;
   Exit;
   end;

MPActive:=True;
MPStep:=0;
SubProc:=nil;
end;

//     
procedure DestroySoundPlayer;
begin
If MPActive=False then Exit;
ResetSoundPlay;
MPActive:=False;
StartPlay:=False;
al.Free;
al1.Free;
PlayList.Free;
end;

//.     
procedure ResetSoundPlay;
begin
If SubProc <> nil then
   begin
   SubProc.Terminate;
   SubProc.WaitFor;
//   SubProc.Free;
   SubProc:=nil;
   end;
end;

//*   


//   TSoundPlay   
{ TSoundPlay }


//.   .
procedure TSoundPlay.Execute;
begin
//      PlayList 
// wav   
If PlayList.Count = 0 then
   StartPlay:= False
   else
   StartPlay := True;

//     -     
If StartPlay = False then
   begin
   While (not Terminated) do
        begin
        //   -  ... ???
        Sleep(1000);
        end;
   end;
//      -  
//While (not Terminated) And (PlayContinuously = True) do
//   begin
Repeat
    While (not Terminated) And(MPStep <= PlayList.Count-1) do
      begin
//      Synchronize(PlaySound); -    !!!
//      PlaySound;
//        :
//     - : Open?!
      FElementName := PlayList[MPStep]; //  wav 
      SPOpen; //  MCI      

//   FWait   MS  ,  ...
      FWait:=True;
      SPPlay; //  
      FWait:=False;

      MPStep:=MPStep+1;
      end;
   MPStep:=0;
//   end; // While not Terminated

Until (Terminated = True) Or (PlayContinuously = False);
  If MCIOpened = True then SPClose;
//  If not Terminated then Terminated := True;
end;

//.    wav 
procedure TSoundPlay.PlaySound;
begin
//     - : Open?!
      FElementName := PlayList[MPStep]; //  wav 
      SPOpen; //  MCI      

//   FWait   MS  ,  ...
      FWait:=True;
      SPPlay; //  
      FWait:=False;
end;


// Unit MPPlayer: Open;
procedure TSoundPlay.SPOpen;
const
  DeviceName: array[TMPDeviceTypes] of PChar = ('', 'AVIVideo', 'CDAudio', 'DAT',
    'DigitalVideo', 'MMMovie', 'Other', 'Overlay', 'Scanner', 'Sequencer',
    'VCR', 'Videodisc', 'WaveAudio');
var
  OpenParm: TMCI_Open_Parms;
begin
  FDeviceType:=dtWaveAudio;
  FUseWait:=True;
  { zero out memory }
  FillChar(OpenParm, SizeOf(TMCI_Open_Parms), 0);
  if MCIOpened then SPClose; {must close MCI Device first before opening another}

  OpenParm.dwCallback := 0;
  OpenParm.lpstrDeviceType := DeviceName[FDeviceType];//DeviceName[FDeviceType];
  OpenParm.lpstrElementName := PChar(FElementName);

  FFlags := 0;
  {
  if FUseWait then
  begin
    if FWait then FFlags := mci_Wait;
    FUseWait := False;
  end
  else
  }
    FFlags := mci_Wait;
   FUseNotify := False;
  {
  if FUseNotify then
  begin
    if FNotify then FFlags := FFlags or mci_Notify;
    FUseNotify := False;
  end;
  }
  if FDeviceType <> dtAutoSelect then
  begin
    if FElementName <> '' then
      FFlags := FFlags or MCI_OPEN_ELEMENT;
    FFlags := FFlags or mci_Open_Type;
  end
  else
    FFlags := FFlags or MCI_OPEN_ELEMENT;
  {
  if FShareable then
    FFlags := FFlags or mci_Open_Shareable;
  }
  OpenParm.dwCallback := Handle;

  FError := mciSendCommand(0, mci_Open, FFlags, Longint(@OpenParm));

  if FError <> 0 then Exit;

    MCIOpened := True;
    FDeviceID := OpenParm.wDeviceID;
    SPGetDeviceCaps;
end;

// Unit MPPlayer: Close;
procedure TSoundPlay.SPClose;
var
  GenParm: TMCI_Generic_Parms;
begin
  if FDeviceID <> 0 then
  begin
    FFlags := 0;
    if FUseWait then
    begin
      if FWait then FFlags := mci_Wait;
      FUseWait := False;
    end
    else FFlags := mci_Wait;
    if FUseNotify then
    begin
      if FNotify then FFlags := FFlags or mci_Notify;
      FUseNotify := False;
    end;
    GenParm.dwCallback := Handle;
    FError := mciSendCommand( FDeviceID, mci_Close, FFlags, Longint(@GenParm));
    if FError = 0 then
    begin
      MCIOpened := False;
      FDeviceID := 0;
    end;
  end; {if DeviceID <> 0}
end;


{ fills in static properties upon opening MCI Device }
// Unit MPPlayer: GetDeviceCaps;
procedure TSoundPlay.SPGetDeviceCaps;
var
  DevCapParm: TMCI_GetDevCaps_Parms;
  devType: Longint;
  RectParms: TMCI_Anim_Rect_Parms;
begin
  FFlags := mci_Wait or mci_GetDevCaps_Item;

  DevCapParm.dwItem := mci_GetDevCaps_Can_Play;
  mciSendCommand(FDeviceID, mci_GetDevCaps, FFlags,  Longint(@DevCapParm) );
  FCanPlay := Boolean(DevCapParm.dwReturn);
  if FCanPlay then Include(FCapabilities, mpCanPlay);

  DevCapParm.dwItem := mci_GetDevCaps_Can_Record;
  mciSendCommand(FDeviceID, mci_GetDevCaps, FFlags,  Longint(@DevCapParm) );
  FCanRecord := Boolean(DevCapParm.dwReturn);
  if FCanRecord then Include(FCapabilities, mpCanRecord);

  DevCapParm.dwItem := mci_GetDevCaps_Can_Eject;
  mciSendCommand(FDeviceID, mci_GetDevCaps, FFlags,  Longint(@DevCapParm) );
  FCanEject := Boolean(DevCapParm.dwReturn);
  if FCanEject then Include(FCapabilities, mpCanEject);

  DevCapParm.dwItem := mci_GetDevCaps_Has_Video;
  mciSendCommand(FDeviceID, mci_GetDevCaps, FFlags,  Longint(@DevCapParm) );
  FHasVideo := Boolean(DevCapParm.dwReturn);
  if FHasVideo then Include(FCapabilities, mpUsesWindow);

  DevCapParm.dwItem := mci_GetDevCaps_Device_Type;
  mciSendCommand(FDeviceID, mci_GetDevCaps, FFlags,  Longint(@DevCapParm) );
  devType := DevCapParm.dwReturn;
  if (devType = mci_DevType_Animation) or
     (devType = mci_DevType_Digital_Video) or
     (devType = mci_DevType_Overlay) or
     (devType = mci_DevType_VCR) then FCanStep := True;
  if FCanStep then Include(FCapabilities, mpCanStep);

  FFlags := mci_Anim_Where_Source;
  FError := mciSendCommand( FDeviceID, mci_Where, FFlags, Longint(@RectParms) );
//  WorkR := RectParms.rc;
//  FDWidth := WorkR.Right - WorkR.Left;
//  FDHeight := WorkR.Bottom - WorkR.Top;
end; {GetDeviceCaps}

// Unit MPPlayer: Play;
procedure TSoundPlay.SPPlay;
var
  PlayParm: TMCI_Play_Parms;
begin
//  CheckIfOpen; {raises exception if device is not open}
  If MCIOpened = False then Exit;

  {if at the end of media, and not using StartPos or EndPos - go to start}
{
  if FAutoRewind and (Position = Length) then
    if not FUseFrom and not FUseTo then Rewind;
 }
  FFlags := 0;
  {
  if FUseNotify then
  begin
    if FNotify then FFlags := mci_Notify;
    FUseNotify := False;
  end else FFlags := mci_Notify;
  if FUseWait then
  begin
    if FWait then FFlags := FFlags or mci_Wait;
    FUseWait := False;
  end;
  }
  FFlags := FFlags or mci_Wait;
  if FUseFrom then
  begin
    FFlags := FFlags or mci_From;
    PlayParm.dwFrom := FFrom;
    FUseFrom := False; {only applies to this mciSendCommand}
  end;
  if FUseTo then
  begin
    FFlags := FFlags or mci_To;
    PlayParm.dwTo := FTo;
    FUseTo := False; {only applies to this mciSendCommand}
  end;
  PlayParm.dwCallback := Handle;
  FError := mciSendCommand( FDeviceID, mci_Play, FFlags, Longint(@PlayParm));
end;

//*   TSoundPlay   

end.
