unit sesAdviseUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Math,StdCtrls, Buttons, ExtCtrls, sesEditUnit, Menus, ImgList,
  sesDatePickerUnit,sesPickListFrame,sesTimePickerUnit,sesHistoryFrame,sesCalcFrame,
  ErrorMessageFrameUnit,sesStrings, sesSystem, ComCtrls, ActnList,SoundPlayUnit;

type


TRangeTrackBar = record
  Min,Max:Double;
  LineSize,Position:Double;
  PixelScale:Double;
  Range:Double;
  MaxWidth:Integer;
  MinWidth:Integer;
  end;

  TsesAdviseForm = class(TForm)
    BasePanel: TPanel;
    Panel2: TPanel;
    ErrorDescription: TLabel;
    ErrorText: TPanel;
    AdviseCaption: TPanel;
    AdvisePanel: TPanel;
    CharAdvisePanel: TPanel;
    Button0: TBitBtn;
    Button1: TBitBtn;
    Button2: TBitBtn;
    Button3: TBitBtn;
    Button4: TBitBtn;
    Button5: TBitBtn;
    Button6: TBitBtn;
    Button7: TBitBtn;
    Button8: TBitBtn;
    Button9: TBitBtn;
    ButtonDecimalSeparator: TBitBtn;
    ButtonPlus: TBitBtn;
    ButtonMinus: TBitBtn;
    BoolAdvisePanel: TPanel;
    FalseButton: TBitBtn;
    TrueButton: TBitBtn;
    AdviseRangePanel: TPanel;
    MinLabel: TLabel;
    MinValue: TStaticText;
    MaxLabel: TLabel;
    MaxValue: TStaticText;
    RangeValue: TStaticText;
    FormIcons: TImageList;
    PopUpMenuImageList: TImageList;
    sesPopupMenu: TPopupMenu;
    PickList: TMenuItem;
    History: TMenuItem;
    Calc: TMenuItem;
    UserForm: TMenuItem;
    ActionPanel: TPanel;
    CancelButton: TBitBtn;
    ApplyButton: TBitBtn;
    JumpButton: TBitBtn;
    ErrorNumberEdit: TEdit;
    DelButton: TSpeedButton;
    RangePanel: TPanel;
    LessPanel: TPanel;
    GreaterPanel: TPanel;
    ActionList1: TActionList;
    CloseModal: TAction;
    ApplyAction: TAction;
    DatePicker: TMenuItem;
    TimePicker: TMenuItem;
    procedure AdvicePagerChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonDecimalSeparatorClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure ErrorNumberEditChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DelButtonClick(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
    procedure FalseButtonClick(Sender: TObject);
    procedure CalcClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure HistoryClick(Sender: TObject);
    procedure JumpButtonClick(Sender: TObject);
    procedure CloseModalExecute(Sender: TObject);
    procedure ApplyActionExecute(Sender: TObject);
    procedure CloseModalUpdate(Sender: TObject);
    procedure PickListClick(Sender: TObject);
    procedure DatePickerClick(Sender: TObject);
    procedure TimePickerClick(Sender: TObject);
    procedure ErrorNumberEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ErrorNumberEditKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    SeparatorPressed:Boolean;
  protected
  procedure CMDialogKey(var Message: TCMDialogKey);message CM_DIALOGKEY;
  procedure WMKeyDOWN(var Message: TWMKEY);message WM_KEYDOWN;

  procedure AdjustScreenPosition;
  public
    { Public declarations }
    Editor:TsesCustomEditor;
    EditControl:TsesCustomEdit;
    PopUpEdit:TsesCustomEdit;
    ErrorType:TEditErrorType;
    OldText:String;
    RangeTrackBar:TRangeTrackBar;

    ShowType:Integer; // Show:
    {
    0 - symbol error;
    1 - number error;
    2 - boolean error;
    3 - Calc;
    4 - History;
    5 - PickList;
    6 - Number range
    7 - Date;
    8 - Time;
    9 - Error message;
    }

    Number:Double;
    procedure ShowEditError(Sender:TObject; aKey:Char; aErrorType:TEditErrorType);
    procedure ShowCalc(Sender:TObject);
    procedure ShowHistory(Sender:TObject);
    procedure ShowPickList(Sender:TObject);
    procedure ShowDatePicker(Sender:TObject);
    procedure ShowTimePicker(Sender:TObject);
    procedure ShowErrorMessage(Sender:TObject; aCaption:String; aText:String);

    // PickList conrol
    function IsValueFounded(Edit:TsesCustomEdit):Integer;
    function GetPickListCaption(Edit:TsesCustomEdit; Full:Boolean):String;

    procedure PlaySound(const FileName:String);
  end;


var
  // global variable as the global reference to CEAdviseForm
  sesAdviseForm:TsesAdviseForm=nil;
implementation

procedure TsesAdviseForm.PlaySound(const FileName:String);
begin
If not FileExists(FileName) then Exit;
If not MPActive then
       SoundPlayerOpen;
PlayList.Clear;
PlayList.Add(FileName);
PlaySoundMessage(False);
end;

{$R *.DFM}
function TsesAdviseForm.IsValueFounded(Edit:TsesCustomEdit):Integer;
begin
Result := sesPickList.IsValueFounded(Edit);
end;
function TsesAdviseForm.GetPickListCaption(Edit:TsesCustomEdit; Full:Boolean):String;
begin
Result := sesPickList.GetPickListCaption(Edit,Full);
end;


procedure TsesAdviseForm.ShowErrorMessage(Sender:TObject; aCaption:String; aText:String);
begin
FormIcons.GetIcon(9,Self.Icon);
ShowType := 9;
BasePanel.Visible := False;
PopUpEdit:=TsesCustomEdit(Sender);
Caption := aCaption;
ErrorMessageFrame.Memo.Lines.Text := aText;
ErrorMessageFrame.Visible := True;

end;

procedure TsesAdviseForm.ShowHistory(Sender:TObject);
begin
FormIcons.GetIcon(4,Self.Icon);
ShowType := 4;
BasePanel.Visible := False;

sesHistory.HistoryEdit:=TsesCustomEdit(Sender);
OldText := sesHistory.HistoryEdit.Text;
Caption := sesHistory_Caption+'->'+sesHistory.HistoryEdit.Caption;
sesHistory.Visible := True;
sesHistory.LoadHistory;
//AdjustScreenPosition;
//ShowModal;

end;

procedure TsesAdviseForm.ShowPickList(Sender:TObject);
begin
FormIcons.GetIcon(5,Self.Icon);
ShowType := 5;
BasePanel.Visible := False;

sesPickList.PickListEdit:=TsesCustomEdit(Sender);
OldText := sesPickList.PickListEdit.Text;
Caption := sesPickList_Caption+'->'+sesPickList.PickListEdit.Caption;
sesPickList.Visible := True;
sesPickList.PickListSelected := False;
sesPickList.LoadPickList;
//AdjustScreenPosition;
//ShowModal;

end;

procedure TsesAdviseForm.ShowDatePicker(Sender:TObject);
begin
FormIcons.GetIcon(7,Self.Icon);
ShowType := 7;
BasePanel.Visible := False;

sesDatePicker.Edit:=TsesCustomEdit(Sender);
OldText := sesDatePicker.Edit.Text;
Caption := sesDatePicker_Caption+'->'+sesDatePicker.Edit.Caption;
sesDatePicker.Visible := True;
//AdjustScreenPosition;
//ShowModal;

end;

procedure TsesAdviseForm.ShowTimePicker(Sender:TObject);
begin
FormIcons.GetIcon(8,Self.Icon);
ShowType := 8;
BasePanel.Visible := False;

sesTimePicker.Edit:=TsesCustomEdit(Sender);
OldText := sesTimePicker.Edit.Text;
Caption := sesTimePicker_Caption+'->'+sesTimePicker.Edit.Caption;
sesTimePicker.Visible := True;
//AdjustScreenPosition;
//ShowModal;

end;

procedure TsesAdviseForm.ShowCalc(Sender:TObject);
begin
FormIcons.GetIcon(3,Self.Icon);
ShowType := 3;
BasePanel.Visible := False;
sesCalc.CalcEdit:=TsesCustomEdit(Sender);
OldText := sesCalc.CalcEdit.Text;
Caption := sesCalc_Caption+'->'+sesCalc.CalcEdit.Caption;
sesCalc.Visible := True;
sesCalc.aClearExecute(nil);
//AdjustScreenPosition;
//ShowModal;

end;

procedure TsesAdviseForm.ShowEditError(Sender:TObject; aKey:Char; aErrorType:TEditErrorType);
var
DataType:TClassicDataType;
begin
sesCalc.Visible := False;
BasePanel.Visible := True;
FormIcons.GetIcon(3,Self.Icon);

Editor:=TsesCustomEditor(Sender);
EditControl:=TsesCustomEdit(Editor.Parent);
OldText := Editor.Text;
DataType:=Editor.EditDataType;
ErrorType:=aErrorType;
ButtonDecimalSeparator.Caption := '&'+DecimalSeparator;
Case ErrorType Of
 ceChar:
                    begin
                    FormIcons.GetIcon(0,Self.Icon);
                    ShowType := 0;
                    AdviseRangePanel.Visible := False;
                    BoolAdvisePanel.Visible := False;
                    CharAdvisePanel.Visible := True;
                    ErrorNumberEdit.Text := Editor.Text;

                    ErrorText.Caption := aKey;
                    Caption := CE_Char_Caption;
                    AdviseCaption.Caption := CE_Char__Advise;
                    ErrorText.Hint := CE_Char_CharHint;
                    case DataType Of
                    cdtDate:
                    begin
                    ButtonPlus.Enabled := False;
                    ButtonMinus.Enabled := False;
                    ButtonDecimalSeparator.Enabled := True;
                    ButtonDecimalSeparator.Caption := DateSeparator;
                    ButtonDecimalSeparator.Hint := HintDateSeparator;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Char_DesriptionForDate;
                    end;
                    cdtCardinal:
                    begin
                    ButtonPlus.Enabled := False;
                    ButtonMinus.Enabled := False;
                    ButtonDecimalSeparator.Enabled := False;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Char_DesriptionForCardinal;
                    end;
                    cdtInteger:
                    begin
                    ButtonPlus.Enabled := True;
                    ButtonMinus.Enabled := True;
                    ButtonDecimalSeparator.Enabled := False;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Char_DesriptionForInteger;
                    end;
                    cdtFloat:
                    begin
                    ButtonPlus.Enabled := True;
                    ButtonMinus.Enabled := True;
                    ButtonDecimalSeparator.Enabled := True;
                    ButtonDecimalSeparator.Caption := DecimalSeparator;
                    ButtonDecimalSeparator.Hint := HintDecimalSeparator;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Char_DesriptionForFloat;
                    end;
                    cdtTime:
                    begin
                    ButtonPlus.Enabled := False;
                    ButtonMinus.Enabled := False;
                    ButtonDecimalSeparator.Enabled := True;
                    ButtonDecimalSeparator.Caption := TimeSeparator;
                    ButtonDecimalSeparator.Hint := HintTimeSeparator;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Char_DesriptionForTime;
                    end;
                    end; // case of DataType

                    end; // Char
 ceBoolean:
                    begin
                    FormIcons.GetIcon(2,Self.Icon);
                    ShowType := 2;
                    AdviseRangePanel.Visible := False;
                    BoolAdvisePanel.Visible := True;
                    CharAdvisePanel.Visible := False;
                    AdviseCaption.Caption := CE_Bool_Advise;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Val_DesriptionForBool;
                    ErrorText.Caption := Editor.Text;
                    Caption := CE_Val_Caption;
                    FalseButton.Caption := Editor.RangeMinOrFalse;
                    TrueButton.Caption := Editor.RangeMaxOrTrue;
                    end; // Boolean


 ceNumber:
                    begin
                    FormIcons.GetIcon(1,Self.Icon);
                    ShowType := 1;
                    AdviseRangePanel.Visible := False;
                    BoolAdvisePanel.Visible := False;
                    CharAdvisePanel.Visible := True;

                    AdviseCaption.Caption := CE_Val_Advise;
                    ErrorText.Caption := Editor.Text;
                    Caption := CE_Val_Caption;
                    ErrorText.Hint := CE_Val_ValueHint;
                    ErrorNumberEdit.Text := Editor.Text;
                    ErrorNumberEditChange(nil);

Case DataType Of
cdtCardinal:
           begin
//           NumberErrorAdvisePanel.Items.Text := CE_Val_SampleForCardinal;
           ErrorDescription.Caption := EditControl.Caption+': '+CE_Val_DesriptionForCardinal;
           end;
cdtInteger:
           begin
//           Samples.Items.Text := CE_Val_SampleForInteger;
           ErrorDescription.Caption := EditControl.Caption+': '+CE_Val_DesriptionForInteger;
           end;
cdtFloat:
           begin
           ErrorDescription.Caption := EditControl.Caption+': '+CE_Val_DesriptionForFloat;
//           Samples.Items.Text := CE_Val_SampleForFloat;
           end;

 end; // Case Of DataType

                    end; // Number error

ceRange:
                    begin
                    FormIcons.GetIcon(6,Self.Icon);
                    Caption := CE_Range_Caption;
                    If not (IsStringFloat(Editor.RangeMinOrFalse)=0) then
                       begin
                       Application.MessageBox(PChar(EditControl.Caption+':'+CE_Range_Min_Error),
                       PChar(Caption), MB_ICONSTOP);
                       Exit;
                       end;
                    If not (IsStringFloat(Editor.RangeMaxOrTrue)=0) then
                       begin
                       Application.MessageBox(PChar(EditControl.Caption+':'+CE_Range_Max_Error),
                        PChar(Caption), MB_ICONSTOP);
                       Exit;
                       end;
                    CharAdvisePanel.Visible := False;
                    BoolAdvisePanel.Visible := False;
                    AdviseRangePanel.Visible := True;
                    ShowType := 6;
                    AdviseCaption.Caption := CE_Range_Advise;
                    ErrorText.Caption := Editor.Text;
                    ErrorDescription.Caption := EditControl.Caption+': '+CE_Range_Description;

                    ErrorText.Hint := CE_Range_Hint;
                    RangeValue.Caption := Editor.Text;
                    RangeTrackBar.Position := StrToFloat(Editor.Text);
                    MinValue.Caption := Editor.RangeMinOrFalse;
                    MaxValue.Caption := Editor.RangeMaxOrTrue;
                    RangeTrackBar.Min:= Round(StrToFloat(MinValue.Caption));
                    If RangeTrackBar.Position < RangeTrackBar.Min then
                       begin
                       RangeValue.Color := HelperBK9;
                       RangeValue.Left := 4;
                       LessPanel.Visible := True;
                       GreaterPanel.Visible := False;
                       end
                       else
                       begin
                       RangeValue.Color := HelperBK1;
                       RangeValue.Left := 214;
                       LessPanel.Visible := False;
                       GreaterPanel.Visible := True;
                       end;
                    end; // range

   end; // Case of ErrorType
AdjustScreenPosition;
ShowModal;

end;

procedure TsesAdviseForm.AdvicePagerChange(Sender: TObject);
begin
If not Showing then Exit;
Case ErrorType Of
 ceChar:
         begin
         CancelButton.SetFocus;
         end;
 ceNumber:
         begin
         ErrorNumberEditChange(nil);
         //RetryButton.SetFocus;
         end;

  end; // Case Of Error Type

end;


procedure TsesAdviseForm.AdjustScreenPosition;
var
H,W:Integer;
ScreenPoint:TPoint;
sesEditor:TsesCustomEditor;
begin
  sesEditor := nil;
  W := Self.Width - Self.ClientWidth;
  H := Self.Height - Self.ClientHeight;
  If  ShowType = 0 then
      JumpButton.Enabled := False
      else
      JumpButton.Enabled := True;

Case ShowType Of
0,1: // Char,Number
  begin
  Self.Width := W + BasePanel.Width + Self.BorderWidth * 2;
  Self.Height := H+ BasePanel.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := Editor;
  end;

2: // Boolean
  begin
  Self.Width := W+BasePanel.Width + Self.BorderWidth * 2;
  Self.Height := H+BasePanel.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := Editor;
  end;

3: // Calc
  begin
  //Self.Width :=W+ ActionPanel.Width + Self.BorderWidth * 2;
  Self.Width :=W+ sesCalc.Width + Self.BorderWidth * 2;
  Self.Height :=H+ sesCalc.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := sesCalc.CalcEdit.Editor;
  end;
4: // History
  begin
  Self.Width := W+sesHistory.Width + Self.BorderWidth * 2;
  Self.Height := H+sesHistory.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := sesHistory.HistoryEdit.Editor;
  end;
5: // PickList
  begin
  Self.Width := W+sesPickList.Width + Self.BorderWidth * 2;
  Self.Height := H+sesPickList.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := sesPickList.PickListEdit.Editor;
  end;

6: // Range number
  begin
  Self.Width := W+BasePanel.Width + Self.BorderWidth * 2;
  Self.Height := H+BasePanel.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := Editor;
  end;

7: // DatePicker
  begin
  Self.Width := W+sesDatePicker.Width + Self.BorderWidth * 2;
  Self.Height := H+sesDatePicker.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := sesDatePicker.Edit.Editor;
  end;
8: // TimePicker
  begin
  Self.Width := W+sesTimePicker.Width + Self.BorderWidth * 2;
  Self.Height := H+sesTimePicker.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := sesTimePicker.Edit.Editor;
  end;
9: //
  begin
  Self.Width := W+ErrorMessageFrame.Width + Self.BorderWidth * 2;
  Self.Height := H+ErrorMessageFrame.Height + ActionPanel.Height + Self.BorderWidth * 2;
  sesEditor := PopUpEdit.Editor;
  end;

end; // Case of ShowType

ScreenPoint:=GetPopUpScreenPos(sesEditor, Self.Height, Self.Width);
Self.Left:=ScreenPoint.x;
Self.Top:=ScreenPoint.y;
end;

procedure TsesAdviseForm.FormShow(Sender: TObject);
begin
AdjustScreenPosition;
Case ShowType Of
0,1: // Char,Number
  begin
  ErrorNumberEditChange(nil);
  ErrorNumberEdit.SetFocus;
  end;

2: // Boolean
  begin
  CancelButton.SetFocus;
  end;

3: // Calc
  begin
  sesCalc.Activate;
  sesCalc.ResEdit.SetFocus;
  end;
4: // History
  begin
  If not sesHistory.HistoryEnabled then
     begin
     ApplyAction.Enabled := False;
     ApplyButton.Enabled := False;
     sesHistory.HistoryListBox.Enabled:=False;
     CancelButton.SetFocus;
     end
     else
     begin
     ApplyAction.Enabled := True;
     ApplyButton.Enabled := True;
     sesHistory.HistoryListBox.Enabled:=True;
     sesHistory.SelectedValue.Text := sesNotSelected;
     sesHistory.SelectedValue.SetFocus;
     end;
  end;
5: // PickList
  begin
  If not sesPickList.PickListEnabled then
     begin
     ApplyAction.Enabled := False;
     ApplyButton.Enabled := False;
     sesPickList.PickListListBox.Enabled:=False;
     If sesPickList.PickListEdit.PickListKind = plDataSet then
        sesPickList.DBGrid1.Enabled := False
        else
        sesPickList.PickListListBox.Enabled:=False;

     CancelButton.SetFocus;
     end
     else
     begin
     ApplyAction.Enabled := True;
     ApplyButton.Enabled := True;
     If sesPickList.PickListEdit.PickListKind = plDataSet then
        sesPickList.DBGrid1.Enabled := True
        else
        sesPickList.PickListListBox.Enabled:=True;
     sesPickList.PickListSelectedValue.Text := sesNotSelected;
     sesPickList.PickListSelectedValue.SetFocus;
     end;
  end;

6: // Range number
  begin
     ApplyAction.Enabled := False;
     ApplyButton.Enabled := False;
     sesPickList.PickListListBox.Enabled:=False;
     CancelButton.SetFocus;
  end;
7: // DatePicker
  begin
  sesDatePicker.SetDateValue(sesDatePicker.Edit.Text,IsSetNow);
  end;

8: // TimePicker
  begin
  sesTimePicker.SetTimeValue(sesTimePicker.Edit.Text,IsSetNow);
  end;

9:
  begin
  ApplyAction.Enabled := False;
  ApplyButton.Enabled := False;
  end;

end; // Case of ShowType



end;

procedure TsesAdviseForm.FormCreate(Sender: TObject);
begin
SeparatorPressed:=False;

ErrorMessageFrame:=TErrorMessageFrame.Create(Self);
ErrorMessageFrame.Parent := Self;
ErrorMessageFrame.Left:=0;
ErrorMessageFrame.Top:=0;
ErrorMessageFrame.Visible := False;


sesCalc:=TsesCalc.Create(Self);
sesCalc.Parent := Self;
sesCalc.Left:=0;
sesCalc.Top:=0;
//CalcFrame.Align := alClient;
sesCalc.Visible := False;
sesCalc.sesCalcInit;

BasePanel.Visible := False;

sesHistory:=TsesHistory.Create(Self);
sesHistory.Parent := Self;
sesHistory.Left:=0;
sesHistory.Top:=0;
sesHistory.HistoryInit;

sesPickList:=TsesPickList.Create(Self);
sesPickList.Parent := Self;
sesPickList.Left:=0;
sesPickList.Top:=0;
sesPickList.PickListInit;

sesDatePicker:=TsesDatePicker.Create(Self);
sesDatePicker.Parent := Self;
sesDatePicker.Left:=0;
sesDatePicker.Top:=0;
sesDatePicker.Init;

sesTimePicker:=TsesTimePicker.Create(Self);
sesTimePicker.Parent := Self;
sesTimePicker.Left:=0;
sesTimePicker.Top:=0;
sesTimePicker.Init;


Editor := nil;

Button0.Hint := Hint0;
Button1.Hint := Hint1;
Button2.Hint := Hint2;
Button3.Hint := Hint3;
Button4.Hint := Hint4;
Button5.Hint := Hint5;
Button6.Hint := Hint6;
Button7.Hint := Hint7;
Button8.Hint := Hint8;
Button9.Hint := Hint9;
ButtonPlus.Hint := HintPlus;
ButtonMinus.Hint := HintMinus;
ButtonDecimalSeparator.Caption := '&'+DecimalSeparator;
ButtonDecimalSeparator.Hint := HintDecimalSeparator;

ApplyButton.Hint := ApplyButtonHint;

LessPanel.Caption := CE_Range_Less;
GreaterPanel.Caption := CE_Range_Greater;
RangePanel.Caption := CE_Range;

FalseButton.Hint := FalseButtonHint;
TrueButton.Hint := TrueButtonHint;

ErrorText.Color := HelperBK5;
ErrorDescription.Color := HelperBK6;
AdviseCaption.Color := HelperBK7;
AdvisePanel.Color := HelperBK8;
CharAdvisePanel.Color:=HelperBK8;


CancelButton.Hint:=CE_CancelButtonHint;
CancelButton.Caption:=CE_CancelButtonCaption;

ApplyButton.Caption:=CE_ApplyButtonCaption;
ApplyButton.Hint:=CE_ApplyButtonHint;

JumpButton.Caption:=CE_JumpButtonCaption;
JumpButton.Hint:=CE_JumpButtonHint;

AdviseRangePanel.Color := HelperBK6;

{sesPopUpMenu}
UserForm.Caption := sesPopupMenu_UserForm_Caption;
UserForm.Hint := sesPopupMenu_UserForm_Hint;

PickList.Caption := sesPopupMenu_PickList_Caption;
PickList.Hint := sesPopupMenu_PickList_Hint;

History.Caption := sesPopupMenu_History_Caption;
History.Hint := sesPopupMenu_History_Hint;

DatePicker.Caption := sesPopupMenu_DatePicker_Caption;
DatePicker.Hint := sesPopupMenu_DatePicker_Hint;

TimePicker.Caption := sesPopupMenu_TimePicker_Caption;
TimePicker.Hint := sesPopupMenu_TimePicker_Hint;

Calc.Caption := sesPopupMenu_Calc_Caption;
Calc.Hint := sesPopupMenu_Calc_Hint;


end;

procedure TsesAdviseForm.ButtonDecimalSeparatorClick(Sender: TObject);
var
S:String;
begin
If Editor = nil then Exit;

Case ShowType Of
0:
   begin
   If not ErrorNumberEdit.CanFocus then Exit;
   S:=Copy((Sender as TBitBtn).Caption,2,1);
   ErrorNumberEdit.SelLength := 0;
   ErrorNumberEdit.SelText := S;
   end;
1:
   begin
   If not ErrorNumberEdit.CanFocus then Exit;
   S:=Copy((Sender as TBitBtn).Caption,2,1);
   ErrorNumberEdit.SelLength := 1;
   ErrorNumberEdit.SelText := S;
   end;

end; // Case
end;

procedure TsesAdviseForm.CMDialogKey(var Message: TCMDialogKey);
begin
if ActiveControl = nil then
   begin
   inherited;
   Exit;
   end;

  if GetKeyState(VK_MENU) >= 0 then
begin
If Message.CharCode = VK_ESCAPE then
                  begin
                  Message.Result := 1;
                  ModalResult := mrCancel;
                  Exit;
                  end;

Case ShowType Of
   0,1:
    begin
    with Message do
      case CharCode of
        VK_TAB:
          if GetKeyState(VK_CONTROL) >= 0 then
          begin
          SelectNext(ActiveControl, GetKeyState(VK_SHIFT) >= 0, True);
            Result := 1;
            Exit;
          end;
        VK_LEFT, VK_RIGHT,VK_UP, VK_DOWN:
          begin
            if (CharCode = VK_DOWN) and (ActiveControl.Tag = 5) then
                    begin
                    Button0.SetFocus;
                    Result := 1;
                    Exit;
                    end
                    else
            if (CharCode = VK_DOWN) and (ActiveControl.Tag = 3) then
                    begin
                    CancelButton.SetFocus;
                    Result := 1;
                    Exit;
                    end
                    else
                    If (CharCode = VK_UP) and (ActiveControl.Tag = 1) then
                            begin
                            Button0.SetFocus;
                            Result := 1;
                            Exit;
                            end
                            else
                    If (CharCode = VK_UP) and (ActiveControl.Tag = 3) then
                            begin
                            ErrorNumberEdit.SetFocus;
                            Result := 1;
                            Exit;
                            end
                    else
                    If (CharCode = VK_Left) and (ActiveControl.Name = 'CancelButton') then
                            begin
                            Button0.SetFocus;
                            Result := 1;
                            Exit;
                            end
                            else
                    If (CharCode = VK_RIGHT) and (ActiveControl.Name = 'JumpButton') then
                            begin
                            Button0.SetFocus;
                            Result := 1;
                            Exit;
                            end
                            else
                    If (CharCode = VK_RIGHT) and (ActiveControl.Name = 'ApplyButton') then
                            begin
                            JumpButton.SetFocus;
                            Result := 1;
                            Exit;
                            end
                            else
                    If (CharCode = VK_RIGHT) and (ActiveControl.Name = 'CancelButton') then
                            begin
                            If  ApplyButton.CanFocus then
                                ApplyButton.SetFocus;
                            Result := 1;
                            Exit;
                            end;




          end; // Arrows
      end; // Case of CharCode
        end; // 0,1
   2:
    begin
    with Message do
      case CharCode of
        VK_TAB:
          if GetKeyState(VK_CONTROL) >= 0 then
          begin
          SelectNext(ActiveControl, GetKeyState(VK_SHIFT) >= 0, True);
            Result := 1;
            Exit;
          end;
        VK_LEFT, VK_RIGHT,VK_UP, VK_DOWN:
          begin
            if (CharCode = VK_DOWN) and (ActiveControl.Tag = 7) then
                    begin
                    CancelButton.SetFocus;
                    Result := 1;
                    Exit;
                    end
                    else
            if (CharCode = VK_UP) and (ActiveControl.Tag = 7) then
                    begin
                    CancelButton.SetFocus;
                    Result := 1;
                    Exit;
                    end
                    else
                    If (CharCode = VK_UP) and (ActiveControl.Tag = 1) then
                            begin
                            FalseButton.SetFocus;
                            Result := 1;
                            Exit;
                            end;



          end; // Arrows
      end; // Case of CharCode
        end; // 2 - Boolean

end; // Case Of errorType
end; // GetKeyState(VK_MENU) >= 0
  inherited;
end;

procedure TsesAdviseForm.CancelButtonClick(Sender: TObject);
begin
Editor.Text := OldText;
end;

procedure TsesAdviseForm.ErrorNumberEditChange(Sender: TObject);
var
Symbol:Integer;
begin
Symbol := 0;
If Editor = nil then Exit;
Case Editor.EditDataType Of
cdtCardinal:
        begin
        ButtonPlus.Enabled := False;
        ButtonMinus.Enabled := False;
        ButtonDecimalSeparator.Enabled := False;
        Symbol := IsStringCardinal(ErrorNumberEdit.Text);
        end;

cdtInteger:
        begin
        ButtonPlus.Enabled := True;
        ButtonMinus.Enabled := True;
        ButtonDecimalSeparator.Enabled := False;
        Symbol := IsStringInteger(ErrorNumberEdit.Text);
        end;

cdtFloat:
        begin
        ButtonPlus.Enabled := True;
        ButtonMinus.Enabled := True;
        ButtonDecimalSeparator.Enabled := True;
        Symbol := IsStringFloat(ErrorNumberEdit.Text);
        end;

end; // Case EditControl.EditDataType of
Case Symbol Of
-1:
   begin
   ApplyAction.Enabled := False;
   ApplyButton.Enabled := False;
   DelButton.Enabled := False;
   end;
0:
  begin
//  ErrorNumberEdit.SelectAll;
  ApplyAction.Enabled := True;
  ApplyButton.Enabled := True;

  ApplyButton.Default := True;
  CancelButton.Default := False;
  DelButton.Enabled := True;
  end;
1..255:
  begin
  ErrorNumberEdit.SelStart := Symbol-1;
  ErrorNumberEdit.SelLength :=1;
  ApplyAction.Enabled := False;
  ApplyButton.Enabled := False;
  DelButton.Enabled := True;
   end;

end; // Case Symbol of
If Showing then
ErrorNumberEdit.SetFocus;
end;

procedure TsesAdviseForm.FormDestroy(Sender: TObject);
begin
Editor := nil;
sesAdviseForm := nil;
If MPActive then
       DestroySoundPlayer;

end;

procedure TsesAdviseForm.DelButtonClick(Sender: TObject);
begin
ErrorNumberEdit.SelText := '';
end;

procedure TsesAdviseForm.ApplyButtonClick(Sender: TObject);
procedure ShowReadOnly;
begin
Application.MessageBox(PChar(sesReadOnly),PChar(Caption),MB_ICONSTOP);
end;
begin

Case ShowType Of
0,1: // Number
  begin
  If Editor = nil then Exit;
  If TsesCustomEdit(Editor.Parent).ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;
  Editor.Text := ErrorNumberEdit.Text;
  end;
2: // Boolean
  begin
  If Editor = nil then Exit;
  If TsesCustomEdit(Editor.Parent).ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;

  If FalseButton.Default then
     Editor.Text := FalseButton.Caption
     else
     Editor.Text := TrueButton.Caption;
  end;
3: // Calc
  begin
  If sesCalc.CalcEdit.ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;

  sesCalc.ApplyResButtonClick(nil);
  end;
4: // History
  begin
  If sesHistory.HistoryEdit.ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;

  sesHistory.HistoryEdit.Text := sesHistory.SelectedValue.Text;
  end;
5: // PickList
  begin
  If sesPickList.PickListEdit.ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;

  sesPickList.PickListEdit.Text := sesPickList.PickListSelectedValue.Text;
  end;

6: // Range number
  begin
  end;

7: // DatePicker
  begin
  If sesDatePicker.Edit.ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;

  sesDatePicker.Edit.Text := sesDatePicker.GetDateValue;
  end;

8: // TimePicker
  begin
  If sesTimePicker.Edit.ReadOnly then
     begin
     ShowReadOnly;
     Exit;
     end;

  sesTimePicker.Edit.Text := sesTimePicker.GetTimeValue;
  end;

end; // Case of ShowType

end;


procedure TsesAdviseForm.FalseButtonClick(Sender: TObject);
begin
If Editor = nil then Exit;
Editor.Text:=(Sender as TBitBtn).Caption;
end;




procedure TsesAdviseForm.CalcClick(Sender: TObject);
var
Res:TModalResult;
begin
sesCalc.CalcEdit := PopUpEdit;
ShowCalc(sesCalc.CalcEdit);
Res := Self.ShowModal;
Case Res Of
mrCancel,mrRetry:;
mrAbort:
        begin
        GetParentForm(sesCalc.CalcEdit).Perform(WM_NEXTDLGCTL,0,0);
        end;
end; // Case Of

end;

procedure TsesAdviseForm.FormHide(Sender: TObject);
begin
ErrorMessageFrame.Visible := False;
sesCalc.Visible := False;
BasePanel.Visible := False;
sesHistory.Visible := False;
sesPickList.Visible := False;
sesDatePicker.Visible := False;
sesTimePicker.Visible := False;
If  ShowType = 5 then
begin
// breake the link with PickDataSet
If sesPickList.PickListEdit.PickListKind = plDataSet then
   begin
   try
   sesPickList.DataSource1.DataSet := nil;
   except
   end;
   end;
end;

end;

procedure TsesAdviseForm.HistoryClick(Sender: TObject);
var
Res:TModalResult;
begin
sesHistory.HistoryEdit := PopUpEdit;
ShowHistory(sesHistory.HistoryEdit);
Res := Self.ShowModal;
Case Res Of
mrCancel,mrRetry:;
mrAbort:
        begin
        GetParentForm(sesHistory.HistoryEdit).Perform(WM_NEXTDLGCTL,0,0);
        end;
end; // Case Of

end;




procedure TsesAdviseForm.JumpButtonClick(Sender: TObject);
begin
Self.ModalResult := mrAbort;
Exit;
{
Case ShowType Of
0:;
1,2,6:;
3:
  begin
  LoseFocusAllowed := True;
  GetParentForm(sesCalc.CalcEdit.Editor).Perform(WM_NEXTDLGCTL,
  sesCalc.CalcEdit.Editor.Handle,88888888);
  end;
4:
  begin
  LoseFocusAllowed := True;
  GetParentForm(sesHistory.HistoryEdit.Editor).Perform(WM_NEXTDLGCTL,
  sesHistory.HistoryEdit.Editor.Handle,88888888);
  end;
5:
  begin
  LoseFocusAllowed := True;
  GetParentForm(sesPickList.PickListEdit.Editor).Perform(WM_NEXTDLGCTL,
  sesPickList.PickListEdit.Editor.Handle,99999999);
  end;
7:
  begin
  LoseFocusAllowed := True;
  GetParentForm(sesDatePicker.Edit.Editor).Perform(WM_NEXTDLGCTL,
  sesDatePicker.Edit.Editor.Handle,99999999);
  end;

end; // Case Of ShowType
}
end;

procedure TsesAdviseForm.WMKeyDOWN(var Message: TWMKEY);
begin
Case Message.CharCode Of
VK_ESCAPE:
          begin
          ModalResult := mrOK;
          Message.Result := 1;
          Exit;
          end;
end; // Case


end;

procedure TsesAdviseForm.CloseModalExecute(Sender: TObject);
begin
ModalResult := mrCancel;
end;

procedure TsesAdviseForm.ApplyActionExecute(Sender: TObject);
begin
If JumpButton.Focused then
   begin
   JumpButton.Click;
   Exit;
   end;
If CancelButton.Focused then
   begin
   ModalResult := mrCancel;
   Exit;
   end;

ApplyButton.Click;
end;


procedure TsesAdviseForm.CloseModalUpdate(Sender: TObject);
begin
Case ShowType Of
0,1,2,6:
        begin
        end;

3:
  begin
  If sesCalc.Modified then
     begin
     If  not ApplyAction.Enabled then
         ApplyAction.Enabled := True;
     If  not ApplyButton.Enabled then
         ApplyButton.Enabled := True;

     end
     else
     begin
     If  ApplyAction.Enabled then
         ApplyAction.Enabled := False;
     If  ApplyButton.Enabled then
         ApplyButton.Enabled := False;

     end;
  end;
4:
  begin
  If sesHistory.HistorySelected then
     begin
     If  not ApplyAction.Enabled then
         ApplyAction.Enabled := True;
     If  not ApplyButton.Enabled then
         ApplyButton.Enabled := True;

     end
     else
     begin
     If  ApplyAction.Enabled then
         ApplyAction.Enabled := False;
     If  ApplyButton.Enabled then
         ApplyButton.Enabled := False;

     end;
  end;

5:
  begin
  If sesPickList.PickListSelected then
     begin
     If  not ApplyAction.Enabled then
         ApplyAction.Enabled := True;
     If  not ApplyButton.Enabled then
         ApplyButton.Enabled := True;
     end
     else
     begin
     If  ApplyAction.Enabled then
         ApplyAction.Enabled := False;
     If  ApplyButton.Enabled then
         ApplyButton.Enabled := False;

     end;
  end;

7:
  begin
  If sesDatePicker.DateControl.ValidDate then
     begin
     If  not ApplyAction.Enabled then
         ApplyAction.Enabled := True;
     If  not ApplyButton.Enabled then
         ApplyButton.Enabled := True;
     Caption := sesDatePicker_RightDate;
     end
     else
     begin
     If  ApplyAction.Enabled then
         ApplyAction.Enabled := False;
     If  ApplyButton.Enabled then
         ApplyButton.Enabled := False;
     Caption := sesDatePicker_WrongDate;
     end;
  end;
8:
  begin
  If sesTimePicker.IsTimeValid then
     begin
     If  not ApplyAction.Enabled then
         ApplyAction.Enabled := True;
     If  not ApplyButton.Enabled then
         ApplyButton.Enabled := True;
     Caption := sesTimePicker_RightTime;
     end
     else
     begin
     If  ApplyAction.Enabled then
         ApplyAction.Enabled := False;
     If  ApplyButton.Enabled then
         ApplyButton.Enabled := False;
     Caption := sesTimePicker_WrongTime;
     end;
  end;
9:
  begin
  end;
end; // Case Of ShowType
end;

procedure TsesAdviseForm.PickListClick(Sender: TObject);
var
Res:TModalResult;
begin
sesPickList.PickListEdit := PopUpEdit;
ShowPickList(sesPickList.PickListEdit);
Res := Self.ShowModal;
Case Res Of
mrCancel,mrRetry:;
mrAbort:
        begin
        GetParentForm(sesPickList.PickListEdit).Perform(WM_NEXTDLGCTL,0,0);
        end;
end; // Case Of
end;

procedure TsesAdviseForm.DatePickerClick(Sender: TObject);
var
Res:TModalResult;
begin
sesDatePicker.Edit := PopUpEdit;
ShowDatePicker(sesDatePicker.Edit);
Res := Self.ShowModal;
Case Res Of
mrCancel,mrRetry:;
mrAbort:
        begin
        GetParentForm(sesDatePicker.Edit).Perform(WM_NEXTDLGCTL,0,0);
        end;
end; // Case Of

end;

procedure TsesAdviseForm.TimePickerClick(Sender: TObject);
var
Res:TModalResult;
begin
sesTimePicker.Edit := PopUpEdit;
ShowTimePicker(sesTimePicker.Edit);
Res := Self.ShowModal;
Case Res Of
mrCancel,mrRetry:;
mrAbort:
        begin
        GetParentForm(sesTimePicker.Edit).Perform(WM_NEXTDLGCTL,0,0);
        end;
end; // Case Of

end;

procedure TsesAdviseForm.ErrorNumberEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
// VK_DECIMAL(110) is the case, when user pressed down Decimal key on the numeric keypad
If (TsesCustomEdit(Editor.Parent).DecimalKeyAsSeparator) and (Key = 110) then
                                begin
                                SeparatorPressed := True;
                                end;

end;

procedure TsesAdviseForm.ErrorNumberEditKeyPress(Sender: TObject;
  var Key: Char);
begin
// VK_DECIMAL(110) is the case, when user pressed down Decimal key on the numeric keypad
If SeparatorPressed then
                                begin
                                SeparatorPressed := False;
// try to translate Decimal Separator(numeric keypad) to universal Separator
Case TsesCustomEdit(Editor.Parent).DataType Of
cdtFloat: Key := DecimalSeparator;
cdtDate:  Key := DateSeparator;
cdtTime:  Key := TimeSeparator;
end;// Case FClassicDataType Of
                                end;

end;

end.
