unit sesCalcFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Clipbrd,Math,sesEditUnit, sesStrings,sesSystem,ActnList, Menus,
  ComCtrls, StdCtrls, Buttons, ExtCtrls;

const
CalcHistoryMax=100;

type
  TsesCalc = class(TFrame)
    BasePanel: TPanel;
    DelMemButton: TSpeedButton;
    ViewMemButton: TSpeedButton;
    SetMemButton: TSpeedButton;
    PlusMemButton: TSpeedButton;
    MultiMemButton: TSpeedButton;
    bLog: TSpeedButton;
    bSin: TSpeedButton;
    bCos: TSpeedButton;
    bXp2: TSpeedButton;
    Panel1: TPanel;
    HistoryComboBox: TComboBox;
    ResEdit: TEdit;
    Panel2: TPanel;
    CEButton: TSpeedButton;
    sqrtButton: TSpeedButton;
    bPower: TSpeedButton;
    bDivide: TSpeedButton;
    CButton: TSpeedButton;
    PerButton: TSpeedButton;
    b7: TSpeedButton;
    b8: TSpeedButton;
    b9: TSpeedButton;
    bMultiplay: TSpeedButton;
    bMinus: TSpeedButton;
    bPlus: TSpeedButton;
    InvXButton: TSpeedButton;
    b4: TSpeedButton;
    b5: TSpeedButton;
    b6: TSpeedButton;
    InvSignButton: TSpeedButton;
    b1: TSpeedButton;
    b2: TSpeedButton;
    b3: TSpeedButton;
    b0: TSpeedButton;
    bComma: TSpeedButton;
    bCalc: TSpeedButton;
    BsButton: TSpeedButton;
    bXp3: TSpeedButton;
    MemPanel: TPanel;
    st: TStatusBar;
    OperationPanel: TPanel;
    RoundEdit: TEdit;
    udRound: TUpDown;
    EditPopupMenu: TPopupMenu;
    ShowHints: TMenuItem;
    ActionList1: TActionList;
    aClear: TAction;
    procedure CEButtonClick(Sender: TObject);
    procedure CButtonClick(Sender: TObject);
    procedure InvSignButtonClick(Sender: TObject);
    procedure SetMemButtonClick(Sender: TObject);
    procedure DelMemButtonClick(Sender: TObject);
    procedure ViewMemButtonClick(Sender: TObject);
    procedure PlusMemButtonClick(Sender: TObject);
    procedure MultiMemButtonClick(Sender: TObject);
    function GetRoundFloat(aNumber:Double):String;
    procedure InsertDigit(aDigit:String);
    procedure b7Click(Sender: TObject);
    procedure bCalcClick(Sender: TObject);
    procedure aClearUpdate(Sender: TObject);
    procedure aClearExecute(Sender: TObject);
    procedure BsButtonClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ResEditKeyPress(Sender: TObject; var Key: Char);
    procedure ShowHintsClick(Sender: TObject);
    procedure HistoryComboBoxChange(Sender: TObject);
    procedure ApplyResButtonClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  Oper:Integer;
  Res,Operand1,Operand2,MemOperand:Double;
  MemSet,OperPressed,InputToOne:Boolean;
  CalcEdit:TsesCustomEdit;
  PrimeValue:String;
  Modified:Boolean;
  procedure Activate;
  procedure sesCalcInit;
  procedure ShowError(aError:String);
  end;

var
  sesCalc: TsesCalc;

implementation

{$R *.DFM}
procedure TsesCalc.InsertDigit(aDigit:String);
var
DS:Integer;
begin

If bComma.Down then
   begin
   ResEdit.SelLength := 1;
   ResEdit.SelStart:=Length(ResEdit.Text);
   ResEdit.SelText := aDigit;
   If InputToOne then
      Operand1 := StrToFloat(ResEdit.Text)
      else
      Operand2 := StrToFloat(ResEdit.Text);
   end
   else
   begin
   If ResEdit.Text = PrimeValue then
      begin
      ResEdit.Text := aDigit + DecimalSeparator;
     If InputToOne then
      Operand1 := StrToFloat(ResEdit.Text)
      else
      Operand2 := StrToFloat(ResEdit.Text);

      Exit;
      end;
   DS:=Pos(DecimalSeparator,ResEdit.Text);
   DS := DS - 1;
   If DS < 0 then DS := 0;
   ResEdit.SelLength := 1;
   ResEdit.SelStart:=DS;
   ResEdit.SelText := aDigit;
   If InputToOne then
      Operand1 := StrToFloat(ResEdit.Text)
      else
      Operand2 := StrToFloat(ResEdit.Text);

   end;
end;

function TsesCalc.GetRoundFloat(aNumber:Double):String;
function SetDecimal(aSource:String):String;
var
i:Integer;
begin
i:= Pos(DecimalSeparator,aSource);
If i = 0 then
   Result := aSource + DecimalSeparator
   else
   Result := aSource;
end;
begin
Result := '';
If udRound.Position = -1 then
   begin
   Result := SetDecimal(FloatToStr(aNumber));
   Exit;
   end;
Result := SetDecimal(FloatToStr(RoundExtended(aNumber, udRound.Position)));

end;
procedure TsesCalc.CEButtonClick(Sender: TObject);
begin
ResEdit.Text := PrimeValue;
Operand2 := 0;
Oper:=0;
OperationPanel.Caption := '';
end;

procedure TsesCalc.CButtonClick(Sender: TObject);
begin
OperationPanel.Caption := '';
ResEdit.Text := '0'+DecimalSeparator;
Oper := 0;
bComma.Down := False;
end;

procedure TsesCalc.InvSignButtonClick(Sender: TObject);
var
B:TSpeedButton;
begin
OperPressed:=False;
B:=TSpeedButton(Sender);
Oper := B.Tag;
OperationPanel.Caption := B.Caption;
   try
   Operand1 := StrToFloat(ResEdit.Text);
   except
   ShowError(sesInvalidOperand);
   Exit;
   end;

Case Oper of
1:
   begin
   // sqrt
   try
   Operand1 := sqrt(Operand1);
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   ShowError(sesInvalidOperand);
   Exit;
   end;
   end;
2:OperPressed:=True;
3:
  begin
  OperPressed:=True;
  end;
4:OperPressed:=True;
5:OperPressed:=True;
6:OperPressed:=True;
7:OperPressed:=True;
8: // 1/x
begin
   try
   If abs(Operand1) <= FloatNull then
      begin
      ShowError(sesDivideByNull);
      Exit;
      end;
   Operand1 := 1 / Operand1;
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   ShowError(sesInvalidOperand);
   Exit;
   end;

end;
9: // +/-
begin
   try
   Operand1 := -Operand1;
   ResEdit.Text := FloatToStr(Operand1);
   Oper := 0;
   except
   ShowError(sesInvalidOperand);
   Exit;
   end;

end;

10:
   begin
   // log
   try
   If Operand1 <= FloatNull then
      begin
     ShowError(sesInvalidOperand);
     Exit;
     end;

   Operand1 := log10(Operand1);
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   ShowError(sesInvalidOperand);
   Exit;
   end;
   end;

11:
   begin
   // sin
   try
   Operand1 := sin(Operand1);
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   end;
   end;
12:
   begin
   // cos
   try
   Operand1 := cos(Operand1);
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   end;
   end;
13:
   begin
   // sqr
   try
   Operand1 := sqr(Operand1);
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   end;
   end;
14:
   begin
   // cube
   try
   Operand1 := sqr(Operand1) * Operand1;
   ResEdit.Text := GetRoundFloat(Operand1);
   Oper := 0;
   except
   end;
   end;


end; // case of Oper

end;


procedure TsesCalc.SetMemButtonClick(Sender: TObject);
begin
try
MemOperand := StrToFloat(ResEdit.Text);
MemPanel.Caption := 'M';
MemSet:=True;
except
end;
end;

procedure TsesCalc.DelMemButtonClick(Sender: TObject);
begin
MemOperand := 0;
MemSet:=False;
MemPanel.Caption := '';
end;

procedure TsesCalc.ViewMemButtonClick(Sender: TObject);
begin
If MemSet then
   begin
   ResEdit.Text := GetRoundFloat(MemOperand);
   If InputToOne then
      Operand1 := MemOperand
      else
      Operand2 := MemOperand;
   end;
end;

procedure TsesCalc.PlusMemButtonClick(Sender: TObject);
begin
If MemSet then
   begin
   try
   Operand1 := StrToFloat(ResEdit.Text);
   MemOperand := MemOperand + Operand1;
   except
   end;
   end;

end;

procedure TsesCalc.MultiMemButtonClick(Sender: TObject);
begin
If MemSet then
   begin
   try
   Operand1 := StrToFloat(ResEdit.Text);
   MemOperand := MemOperand * Operand1;
   except
   end;
   end;


end;

procedure TsesCalc.sesCalcInit;
begin
CalcEdit:=nil;
Modified:=False;

PrimeValue := '0'+DecimalSeparator;
ResEdit.Text := PrimeValue;
OperPressed:=False;
InputToOne := True;

ResEdit.Hint := sesCalc_ResEdit_Hint;
CButton.Hint :=sesCalc_CButton_Hint;
CEButton.Hint :=sesCalc_CEButton_Hint;
BsButton.Hint :=sesCalc_BsButton_Hint;

sqrtButton.Hint :=sesCalc_sqrtButton_Hint;
PerButton.Hint :=sesCalc_PerButton_Hint;
InvXButton.Hint :=sesCalc_InvXButton_Hint;
InvSignButton.Hint :=sesCalc_InvSignButton_Hint;

st.Hint := sesCalc_st_Hint;

MemPanel.Hint :=sesCalc_MemPanel_Hint;
OperationPanel.Hint := sesCalc_OperationPanel_Hint;

RoundEdit.Hint:= sesCalc_Rounded_Hint;
udRound.Hint := sesCalc_Rounded_Hint;

ShowHints.Caption := sesCalc_ShowHints_Caption;

bComma.Hint :=sesCalc_bComma_Hint;
bCalc.Hint :=sesCalc_bCalc_Hint;
bPlus.Hint :=sesCalc_bPlus_Hint;
bMinus.Hint :=sesCalc_bMinus_Hint;
bDivide.Hint :=sesCalc_bDivide_Hint;
bMultiplay.Hint :=sesCalc_bMultiplay_Hint;
bPower.Hint :=sesCalc_bPower_Hint;

bLog.Hint :=sesCalc_bLog_Hint;
bSin.Hint :=sesCalc_bSin_Hint;
bCos.Hint :=sesCalc_bCos_Hint;
bXp2.Hint :=sesCalc_bXp2_Hint;
bXp3.Hint :=sesCalc_bXp3_Hint;

HistoryComboBox.Hint :=sesCalc_HistoryComboBox_Hint;

DelMemButton.Hint :=sesCalc_DelMemButton_Hint;
ViewMemButton.Hint :=sesCalc_ViewMemButton_Hint;
SetMemButton.Hint :=sesCalc_SetMemButton_Hint;
PlusMemButton.Hint :=sesCalc_PlusMemButton_Hint;
MultiMemButton.Hint :=sesCalc_MultiMemButton_Hint;

end;

procedure TsesCalc.Activate;
begin
Modified:=False;

PrimeValue := '0'+DecimalSeparator;
ResEdit.Text := PrimeValue;
OperPressed:=False;
InputToOne := True;
end;

procedure TsesCalc.b7Click(Sender: TObject);
begin
If OperPressed = True then
   begin
   OperPressed:=False;
   ResEdit.Text := PrimeValue;
   InputToOne := False;
   bComma.Down := False;
   end;
InsertDigit(Trim(TSpeedButton(Sender).Caption));
end;

procedure TsesCalc.bCalcClick(Sender: TObject);
var
I,N:Integer;
S:String;
begin
Modified:=True;
try
Case Oper Of
2: // power
  begin
  Operand1 := Power(Operand1,Operand2);
  ResEdit.Text := GetRoundFloat(Operand1);
  Oper := 0;

  end;
3: // /
  begin
    If abs(Operand2) <= FloatNull then
     begin
     ShowError(sesDivideByNull);
     Exit;
     end;

  Operand1 := Operand1 / Operand2;
  ResEdit.Text := GetRoundFloat(Operand1);
  end;
4: // *
  begin
  Operand1 := Operand1 * Operand2;
  ResEdit.Text := GetRoundFloat(Operand1);
  end;
5: // -
  begin
  Operand1 := Operand1 - Operand2;
  ResEdit.Text := GetRoundFloat(Operand1);
  end;

6: // +
  begin
  Operand1 := Operand1 + Operand2;
  ResEdit.Text := GetRoundFloat(Operand1);
  end;
7: // *
  begin
  Operand1 := (Operand1 * Operand2) / 100;
  ResEdit.Text := GetRoundFloat(Operand1);
  end;


end; // case of Oper

S:=Trim(ResEdit.Text);
I:=HistoryComboBox.Items.IndexOf(S);
If I = -1 then
   begin
   N:=HistoryComboBox.Items.Count;
   If N = CalcHistoryMax then
      HistoryComboBox.Items.Delete(N-1);
   HistoryComboBox.Items.Insert(0,S);   
   end;

except

end;
end;

procedure TsesCalc.aClearUpdate(Sender: TObject);
var
i,L:Integer;
begin
st.Panels[0].Text := GetRoundFloat(Operand1);
st.Panels[1].Text := GetRoundFloat(Operand2);
i:=Pos(DecimalSeparator,ResEdit.Text);
If i = 0 then Exit;
ResEdit.SelLength := 0;
L:=Length(ResEdit.Text);
If bComma.Down then
   begin
   ResEdit.SelStart := L;
   end
   else
   begin
   ResEdit.SelStart := i-1;
   end;
end;

procedure TsesCalc.aClearExecute(Sender: TObject);
begin
OperationPanel.Caption := '';
ResEdit.Text := PrimeValue;
Operand1 := 0;
Operand2 := 0;
Oper := 0;
bComma.Down := False;
InputToOne:=True;
end;

procedure TsesCalc.BsButtonClick(Sender: TObject);
var
j,L,L1:Integer;
S:String;
begin
If ResEdit.Text = PrimeValue then Exit;
j:= Pos(DecimalSeparator, ResEdit.Text);
L:=Length(ResEdit.Text);
If (j=0) then Exit;

If bComma.Down then
   begin
   If  Copy(ResEdit.Text,L, 1) = DecimalSeparator then Exit;;
   ResEdit.Text := Copy(ResEdit.Text,1, L-1);
   ResEdit.SelLength:=0;
   ResEdit.SelStart :=L-1;
   end
   else
   begin
   S:=Copy(ResEdit.Text, 1, j-1);
   L1:=Length(S)-1;
   If L1 = 0 then
      begin
      ResEdit.Text := PrimeValue;
      end
      else
      begin
      S:=Copy(S,1,L1);
      If S = '' then Exit;
      ResEdit.Text := S + Copy(ResEdit.Text,j, L);
      ResEdit.SelLength:=0;
      ResEdit.SelStart :=j-2;
      end;
   end;

     If InputToOne then
      Operand1 := StrToFloat(ResEdit.Text)
      else
      Operand2 := StrToFloat(ResEdit.Text);

end;

procedure TsesCalc.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
C:char;
begin
Case Key Of
VK_F12: ApplyResButtonClick(nil);
VK_F9 : bCalcClick(nil);
VK_BACK : BsButtonClick(nil);
VK_F8 :
           begin
           If not HistoryComboBox.DroppedDown then
              aClearExecute(nil)
              else
              begin
              HistoryComboBox.DroppedDown := False;
              ResEdit.SetFocus;
              end;
           end;
VK_DELETE : CEButtonClick(nil);
VK_F7 : InvSignButtonClick(InvSignButton);
end; // Case of Key
If ssCtrl in Shift then
   begin
   C:=chr(Key);
   Case C Of
   'L':DelMemButtonClick(nil);
   'R':ViewMemButtonClick(nil);
   'M':SetMemButtonClick(nil);
   'P':PlusMemButtonClick(nil);
   'U':MultiMemButtonClick(nil);
   end; // case of C
   end;
//Key:=0;
end;

procedure TsesCalc.FormKeyPress(Sender: TObject; var Key: Char);
var
sKey:String;
begin
sKey := Key;
sKey:=ANSIUpperCase(sKey);
Key:=sKey[1];
Case Key Of
'0':b7Click(b0);
'1':b7Click(b1);
'2':b7Click(b2);
'3':b7Click(b3);
'4':b7Click(b4);
'5':b7Click(b5);
'6':b7Click(b6);
'7':b7Click(b7);
'8':b7Click(b8);
'9':b7Click(b9);

'+':InvSignButtonClick(bPlus);
'-':InvSignButtonClick(bMinus);
'*':InvSignButtonClick(bMultiplay);
'/':InvSignButtonClick(bDivide);
'^':InvSignButtonClick(bPower);
'@':InvSignButtonClick(sqrtButton);
'%':InvSignButtonClick(PerButton);
'R':InvSignButtonClick(InvXButton);

'L':InvSignButtonClick(bLog);
'S':InvSignButtonClick(bSin);
'K':InvSignButtonClick(bXp2);
'U':InvSignButtonClick(bXp3);
'C':InvSignButtonClick(bCos);


else
begin
If sKey = DecimalSeparator then
   If bComma.Down then
      bComma.Down := False
      else
      bComma.Down := True;
end;
end; // Case of Key
Key := #0;
end;

procedure TsesCalc.ResEditKeyPress(Sender: TObject; var Key: Char);
begin
Key:=#0;
Exit;
end;

procedure TsesCalc.ShowHintsClick(Sender: TObject);
begin
If ShowHints.Checked then
   begin
   ShowHints.Checked := False;
   end
   else
   begin
   ShowHints.Checked := True;
   end;
BasePanel.ShowHint := ShowHints.Checked;
end;




procedure TsesCalc.HistoryComboBoxChange(Sender: TObject);
begin
ResEdit.SetFocus;
If Trim(HistoryComboBox.Text) = '' then Exit;
ResEdit.Text := HistoryComboBox.Text;
     If InputToOne then
      Operand1 := StrToFloat(ResEdit.Text)
      else
      Operand2 := StrToFloat(ResEdit.Text);

end;

procedure TsesCalc.ApplyResButtonClick(Sender: TObject);
var
D:Double;
I:Integer;
begin

try
D:=RoundExtended(StrToFloat(ResEdit.Text),udRound.Position);
except
If Application.MessageBox(PChar(sesCalc_ErrorMessage),PChar(sesCalc_Caption),
MB_ICONWARNING+MB_YESNO) = IDYES then
GetParentForm(Self).ModalResult := mrCancel;
Exit;
end;

If CalcEdit = nil then Exit;
Case CalcEdit.DataType Of
cdtString: CalcEdit.Text := Trim(ResEdit.Text);
cdtCardinal:
           begin
           I:= abs(Round(D));
           CalcEdit.Text := IntToStr(I);
           end;
cdtInteger:
           begin
           I:= Round(D);
           CalcEdit.Text := IntToStr(I);
           end;
cdtFloat:
           begin
           CalcEdit.Text := FloatToStr(D);
           end;
end; // Case Of EditControl.aDataType

end;

procedure TsesCalc.ShowError(aError:String);
begin
Modified := False;
Application.MessageBox(PChar(aError), PChar(sesCalc_Caption),
MB_ICONSTOP);
end;
end.
