unit sesDatePickerUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesSystem,sesStrings,sesEditUnit,StdCtrls, ExtCtrls, CheckLst, Buttons;

type

TValidSet=set of char;

TDateControl = record
  ValidDate:Boolean;
  DateText:String;
  ParsedDate:TParsedDate;
  yE1:TEdit; // editor of the first byte of Year
  yE2:TEdit;

  mE1:TEdit; // editor of the first byte of Month
  mE2:TEdit;

  dE1:TEdit; // editor of the first byte of Day
  dE2:TEdit;
  end;

  TsesDatePicker = class(TFrame)
    Panel1: TPanel;
    Year: TGroupBox;
    b1: TSpeedButton;
    b2: TSpeedButton;
    b6: TSpeedButton;
    b4: TSpeedButton;
    b7: TSpeedButton;
    b9: TSpeedButton;
    b3: TSpeedButton;
    b8: TSpeedButton;
    b10: TSpeedButton;
    b5: TSpeedButton;
    Day: TGroupBox;
    bd01: TSpeedButton;
    bd02: TSpeedButton;
    bd06: TSpeedButton;
    bd04: TSpeedButton;
    bd07: TSpeedButton;
    bd12: TSpeedButton;
    bd09: TSpeedButton;
    bd03: TSpeedButton;
    bd11: TSpeedButton;
    bd08: TSpeedButton;
    bd10: TSpeedButton;
    bd05: TSpeedButton;
    bd13: TSpeedButton;
    bd14: TSpeedButton;
    bd15: TSpeedButton;
    bd16: TSpeedButton;
    bd17: TSpeedButton;
    bd18: TSpeedButton;
    bd19: TSpeedButton;
    bd20: TSpeedButton;
    bd21: TSpeedButton;
    bd22: TSpeedButton;
    bd23: TSpeedButton;
    bd24: TSpeedButton;
    bd25: TSpeedButton;
    bd26: TSpeedButton;
    bd27: TSpeedButton;
    bd28: TSpeedButton;
    bd29: TSpeedButton;
    bd30: TSpeedButton;
    bd31: TSpeedButton;
    Month: TGroupBox;
    bm01: TSpeedButton;
    bm02: TSpeedButton;
    bm06: TSpeedButton;
    bm04: TSpeedButton;
    bm07: TSpeedButton;
    bm12: TSpeedButton;
    bm09: TSpeedButton;
    bm03: TSpeedButton;
    bm11: TSpeedButton;
    bm08: TSpeedButton;
    bm10: TSpeedButton;
    bm05: TSpeedButton;
    BackButton: TSpeedButton;
    FutureButton: TSpeedButton;
    P1: TPanel;
    E1: TEdit;
    E2: TEdit;
    P2: TPanel;
    E3: TEdit;
    E4: TEdit;
    P3: TPanel;
    E5: TEdit;
    E6: TEdit;
    bSetNow: TSpeedButton;
    procedure E1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure bd01Click(Sender: TObject);
    procedure bm01Click(Sender: TObject);
    procedure b1Click(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    procedure bSetNowClick(Sender: TObject);
  private
    { Private declarations }
    Years:array[1..10] of String;
    procedure RefreshButtons;
    procedure ChangeMonth;
    procedure ChangeYear;
    procedure DateChange;
    procedure FillYears(aYear:Word);

    procedure yE1KeyPress(Sender: TObject; var Key: Char);
    procedure yE2KeyPress(Sender: TObject; var Key: Char);

    procedure mE1KeyPress(Sender: TObject; var Key: Char);
    procedure mE2KeyPress(Sender: TObject; var Key: Char);

    procedure dE1KeyPress(Sender: TObject; var Key: Char);
    procedure dE2KeyPress(Sender: TObject; var Key: Char);

    procedure SetDownMonthButton;
  public
    { Public declarations }
  Edit:TsesCustomEdit;
  Editor:TsesCustomEditor;
  DateControl:TDateControl;
  procedure Init;
  procedure SetDateValue(const Value:String; SetNow:Boolean);
  function GetDateValue:String;
  end;



var
 sesDatePicker:TsesDatePicker;
 Days_1:set of char = [];
 Days_2:set of char = [];
 Month_1:set of char = [];
 Month_2:set of char = [];


implementation
{$R *.DFM}



function TsesDatePicker.GetDateValue:String;
begin
If DateControl.ValidDate then
   begin
   DateChange;
   Result := DateControl.DateText;
   end
   else
   Result := '';
end;


procedure TsesDatePicker.FillYears(aYear:Word);
var
I,J:Integer;
function YearToStr(Y:Integer):String;
var
U:String;
K:Integer;
begin
U:= IntToStr(Y);
K:= Length(U);
If K = 4 then
   Result := Copy(U,3,2)
   else
   Result := Copy(U,1,2);
If Length(Result) = 1 then Result := '0' + Result;
end;
begin
Years[5] := YearToStr(aYear);
J:=aYear;
for I := 6 to 10 do
    begin
    J:=J+1;
    If J >= 100 then
       J := J - 100;
    Years[I] := YearToStr(J);
    end;
J:=aYear;
for I := 4 downto 1 do
    begin
    J:=J-1;
    If J < 0 then
       J := J + 100;
    Years[I] := YearToStr(J);
    end;

b1.Caption := Years[1];
b2.Caption := Years[2];
b3.Caption := Years[3];
b4.Caption := Years[4];
b5.Caption := Years[5];
b6.Caption := Years[6];
b7.Caption := Years[7];
b8.Caption := Years[8];
b9.Caption := Years[9];
b10.Caption := Years[10];
b5.Down := True;
b5.Click;
end;

procedure TsesDatePicker.SetDateValue(const Value:String; SetNow:Boolean);
var
S:String;
Res:Integer;
begin
DateControl.DateText := Value;
Res := IsStringDate(Value,DateControl.ParsedDate);
If (Res < 0) and (SetNow) then
   begin
   S:=DateToStr(Date);
   Res := IsStringDate(S,DateControl.ParsedDate);
   DateControl.DateText := S;
   DateControl.ValidDate := True;
   end
   else
   If Res = 0 then
      begin
      DateControl.ValidDate := True;
      end
      else
      DateControl.ValidDate := False;

DateControl.yE1.Text := Copy(DateControl.ParsedDate.sYear,1,1);
DateControl.yE2.Text := Copy(DateControl.ParsedDate.sYear,2,1);

DateControl.mE1.Text := Copy(DateControl.ParsedDate.sMonth,1,1);
DateControl.mE2.Text := Copy(DateControl.ParsedDate.sMonth,2,1);

DateControl.dE1.Text := Copy(DateControl.ParsedDate.sDay,1,1);
DateControl.dE2.Text := Copy(DateControl.ParsedDate.sDay,2,1);


Case Res Of
0:
  begin
  DateControl.ValidDate := True;
  end;
end; // Case Res Of
S:=ANSIUpperCase(ShortDateFormat);
  Case S[1] of
  'Y': DateControl.yE1.SetFocus;
  'M': DateControl.mE1.SetFocus;
  'D': DateControl.dE1.SetFocus;
  end; // Case ShortDateFormat[1]

FillYears(DateControl.ParsedDate.Year);
RefreshButtons;
DateChange;
end;




procedure TsesDatePicker.ChangeMonth;
var
V:Word;
y1,m1:Word;
y,m:String;
begin
y:=DateControl.yE1.Text + DateControl.yE2.Text;
y1 := StrToInt(y);
m:=DateControl.mE1.Text + DateControl.mE2.Text;
m1 := StrToInt(m);
If (m1 >= 1) and (m1 <= 12) then
   V:=MonthDays[IsLeapYear(y1), m1]
   else
   V:=0;
Case V Of
28:
   begin
   bd29.Enabled := False;
   bd30.Enabled := False;
   bd31.Enabled := False;
   end;
29:
   begin
   bd29.Enabled := True;
   bd30.Enabled := False;
   bd31.Enabled := False;
   end;
30:
   begin
   bd29.Enabled := True;
   bd30.Enabled := True;
   bd31.Enabled := False;
   end;
0,31:
   begin
   bd29.Enabled := True;
   bd30.Enabled := True;
   bd31.Enabled := True;
   end;

end; // Case MonthDays

end;

procedure TsesDatePicker.DateChange;
var
m:Word;
S:String;
Res:Integer;
Dd:TDateTime;
begin
S:=ANSIUpperCase(ShortDateFormat);
  Case S[1] of
  'Y': DateControl.DateText := DateControl.yE1.Text + DateControl.yE2.Text +
       DateSeparator + DateControl.mE1.Text + DateControl.mE2.Text +
       DateSeparator + DateControl.dE1.Text + DateControl.dE2.Text;
  'M': DateControl.DateText := DateControl.mE1.Text + DateControl.mE2.Text +
       DateSeparator + DateControl.dE1.Text + DateControl.dE2.Text +
       DateSeparator +DateControl.yE1.Text + DateControl.yE2.Text;
  'D': DateControl.DateText := DateControl.dE1.Text + DateControl.dE2.Text +
       DateSeparator + DateControl.mE1.Text + DateControl.mE2.Text +
       DateSeparator +DateControl.yE1.Text + DateControl.yE2.Text;
  end; // Case ShortDateFormat[1]
Res := IsStringDate(DateControl.DateText, DateControl.ParsedDate);
DateControl.ValidDate := (Res = 0);
m:=DateControl.ParsedDate.Month;
If (m >=1) and (m <= 12) then
   begin
   S:= LongMonthNames[m];
   Month.Caption := sesDatePicker_Month+' : '+S+' ';
   end
   else
   Month.Caption := sesDatePicker_Month+' : '+sesDatePicker_WrongMonth;

   If Res = 0 then
      begin
      Dd := StrToDateTime(DateControl.DateText);
      m:= DayOfWeek(Dd);
      If (m>=1) and (m<=7) then
         Day.Caption := sesDatePicker_Day +' : ' + sesDatePicker_Days[m]
         else
         Day.Caption := sesDatePicker_Day+' : '+sesDatePicker_WrongDay;
      end
      else
      Day.Caption := sesDatePicker_Day+' : '+sesDatePicker_WrongDay;

end;

procedure TsesDatePicker.Init;
var
S:String;
begin
Edit := nil;
Editor:=nil;

S:=ANSIUpperCase(ShortDateFormat);
Case S[1] Of
'Y': // y/m/d
    begin
    DateControl.yE1 := E1;
    DateControl.yE2 := E2;

    DateControl.mE1 := E3;
    DateControl.mE2 := E4;

    DateControl.dE1 := E5;
    DateControl.dE2 := E6;


   P1.Caption := sesDatePicker_yy;
   P3.Caption := sesDatePicker_dd;
   P2.Caption := sesDatePicker_mm;

    end;

'M':  // m/d/y
    begin
    DateControl.yE1 := E5;
    DateControl.yE2 := E6;

    DateControl.mE1 := E1;
    DateControl.mE2 := E2;

    DateControl.dE1 := E3;
    DateControl.dE2 := E4;

   P3.Caption := sesDatePicker_yy;
   P2.Caption := sesDatePicker_dd;
   P1.Caption := sesDatePicker_mm;

    end;
'D': // d/m/y
    begin
    DateControl.yE1 := E5;
    DateControl.yE2 := E6;

    DateControl.mE1 := E3;
    DateControl.mE2 := E4;

    DateControl.dE1 := E1;
    DateControl.dE2 := E2;

   P3.Caption := sesDatePicker_yy;
   P1.Caption := sesDatePicker_dd;
   P2.Caption := sesDatePicker_mm;

    end;
else
begin
// sets the US date format
    DateControl.yE1 := E5;
    DateControl.yE2 := E6;

    DateControl.mE1 := E1;
    DateControl.mE2 := E2;

    DateControl.dE1 := E3;
    DateControl.dE2 := E4;

   P3.Caption := sesDatePicker_yy;
   P2.Caption := sesDatePicker_dd;
   P1.Caption := sesDatePicker_mm;

end;

end; // Case ShortDateFormat[1] Of

bSetNow.Caption:= sesDatePicker_Now;
Year.Caption := sesDatePicker_Year;
Month.Caption := sesDatePicker_Month;
Day.Caption := sesDatePicker_Day;

DateControl.yE1.OnKeyPress :=yE1KeyPress;
DateControl.yE2.OnKeyPress :=yE2KeyPress;
DateControl.yE1.Text := '0';
DateControl.yE1.Text := '0';

DateControl.mE1.OnKeyPress :=mE1KeyPress;
DateControl.mE2.OnKeyPress :=mE2KeyPress;
DateControl.mE1.Text := '0';
DateControl.mE1.Text := '0';

DateControl.dE1.OnKeyPress :=dE1KeyPress;
DateControl.dE2.OnKeyPress :=dE2KeyPress;
DateControl.dE1.Text := '0';
DateControl.dE1.Text := '0';

end;

procedure TsesDatePicker.E1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
E:TEdit;
begin
Case Key Of
VK_Right:
         begin
         Key:=0;
         GetParentForm(Self).Perform(WM_NEXTDLGCTL, 0, 0);
         end;
VK_Left:
         begin
         Key:=0;
         E:=TEdit(Sender);
         Case E.Tag of
         1: E6.SetFocus;
         2: E1.SetFocus;
         3: E2.SetFocus;
         4: E3.SetFocus;
         5: E4.SetFocus;
         6: E5.SetFocus;
         end; // Case of tag
         end;

end; // case Of Key
end;

procedure TsesDatePicker.yE1KeyPress(Sender: TObject; var Key: Char);
begin
If not (Key in ['0'..'9']) then
  begin
  Key:=#0;
  Exit;
  end;
  DateControl.yE1.Text := Key;
  ChangeYear;
  DateControl.yE2.SetFocus;
end;

procedure TsesDatePicker.yE2KeyPress(Sender: TObject; var Key: Char);
var
S:String;
begin
If not (Key in ['0'..'9']) then
  begin
  Key:=#0;
  Exit;
  end;
  DateControl.yE2.Text := Key;
  ChangeYear;

S:=ANSIUpperCase(ShortDateFormat);
  Case S[1] of
  'Y': DateControl.mE1.SetFocus;
  'M': DateControl.mE1.SetFocus;
  'D': DateControl.dE1.SetFocus;
  end; // Case ShortDateFormat[1]

end;


procedure TsesDatePicker.SetDownMonthButton;
var
S:String;
I:Integer;
B:TSpeedButton;
begin
S :='bm'+ DateControl.mE1.Text+DateControl.mE2.Text;
for I:=0 to Month.ControlCount-1 do
   begin
   If Month.Controls[I] is TSpeedButton then
      begin
      B:=TSpeedButton(Month.Controls[I]);
      If B.Name = S then
         begin
         B.Down := True;
         end;
      end;

   end;
end;


procedure TsesDatePicker.mE1KeyPress(Sender: TObject; var Key: Char);
begin
If not (Key in ['0'..'1']) then
  begin
  Key:=#0;
  Exit;
  end;
  DateControl.mE1.Text := Key;
  DateChange;
  ChangeMonth;
  SetDownMonthButton;
  DateControl.mE2.SetFocus;
end;

procedure TsesDatePicker.mE2KeyPress(Sender: TObject; var Key: Char);
var
S:String;
begin
If not (Key in ['0'..'9']) then
  begin
  Key:=#0;
  Exit;
  end;
  DateControl.mE2.Text := Key;
  DateChange;
  ChangeMonth;
  SetDownMonthButton;
S:=ANSIUpperCase(ShortDateFormat);
  Case S[1] of
  'Y': DateControl.dE1.SetFocus;
  'M': DateControl.dE1.SetFocus;
  'D': DateControl.yE1.SetFocus;
  end; // Case ShortDateFormat[1]

end;

procedure TsesDatePicker.dE1KeyPress(Sender: TObject; var Key: Char);
begin
If not (Key in ['0'..'3']) then
  begin
  Key:=#0;
  Exit;
  end;
  DateControl.dE1.Text := Key;
  DateChange;
  DateControl.dE2.SetFocus;
  RefreshButtons;
end;

procedure TsesDatePicker.dE2KeyPress(Sender: TObject; var Key: Char);
var
S:String;
begin
If not (Key in ['0'..'9']) then
  begin
  Key:=#0;
  Exit;
  end;
  DateControl.dE2.Text := Key;
  DateChange;
S:=ANSIUpperCase(ShortDateFormat);
  Case S[1] of
  'Y': DateControl.yE1.SetFocus;
  'M': DateControl.yE1.SetFocus;
  'D': DateControl.mE1.SetFocus;
  end; // Case ShortDateFormat[1]
  RefreshButtons;
end;

procedure TsesDatePicker.bd01Click(Sender: TObject);
var
B:TSpeedButton;
begin
B:=TSpeedButton(Sender);
DateControl.dE1.Text:=Copy(B.Name,3,1);
DateControl.dE2.Text:=Copy(B.Name,4,1);
DateChange;
end;


procedure TsesDatePicker.bm01Click(Sender: TObject);
var
B:TSpeedButton;
begin
B:=TSpeedButton(Sender);
DateControl.mE1.Text:=Copy(B.Name,3,1);
DateControl.mE2.Text:=Copy(B.Name,4,1);
DateChange;
ChangeMonth;
end;

procedure TsesDatePicker.b1Click(Sender: TObject);
var
B:TSpeedButton;
S:String;
begin
B:=TSpeedButton(Sender);
S:=B.Caption;
DateControl.yE1.Text := Copy(S,1,1);
DateControl.yE2.Text := Copy(S,2,1);
{
ResetMonthButtons;
RefreshDayButtons;
}
end;

procedure TsesDatePicker.ChangeYear;
var
Y:Word;
begin
try
Y:= StrToInt(DateControl.yE1.Text + DateControl.yE2.Text);
FillYears(Y);
{
ResetMonthButtons;
RefreshDayButtons;
}
except
DateControl.yE2.SetFocus;
end;
end;
procedure TsesDatePicker.BackButtonClick(Sender: TObject);
var
Y:Word;
J:Integer;
S:String;
begin
S := Years[5];
Y:= StrToInt(S);
If Sender = BackButton then
   begin
   J := Y - 4;
   If J < 0 then
      J := J + 100;
   Y := J;
   end
   else
   begin
   J := Y + 5;
   If J >= 100 then
      J := J - 100;
   Y := J;
   end;
FillYears(Y);

end;

procedure TsesDatePicker.bSetNowClick(Sender: TObject);
begin
SetDateValue('',True);
DateChange;
end;

procedure TsesDatePicker.RefreshButtons;
var
B:TSpeedButton;
I:Integer;
sM,sD:String;
begin
sM:= DateControl.mE1.Text + DateControl.mE2.Text;
for I:=0 to Month.ControlCount-1 do
    begin
    If Month.Controls[I] is TSpeedButton then
       begin
       B:= TSpeedButton(Month.Controls[I]);
       If B.Name = 'bm'+sM then
          begin
          B.Down := True;
          Break;
          end;
       end;
    end;
sD:= DateControl.dE1.Text + DateControl.dE2.Text;
for I:=0 to Day.ControlCount-1 do
    begin
    If Day.Controls[I] is TSpeedButton then
       begin
       B:= TSpeedButton(Day.Controls[I]);
       If B.Name = 'bd'+sD then
          begin
          B.Down := True;
          Break;
          end;
       end;
    end;

end;


end.
