unit sesEditorUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesSystem,Menus,buttons,stdctrls,ExtCtrls;

const
sesFalse = '0';
sesTrue='1';

type

TClassicEditControlOption = (goCanExitOnError, goCheckChar, goCheck);
TClassicEditControlOptions = set of TClassicEditControlOption;



TClassicRange = record
  ControlRange:Boolean;
  MaxOrTrue:String;
  MinOrFalse:String;
  end;

TOnEditButtonClick = procedure(Sender: TObject; ScreenPopUpPoint,FormPopUpPoint:TPoint;
var aSource:String; var Changed:Boolean) of object;

TOnErrorKey = procedure(Sender: TObject;
var Key:Char; var Replace:Boolean) of object;


//   helper
TClassicHelper = class;


//   -
  TsesCustomEditor = class(TCustomEdit)
  private
    { Private declarations }
  FCheckTextResult:TEditErrorType;
  FCanLoseFocus:Boolean;
  FRanged:Boolean;
  FRangeMinOrFalse:String;
  FRangeMaxOrTrue:String;
//  FButtonKind:TEditButtonKind;
  FEnterAsTab:Boolean;
  FErrorSoundType:TErrorSound;
  FOnErrorKey:TOnErrorKey;
  FShowErrorWindow:Boolean;

  FFocusPassedOn:Boolean;

//  FOnButtonClick:TNotifyEvent;


  FOnEditButtonClick:TOnEditButtonClick;
  FButtonHotKey:TShortCut;

  FClassicDataType:TClassicDataType;

  FClassicHelper:TClassicHelper;

  procedure OnInternalButtonClick(Sender:TObject);
  function GetMinHeight: Integer;

//  procedure SetEditButtonKind(Value:TEditButtonKind);

  function GetEditEnabled:Boolean;


  procedure SetClassicDataType(Value:TClassicDataType);


  function IsValidChar(Key: Char): Boolean;
  protected
    { Protected declarations }
  procedure FocusPassOn;
  procedure ActivateCharCheckPopUpForm(Key:Char);


//  property ClassicHelper:TClassicHelper read FClassicHelper write FClassicHelper;

  property ShowErrorWindow:Boolean read   FShowErrorWindow write   FShowErrorWindow;
  property ErrorSoundType:TErrorSound read FErrorSoundType write FErrorSoundType;
  property OnErrorKey:TOnErrorKey read FOnErrorKey write FOnErrorKey;


  property EnterAsTab:Boolean read FEnterAsTab write FEnterAsTab;

//  property ButtonKind:TEditButtonKind read FButtonKind write SetEditButtonKind;
  property ButtonHotKey:TShortCut read FButtonHotKey write FButtonHotKey;
  property OnEditButtonClick:TOnEditButtonClick read FOnEditButtonClick write FOnEditButtonClick;



//  procedure Loaded; override;
  function IsStringBoolean:Boolean;
  procedure CreateParams(var Params: TCreateParams); override;
  procedure CreateWnd; override;
  procedure WMSize(var Message: TWMSize); message WM_SIZE;
  procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  procedure KeyPress(var Key: Char); override;
  procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
  procedure CMExit(var Message: TCMExit);   message CM_EXIT;
  procedure CEOperation(var Message: TWMKey); message CM_DIALOGKEY;

  procedure ActivateErrorWindow;
  procedure DeActivateErrorWindow;
  public
    { Public declarations }
    property CanLoseFocus:Boolean read FCanLoseFocus write FCanLoseFocus;
    property CheckTextResult:TEditErrorType read FCheckTextResult write FCheckTextResult;
    property Color;
    property EditDataType:TClassicDataType read FClassicDataType write SetClassicDataType;
    property Font;
    property ParentFont;
    property Ranged:Boolean read FRanged write FRanged;
    property RangeMinOrFalse:String read FRangeMinOrFalse write FRangeMinOrFalse;
    property RangeMaxOrTrue:String read FRangeMaxOrTrue write FRangeMaxOrTrue;

//  property Button: TSpeedButton read FButton;
  constructor Create(AOwner:TComponent);override;
  // override this method for custom text check up
  function CheckText:TEditErrorType;virtual;

  published
    { Published declarations }
  end;

TClassicEdit = class(TsesCustomEditor)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Ranged;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BiDiMode;
    property BorderStyle;
    property BorderWidth;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property EditDataType;
    property EnterAsTab;
    property ErrorSoundType;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property RangeMinOrFalse;
    property RangeMaxOrTrue;
    property ReadOnly;
    property ShowErrorWindow;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
//    property OnEditButtonClick;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnErrorKey;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

TClassicEditPicker = class(TsesCustomEditor)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
  published
    { Published declarations }
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BiDiMode;
    property BorderStyle;
    property BorderWidth;
//    property ClassicHelper;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;

    property EditDataType;
    property EnterAsTab;
    property ErrorSoundType;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowErrorWindow;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEditButtonClick;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnErrorKey;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

//   helper
TClassicHelper = class(TCustomPanel)
    private
    FClassicEdit:TClassicEdit;
    end;

//procedure Register;

var
// Global variables

LastEdit:TsesCustomEditor=nil; // last operational edit


implementation

uses sesAdviseUnit;



{TsesCustomEditor}
constructor TsesCustomEditor.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
//Height := 30;

Autosize := True;
Width := 121;

FFocusPassedOn:= False;

{
 FLabel:=TLabel.Create(Self);
 FLabel.Name:='EditLabel';
 FLabel.Align := alLeft;
// FLabel. Left :=1;
// FLabel.Top :=1;
 FLabel.Parent := Self;
 FLabel.Caption := 'EditLabel';//Self.Name;
 FLabel.Transparent := False;
}
{
  FButton := TSpeedButton.Create (Self);
  FButton.Name:='Button';
  FButton.Width := 20;
  FButton.Visible := False;
  FButton.Cursor:=crArrow;
  FButton.Parent := Self;
//  FButton.Glyph := nil;
//  FButton.Glyph.Handle := LoadBitmap(HInstance, 'EMPTY');
//  FButtonKind:=ebkCustom;
//  FButton.NumGlyphs := 1;
  FButton.Spacing :=0;
  FButton.Margin:=-1;
  FButton.OnClick := OnInternalButtonClick;
}
//   
FClassicDataType := ftString;
FEnterAsTab := True;
FButtonHotKey:=TextToShortCut('F12');
FClassicHelper := nil;
FShowErrorWindow := True;
FErrorSoundType:=essNone;
FCanLoseFocus := False;
FShowErrorWindow := True;
//ControlStyle := ControlStyle - [csSetCaption];

end;

procedure TsesCustomEditor.SetClassicDataType(Value:TClassicDataType);
begin
If Value <> FClassicDataType then
   begin
   FClassicDataType := Value;
   Case FClassicDataType Of
   ftString:;
   ftBoolean: If not IsStringBoolean then
              begin
              If (FRangeMinOrFalse = '') and (FRangeMaxOrTrue = '') then
                 begin
                 FRangeMinOrFalse := sesFalse;
                 FRangeMaxOrTrue := sesTrue;
                 end;
              Text := FRangeMinOrFalse;
              end;
   ftCardinal: If not (IsStringCardinal(Text) = 0) then Text := '0';
   ftInteger: If not (IsStringInteger(Text) = 0) then Text := '0';
   ftFloat: If not (IsStringFloat(Text) = 0) then Text := '0';
   end; // Case Of FClassicDataType

   end;
end;


{
procedure TsesCustomEditor.SetEditRect;
var
  Loc: TRect;
begin
  SendMessage(Handle, EM_GETRECT, 0, LongInt(@Loc));
  If FButtonVisible then
  begin
  Loc.Bottom := ClientHeight + 1;
  Loc.Right := ClientWidth - FButton.Width - 4;
  Loc.Top := 0;
  Loc.Left := 0;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
  FButton.Top := 0;
  FButton.Height := ClientHeight + 1;
  FButton.Left := ClientWidth - FButton.Width;
  end
  else
  begin
  Loc.Bottom := ClientHeight + 1;
  Loc.Right := ClientWidth;
  Loc.Top := 0;
  Loc.Left := 0;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
  end;

end;
}
{
procedure TsesCustomEditor.SetButtonVisible(Value:Boolean);
begin
If Value <> FButtonVisible then
   begin
   FButtonVisible:=Value;
   If FButtonVisible then
      begin
  FButton := TSpeedButton.Create (Self);
  FButton.Name:='Button';
  FButton.Width := 20;
  FButton.Visible := False;
  FButton.Cursor:=crArrow;
  FButton.Parent := Self;
//  FButton.Glyph := nil;
//  FButton.Glyph.Handle := LoadBitmap(HInstance, 'EMPTY');
//  FButtonKind:=ebkCustom;
//  FButton.NumGlyphs := 1;
  FButton.Spacing :=0;
  FButton.Margin:=-1;
  FButton.OnClick := OnInternalButtonClick;
      end
      else
      begin
      FButton.Free;
      end;
   SetEditRect;
   Invalidate;
   end;
end;
}
procedure TsesCustomEditor.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
{  Params.Style := Params.Style and not WS_BORDER;  }
  Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN;
end;

procedure TsesCustomEditor.CreateWnd;
begin
  inherited CreateWnd;
end;

function TsesCustomEditor.GetMinHeight: Integer;
var
  DC: HDC;
  SaveFont: HFont;
  I: Integer;
  SysMetrics, Metrics: TTextMetric;
begin
  DC := GetDC(0);
  GetTextMetrics(DC, SysMetrics);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  I := SysMetrics.tmHeight;
  if I > Metrics.tmHeight then I := Metrics.tmHeight;
  Result := Metrics.tmHeight + I div 4 + GetSystemMetrics(SM_CYBORDER) * 4 + 2;
end;

procedure TsesCustomEditor.WMSize(var Message: TWMSize);
begin
  inherited;
end;

{
procedure TsesCustomEditor.SetEditButtonKind(Value:TEditButtonKind);
begin
If Value <> FButtonKind then
   begin
   FButtonKind := Value;
// (ebkNone,ebkCustom,ebkToggle,ebkDropDown,ebkForm,ebkOpen);
   Case FButtonKind Of
   ebkNone: FButton.Glyph.Handle := LoadBitmap(HInstance, 'EMPTY');
   ebkCustom:;
   ebkToggle: FButton.Glyph.Handle := LoadBitmap(HInstance, 'TOGGLE');
   ebkDropDown: FButton.Glyph.Handle := LoadBitmap(HInstance, 'DOWN');
   ebkForm: FButton.Glyph.Handle := LoadBitmap(HInstance, 'FORM');
   ebkOpen: FButton.Glyph.Handle := LoadBitmap(HInstance, 'OPEN');

        end; // Case Of FButtonKind
   Invalidate;
   end;
end;
}
function TsesCustomEditor.GetEditEnabled:Boolean;
begin
Result := Enabled;
end;

{
procedure TsesCustomEditor.SetEditEnabled(Value:Boolean);
begin
Enabled := Value;
     If FButton <> nil then
        begin
        FButton.Enabled := Value;
        end;
Invalidate;
end;
}
{
function TsesCustomEditor.GetButtonFlat:Boolean;
begin
Result := FButton.Flat;
end;
}
{
procedure TsesCustomEditor.SetButtonFlat(Value:Boolean);
begin
     If FButton <> nil then
        begin
        FButton.Flat := Value;
        end;
Invalidate;
end;


function TsesCustomEditor.GetButtonCaption:String;
begin
     If FButton <> nil then
        begin
        Result := FButton.Caption;
        end;
end;

procedure TsesCustomEditor.SetButtonCaption(Value:String);
begin
     If FButton <> nil then
        begin
        FButton.Caption := Value;
        Invalidate;
        end;
end;

function TsesCustomEditor.GetButtonWidth:Integer;
begin
     If FButton <> nil then
        begin
        Result := FButton.Width;
        end;
end;

procedure TsesCustomEditor.SetButtonWidth(Value:Integer);
begin

FButton.Width := Value;
SetEditRect;
Invalidate;
end;

function TsesCustomEditor.GetButtonLayout:TButtonLayout;
begin
     If FButton <> nil then
        begin
        Result := FButton.Layout;
        end;
end;

procedure TsesCustomEditor.SetButtonLayout(Value:TButtonLayout);
begin

FButton.Layout := Value;
Invalidate;
end;



function TsesCustomEditor.GetButtonGlyph:TBitMap;
begin
  Result := FButton.Glyph;
end;

procedure TsesCustomEditor.SetButtonGlyph(Value:TBitMap);
begin
  if Value <> nil then
    FButton.Glyph := Value
  else
  begin
    FButton.Glyph.Handle := LoadBitmap(HInstance, 'EMPTY');
    FButton.NumGlyphs := 1;
    FButton.Invalidate;
  end;
end;



function TsesCustomEditor.GetButtonNumGlyphs: TNumGlyphs;
begin
  Result := FButton.NumGlyphs;
end;

procedure TsesCustomEditor.SetButtonNumGlyphs(Value: TNumGlyphs);
begin
  FButton.NumGlyphs := Value;
end;
}
procedure TsesCustomEditor.KeyDown(var Key: Word; Shift: TShiftState);
var
F:TCustomForm;
aKey:Word;
aShift:TShiftState;
begin
ShortCutToKey(FButtonHotKey,aKey,aShift);
If (aKey = Key) and (aShift = Shift) then
   begin
   OnInternalButtonClick(Self);
   Key:=0;
   end;
Case Key Of
VK_UP,VK_DOWN:
              begin
              //
              OnInternalButtonClick(Self);
              Key:=0;
              end;
VK_ESCAPE:
              begin
              UnDo;
              Key:=0;
              end;
VK_RETURN:
              begin
              If FEnterAsTab then
                begin
                Key:=0;
                F:=GetParentForm(Self);
                           //Self.Perform(CM_EXIT, 0, 0);
                CheckTextResult := CheckText;
                If not (CheckTextResult = ceOK) then
                   begin
                   ActivateErrorWindow;
                   If FCanLoseFocus then
                      F.Perform(WM_NEXTDLGCTL, 0, 0);
                      // a OnExit procedure will be executed, if assigned...
                   Exit;
                   end
                   else
                   begin
                   FCanLoseFocus := True;
                   F.Perform(WM_NEXTDLGCTL, 0, 0);
                   end;

                end; // EnterAsTab
            end; // Enter
else
inherited KeyDown(Key, Shift);
end; // Case Of Key
end;

procedure TsesCustomEditor.KeyPress(var Key: Char);
var
Replace:Boolean;
Mess:TPopUpMessage;
begin
DeActivateErrorWindow;
If (Key = #13) then
    begin
    Key := #0;
    end
    else
    begin
  if not IsValidChar(Key) then
          begin
          if Assigned(FOnErrorKey) then
             begin
             Replace:=False;
             FOnErrorKey(Self,Key,Replace);
             If not Replace then
                begin
                Key:=#0;
                end;
             end
             else
             begin
             If FShowErrorWindow then
                begin
                ActivateCharCheckPopUpForm(Key);
                end;
             Key := #0;
             Case FErrorSoundType Of
             essNone:;
             essBeep: Beep;
             essSystemExclamation:MessageBeep(MB_ICONEXCLAMATION);
             essSystemQuestion:MessageBeep(MB_ICONQUESTION);
               end; // Case ErrorSoundType
             end; // not assigned
          end;
  if Key <> #0 then inherited KeyPress(Key);
    end;

end;

function TsesCustomEditor.IsValidChar(Key: Char): Boolean;
begin
Case FClassicDataType Of
ftString: Result:=True;
ftBoolean: Result:=True;
ftCardinal: Result := (Key in CardinalSymbolSet);
ftInteger: Result := (Key in IntegerSymbolSet);
ftFloat: Result := (Key in FloatSymbolSet);
end; // Case Of FClassicDataType

  Result := Result or (Key < #32);
  if not Enabled and Result and ((Key >= #32) or
      (Key = Char(VK_BACK)) or (Key = Char(VK_DELETE))) then
    Result := False;
end;

function TsesCustomEditor.IsStringBoolean:Boolean;
begin
If (Text=FRangeMinOrFalse) or (Text=FRangeMaxOrTrue) then
   Result := True
   else
   Result:=False;
end;

procedure TsesCustomEditor.CMEnter(var Message: TCMGotFocus);
begin
If AutoSelect then
SelectAll;
inherited;
end;

// check up the Text Value for format errors...
function TsesCustomEditor.CheckText:TEditErrorType;
var
Check:Boolean;
begin
Result:=ceOK;
Case FClassicDataType Of
ftString: Result := ceOK;
ftCardinal:
           begin
           Check := IsStringCardinal(Self.Text) = 0;
           If Check then
              Result := ceOK
              else
              Result := ceNumber;
           end;
ftInteger:
           begin
           Check := IsStringInteger(Self.Text) = 0;
           If Check then
              Result := ceOK
              else
              Result := ceNumber;
           end;

ftBoolean:
           begin
           Check := IsStringBoolean;
           If Check then
              Result := ceOK
              else
              Result := ceBoolean;
           end;
ftFloat:
           begin
           Check := IsStringFloat(Self.Text) = 0;
           If Check then
              Result := ceOK
              else
              Result := ceNumber;
           end;

end; // Case Of FClassicDataType
If not (Result = ceOK) then
       begin
       Exit;
       end;
If FRanged then
      begin
Case FClassicDataType Of
ftString: Result := ceOK;
ftCardinal,ftInteger:
    If IsIntegerInRange(Self.Text, FRangeMinOrFalse, FRangeMaxOrTrue) then
       Result := ceOK
       else
       Result := ceRange;
ftFloat:
    If IsFloatInRange(Self.Text, FRangeMinOrFalse, FRangeMaxOrTrue) then
       Result := ceOK
       else
       Result := ceRange;

end; // Case Of FClassicDataType
      end;


end;


procedure TsesCustomEditor.FocusPassOn;
var
F:TCustomForm;
begin
  F:=GetParentForm(Self);
  If F <> nil then
  begin
  FFocusPassedOn := True;
  F.Perform(WM_NEXTDLGCTL, 0, 0);
  end;

end;
procedure TsesCustomEditor.CMExit(var Message: TCMExit);
var
EditCompleted:Boolean;
begin
// Has edit completed with the right result?
CheckTextResult := CheckText;
EditCompleted := CheckTextResult = ceOK;
// can Edit lose focus?
If FCanLoseFocus or EditCompleted then
   begin
   // yes, it can. Then triiger this flag to False for the future...
   FCanLoseFocus := False;
   // a OnExit procedure will be executed, if assigned...
   //FocusPassOn;
   inherited;
   Exit;
   end
   else
   begin
   If not EditCompleted then ActivateErrorWindow;
   If FCanLoseFocus then
      begin
      FCanLoseFocus := False;
      // a OnExit procedure will be executed, if assigned...
      //FocusPassOn;
      inherited;
      Exit;

      end
      else
      SetFocus;
   end;


end;


procedure TsesCustomEditor.OnInternalButtonClick(Sender:TObject);
var
Form:TCustomForm;
FormPopUpPoint, ScreenPopUpPoint,P:TPoint;
Changed:Boolean;
aSource:String;
ParentControl:TWinControl;
begin
// internal procedure to process the event "Edit button pressed"
//     " "

//1. The first, the internal check-up format control will be executed for the declared field data type...
//1. -,        
CheckTextResult := CheckText;
If not (CheckTextResult = ceOK) then Exit;
// Format control has failed, there is no sense to continue

//2. The second, the external user's procedure will be executed
//2.    
If Assigned(FOnEditButtonClick) then
   begin
   aSource := Text;
   Changed := False;
   ParentControl:=Self.Parent;
   ScreenPopUpPoint.x:=0;
   ScreenPopUpPoint.y:=0;
   FormPopUpPoint.x:=0;
   FormPopUpPoint.y:=0;
   If ParentControl <> nil then
      begin
      P.x:= Self.Left;
      P.y:=Self.Top+Self.Height;
      ScreenPopUpPoint := ParentControl.ClientToScreen(P);
      Form:=GetParentForm(Self);
      If Form <> nil then
         FormPopUpPoint := Form.ScreenToClient(ScreenPopUpPoint);
      end;
   FOnEditButtonClick(Self, ScreenPopUpPoint, FormPopUpPoint, aSource, Changed);
   If Changed then
      Text := aSource;
   end
   else
   begin
//3. The third, internal process will be executed for some data types only...
   Case FClassicDataType Of
   ftBoolean:
             begin
             If Text = FRangeMaxOrTrue then
                Text := FRangeMinOrFalse
                else
                Text := FRangeMaxOrTrue;
             end;
        end; // Case Of FClassicDataType
   end;
end;

procedure TsesCustomEditor.ActivateErrorWindow;
var
ErrorType:TEditErrorType;
Key:Char;
begin
Key:='9';
{
If ValueCheckPopUpForm = nil then
   begin
   ValueCheckPopUpForm:=TValueCheckPopUpForm.Create(Application);
   end;
ValueCheckPopUpForm.ShowPopUp(Self);
//CanLoseFocus
  Case ValueCheckPopUpForm.ModalResult Of
  mrRetry: FCanLoseFocus:=False;
  mrCancel: FCanLoseFocus:=True;
  end; // Case ValueCheckPopUpForm.ModalResult Of
}
If sesAdviseForm = nil then
   begin
   sesAdviseForm:=TsesAdviseForm.Create(Application);
   end;
{
   Case FClassicDataType Of
   ftCardinal,ftInteger,ftFloat: ErrorType:=ceNumber;
   ftBoolean: ErrorType:=ceBoolean;
   end; // case of FClassicDataType
}
sesAdviseForm.ShowEditError(Self, Key, CheckTextResult);
//CanLoseFocus
  Case sesAdviseForm.ModalResult Of
  mrRetry: FCanLoseFocus:=False;
  mrCancel: FCanLoseFocus:=True;
  end; // Case CEAdviseForm.ModalResult Of

end;


procedure TsesCustomEditor.CEOperation(var Message: TWMKey);
begin
Case Message.CharCode Of
VK_IsEditCompleted:
  begin
  CheckTextResult := CheckText;
  If not (CheckTextResult = ceOK) then
     begin
     Message.Result := 1; // break broadcasting chain
     LastEdit:=Self; // pointer to last operational Edit
     end;

  end;
VK_SetFocusIfNotEditCompleted:
  begin
  If not (CheckText = ceOK) then
     begin
     If Focused then
                begin
                Message.Result := 1;
                LastEdit:=Self; // pointer to last operational Edit
                end
                else
                begin
                If CanFocus then
                   begin
                   Message.Result := 1;
                   SetFocus;
                   LastEdit:=Self; // pointer to last operational Edit
                   end;
                end;
     end;
  end;
end; // Case Of Message.Unused
inherited;

end;


procedure TsesCustomEditor.ActivateCharCheckPopUpForm(Key:Char);
begin
{
If CharCheckPopUpForm = nil then
   begin
   CharCheckPopUpForm := TCharCheckPopUpForm.Create(Application);
//   ClassicErrorWindow.Color := clInfoBk;
   end;
  CharCheckPopUpForm.ShowPopUp(Self,Key,FClassicDataType);
}
If sesAdviseForm = nil then
   begin
   sesAdviseForm := TsesAdviseForm.Create(Application);
//   ClassicErrorWindow.Color := clInfoBk;
   end;
  sesAdviseForm.ShowEditError(Self,Key,ceChar);

end;


procedure TsesCustomEditor.DeActivateErrorWindow;
begin

If ClassicErrorWindow = nil then Exit;
//ValueCheckPopUpForm.HideWindow;
{
If ClassicErrorWindow.Visible then
ClassicErrorWindow.ReleaseHandle;
}
end;

{TClassicEditPicker}
constructor TClassicEditPicker.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
end;



//procedure Register;
//begin
//  RegisterComponents('', [TClassicEdit,TClassicEditPicker]);

//end;


end.
