unit sesHistoryFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesSystem,sesStrings,sesEditUnit,StdCtrls, Buttons, ExtCtrls;

type
  TsesHistory = class(TFrame)
    SelectedPanel: TPanel;
    Panel2: TPanel;
    HistoryListBox: TListBox;
    HistoryRec: TStaticText;
    SelectedValue: TEdit;
    procedure HistoryListBoxClick(Sender: TObject);
    procedure ApplyHistoryClick(Sender: TObject);
    procedure HistoryListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure HistoryListBoxDblClick(Sender: TObject);
    procedure HistoryListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SelectedValueKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    HistoryEdit:TsesCustomEdit;
    HistoryEnabled:Boolean;
    HistorySelected:Boolean;

    procedure HistoryInit;
    procedure LoadHistory;
  end;

  var
  sesHistory:TsesHistory;

implementation

{$R *.DFM}
    procedure TsesHistory.HistoryInit;
    begin
    HistoryEdit := nil;
    SelectedPanel.Caption := sesHistory_Selected;
    SelectedValue.Text := sesNotSelected;
    end;

    procedure TsesHistory.LoadHistory;
    begin
    HistoryEnabled := False;
    HistorySelected:=False;
    If HistoryEdit = nil then Exit;
    If HistoryEdit.Logger = nil then
       begin
       HistoryListBox.Clear;
       HistoryListBox.Items.Add(sesHistory_SessionError);
       HistoryRec.Caption:='1'+sesFrom+'0';
       HistoryListBox.Enabled := False;
       Exit;
       end;
    If not HistoryEdit.Logger.Active then
       begin
       HistoryListBox.Clear;
       HistoryListBox.Items.Add(sesHistory_FileError_1+
       HistoryEdit.Logger.Name);
       HistoryListBox.Items.Add(sesHistory_ErrorVersion);
       Case HistoryEdit.Logger.Status Of
       1: HistoryListBox.Items.Add(sesLogger_1);
       2: begin
       HistoryListBox.Items.Add(sesLogger_2);
       HistoryListBox.Items.Add(HistoryEdit.Logger.FileName);
          end;
       3: begin
       HistoryListBox.Items.Add(sesLogger_3);
       HistoryListBox.Items.Add(HistoryEdit.Logger.DirDefault+' -> '+HistoryEdit.Logger.FileName);
          end;
       4: begin
       HistoryListBox.Items.Add(sesLogger_4);
       HistoryListBox.Items.Add(HistoryEdit.Logger.DirDefault+' -> '+HistoryEdit.Logger.FileName);
          end;
       5: begin
       HistoryListBox.Items.Add(sesLogger_5);
       HistoryListBox.Items.Add(HistoryEdit.Logger.DirDefault+' -> '+HistoryEdit.Logger.FileName);
          end;
       6: HistoryListBox.Items.Add(sesLogger_6);
       7: begin
       HistoryListBox.Items.Add(sesLogger_7);
       HistoryListBox.Items.Add(HistoryEdit.Logger.DirDefault+' -> '+HistoryEdit.Logger.FileName);
          end;
       end; // Case HistoryEdit.Logger.Status Of
       HistoryListBox.Enabled := False;
       HistoryRec.Caption:='1'+sesFrom+'0';
       Exit;
       end;
       HistoryEdit.Logger.GetHistoryList(HistoryEdit,HistoryListBox.Items);
    If HistoryListBox.Items.Count > 0 then
       begin
       HistoryEnabled := True;
       HistoryListBox.Enabled := True;
       HistoryListBox.ItemIndex := HistoryListBox.Items.Count-1;
       HistoryRec.Caption := sesTotal +
       IntToStr(HistoryListBox.Items.Count);

       //HistoryListBoxClick(nil);

       end
       else
       begin
       HistoryListBox.Clear;
       HistoryListBox.Items.Add(sesHistory_HistoryEmpty);
       HistoryListBox.Enabled := False;
       HistoryRec.Caption:='1'+sesFrom+'0';
       end;
    end;
procedure TsesHistory.HistoryListBoxClick(Sender: TObject);
var
I,N,M:Integer;
S:String;
begin
If not HistoryEnabled then Exit;
HistorySelected := True;

I:= HistoryListBox.ItemIndex;
If I = -1 then Exit;
N := HistoryListBox.Items.Count;
If N = 0 then Exit;
S := HistoryListBox.Items[I];
M:=Pos(LogFieldSeparator,S);
If M = 0 then
   SelectedValue.Text := S
   else
   begin
   SelectedValue.Text := Copy(S,M+1,500);
   end;
HistoryRec.Caption := IntToStr(I+1) + sesFrom+
       IntToStr(HistoryListBox.Items.Count);

end;

procedure TsesHistory.ApplyHistoryClick(Sender: TObject);
begin
Self.HistoryEdit.Text := SelectedValue.Text;
end;

procedure TsesHistory.HistoryListBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
Offset,M,W:Integer;
S,S1,S2:String;
begin
//
with (Control as TListBox).Canvas do
begin
FillRect(Rect);
S:= HistoryListBox.Items[Index];
Offset := 2;
M:=Pos(LogFieldSeparator,S);
If M = 0 then
   begin
   Font.Style := [fsBold];
   TextOut(Rect.Left + Offset, Rect.Top,S);
   end
   else
   begin
   W := TextWidth('31/12/2005 24:59:59'+LogFieldSeparator+' ');
   S1 := Copy(S,1, M) + ' ';
   S2:= Copy(S,M+1,500);
   Font.Style := [];
   TextOut(Rect.Left + Offset, Rect.Top,S1);
   Font.Style := [fsBold];
   TextOut(Rect.Left + Offset+W, Rect.Top,S2);
   Font.Style := [];
   end;

end; // With
end;

procedure TsesHistory.HistoryListBoxDblClick(Sender: TObject);
begin
If (HistoryEnabled) and (not Self.HistoryEdit.ReadOnly) then
    Self.HistoryEdit.Text := SelectedValue.Text;
GetParentForm(Self).ModalResult := mrRetry;
end;

procedure TsesHistory.HistoryListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   Case Key Of
   VK_RETURN:
                begin
                  GetParentForm(Self).ModalResult := mrRetry;
                  If HistoryEnabled then
                  sesHistory.HistoryEdit.Text := sesHistory.SelectedValue.Text;
                  Key:=0;
                  Exit;
                  end;

   end; // Case Of Key

end;

procedure TsesHistory.SelectedValueKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
Case Key Of
VK_UP,VK_DOWN:
               begin
               HistoryListBox.SetFocus;
               HistoryListBoxClick(nil);
               end;
end; // Case Key Of
end;

end.
