unit sesPickListFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesSystem,sesStrings,sesEditUnit,StdCtrls, Buttons, ExtCtrls, Grids,
  DBGrids, Db, sesDataSetUnit;

type
  TsesPickList = class(TFrame)
    PickListSelectedPanel: TPanel;
    Panel2: TPanel;
    PickListRec: TStaticText;
    PickListSelectedValue: TEdit;
    PickListListBox: TStringGrid;
    FoundPanel: TPanel;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure ApplyPickListClick(Sender: TObject);
    procedure PickListListBoxDblClick(Sender: TObject);
    procedure PickListListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PickListSelectedValueKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PickListListBoxSelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBGrid1Enter(Sender: TObject);
  private
    { Private declarations }
  protected
  procedure SelectItem(const ACol,ARow:Integer);
  public
    { Public declarations }
    PickListEdit:TsesCustomEdit;
    PickListEnabled:Boolean;
    PickListSelected:Boolean;
    Founded:Integer;
    procedure PickListInit;
    procedure LoadPickList;
    procedure ShowError(aError:String);
    function IsValueFounded(Edit:TsesCustomEdit):Integer;
    function GetPickListCaption(Edit:TsesCustomEdit; Full:Boolean):String;
  end;

  var
  sesPickList:TsesPickList;

implementation

{$R *.DFM}
    procedure TsesPickList.PickListInit;
    begin
    PickListEdit := nil;
    PickListSelectedPanel.Caption := sesPickList_Selected;
    PickListSelectedValue.Text := sesNotSelected;
    end;

    function TsesPickList.IsValueFounded(Edit:TsesCustomEdit):Integer;
    var
    I,N,F:Integer;
    Sep,S:String;
    V:Variant;
    begin
    Result := -1;
    If Edit = nil then Exit;
    If Edit.PickListKind <> plDataSet then
    begin
    If Edit.PickList = nil then Exit;
    If Edit.PickList.Count = 0 then Exit;
    end;
    Case Edit.PickListKind Of
    plStandard:
        begin
        Result := Edit.PickList.IndexOf(Edit.Text);
        end;
    plCodeCaption:
        begin
        Sep := Trim(Edit.PickListSeparator);
        If Sep = '' then Sep := ' ';
        N:=Edit.PickList.Count-1;
        for I:=0 to N do
            begin
            S:=Edit.PickList[I];
            F:= Pos(Sep,S);
            If F > 0 then
               S:= Copy(S,1,F-1);
            // got the Code value in the S
            If S = Edit.Text then
               begin
               Result := I;
               Exit;
               end;
            end;
        end; // CodeCaption
    plGrid:
        begin
        // now use the same algorithm as CodeCaption
        Sep := Trim(Edit.PickListSeparator);
        If Sep = '' then Sep := ' ';
        N:=Edit.PickList.Count-1;
        for I:=0 to N do
            begin
            S:=Edit.PickList[I];
            F:= Pos(Sep,S);
            If F > 0 then
               S:= Copy(S,1,F-1);
            // got the Code value in the S
            If S = Edit.Text then
               begin
               Result := I;
               Exit;
               end;
            end;
        end;
    plDataSet :
        begin
        If Edit.PickDataSet = nil then Exit;
        If Edit.PickDataSet.Active = False then Exit;
        If Edit.PickDataSet.RecordCount = 0 then Exit;
        try
        S:= Edit.PickDataSet.Fields[0].FieldName;
        V := Edit.Value;
        If Edit.PickDataSet.Locate(S,V,[]) then
           Result := Edit.PickDataSet.RecNo
           else
           Result := -1;
        except
        Exit;
        end;
        end;
    end; // Case Edit.PickListKind Of
    end;

    function TsesPickList.GetPickListCaption(Edit:TsesCustomEdit; Full:Boolean):String;
    var
    I,N,F:Integer;
    Sep,S,S1:String;
    V:Variant;
    begin
    Result := '';
    If Edit = nil then Exit;
    If Edit.PickListKind <> plDataSet then
    begin
    If Edit.PickList = nil then Exit;
    If Edit.PickList.Count = 0 then Exit;
    end;
    Case Edit.PickListKind Of
    plStandard:
        begin
        F := Edit.PickList.IndexOf(Edit.Text);
        If F > -1 then
           Result := Edit.PickList[F];
        end;
    plCodeCaption:
        begin
        Sep := Trim(Edit.PickListSeparator);
        If Sep = '' then Sep := ' ';
        N:=Edit.PickList.Count-1;
        for I:=0 to N do
            begin
            S:=Edit.PickList[I];
            F:= Pos(Sep,S);
            If F > 0 then
               begin
               S1 := Copy(S,F+1,500);
               S:= Copy(S,1,F-1);
               end
               else
               begin
               S1 := S;
               end;
            // get the Code value in the S
            If S = Edit.Text then
               begin
               Result := S1;
               Exit;
               end;
            end;
        end; // CodeCaption
    plGrid:
        begin
        Sep := Trim(Edit.PickListSeparator);
        If Sep = '' then Sep := ' ';
        N:=Edit.PickList.Count-1;
        for I:=0 to N do
            begin
            S:=Edit.PickList[I];
            F:= Pos(Sep,S);
            If F > 0 then
               begin
               S1 := Copy(S,F+1,1000);
               S:= Copy(S,1,F-1);
               end
               else
               begin
               S1 := S;
               end;
            // get the Code value in the S
            If S = Edit.Text then
               begin
               If not Full then
                  begin
                  F:= Pos(Sep,S1);
                  If F = 0 then
                     Result := S1
                     else
                     Result := Copy(S1,1, F-1);
                   end
                   else
                   Result := S1;

               Exit;
               end;
            end;
        end; // Grid
    plDataSet :
        begin
        If Edit.PickDataSet = nil then Exit;
        If Edit.PickDataSet.Active = False then Exit;
        If Edit.PickDataSet.RecordCount = 0 then Exit;
        If Edit.PickDataSet.FieldCount < 2 then Exit;
        try
        S:= Edit.PickDataSet.Fields[0].FieldName;
        V := Edit.Value;
        If Edit.PickDataSet.Locate(S,V,[]) then
           begin
           Result := '';
           If Full then
                        begin
           For I:=1 to Edit.PickDataSet.FieldCount-1 do
               begin
               If I = Edit.PickDataSet.FieldCount-1 then
                  Result := Result + Edit.PickDataSet.Fields[I].AsString
                  else
                  Result := Result + Edit.PickDataSet.Fields[I].AsString + ', ';
               end;
                        end
                        else
                        Result := Edit.PickDataSet.Fields[1].AsString;
           end
           else
           Exit;
        except
        Exit;
        end;
        end;
    end; // Case Edit.PickListKind Of
    end;

    procedure TsesPickList.ShowError(aError:String);
    begin
    DBGrid1.Visible := False;
    With PickListListBox do
    begin
    Visible := True;
    ColCount:=1;
    RowCount:=2;
    ColWidths[0]:= 300;
    Cells[0,0]:='';
    Cells[0,1]:=aError;
    PickListEnabled := False;
    end; // with
    end;

    procedure TsesPickList.LoadPickList;
    var
    I,J,N,F,W:Integer;
    Sep,S,S1:String;
    V:Variant;
    begin
    Founded := -1;
    PickListEnabled := False;
    PickListSelected:=False;
    DBGrid1.Visible := False;
    PickListListBox.Visible := False;
    If PickListEdit = nil then Exit;
    If PickListEdit.PickListKind = plNone then
       begin
       ShowError(sesPickList_ListIsNotAssigned);
       Exit;
       end;
    If PickListEdit.PickListKind <> plDataSet then
    begin
    If PickListEdit.PickList = nil then
       begin
       ShowError(sesPickList_Empty);
       PickListListBox.Enabled := False;
       Exit;
       end;
    If PickListEdit.PickList.Count = 0 then
       begin
       ShowError(sesPickList_Empty);
       PickListListBox.Enabled := False;
       Exit;
       end;
     end;
    try
    Case PickListEdit.PickListKind Of
    plStandard:
        begin
        PickListListBox.Visible := True;
        PickListListBox.ColCount := 1;
        PickListListBox.ColWidths[0] := PickListListBox.ClientWidth;
        PickListListBox.RowCount := PickListEdit.PickList.Count;
        PickListListBox.FixedRows:=0;

        PickListListBox.Cols[0].BeginUpdate;
        PickListListBox.Cols[0].Assign(PickListEdit.PickList);
        PickListListBox.Cols[0].EndUpdate;
        Founded := PickListListBox.Cols[0].IndexOf(PickListEdit.Text);
        PickListRec.Caption := sesTotal+': '+IntToStr(PickListEdit.PickList.Count);

        end;
   plCodeCaption:
     begin
        PickListListBox.Visible := True;
        PickListListBox.ColCount := 2;
        PickListListBox.ColWidths[0] := 120;
        PickListListBox.ColWidths[1] := PickListListBox.Width - 120;
        PickListListBox.RowCount := PickListEdit.PickList.Count+1;
        PickListListBox.FixedRows:=1;

//        PickListListBox.Cols[0].BeginUpdate;

        Sep := Trim(PickListEdit.PickListSeparator);
        If Sep = '' then Sep := ' ';
        N:=PickListEdit.PickList.Count-1;
        for I:=0 to N do
            begin
            S:=PickListEdit.PickList[I];
            F:= Pos(Sep,S);
            If F > 0 then
               begin
               S1:=Copy(S,F+1,200);
               S:= Copy(S,1,F-1);
               end
               else
               begin
               S1:='';
               end;
            // got the Code value in the S
            If S = PickListEdit.Text then
               begin
               Founded := I+1;
               end;
            PickListListBox.Cells[0,I+1] := S;
            PickListListBox.Cells[1,I+1] := S1;

            end;

//      PickListListBox.Cols[0].EndUpdate;
      PickListListBox.Cells[0,0] := sesPickList_GridCode;
      PickListListBox.Cells[1,0] := sesPickList_GridCaption;
      PickListListBox.Row:= 1;
      PickListListBox.Col:= 0;
      PickListRec.Caption := sesTotal+': '+IntToStr(PickListEdit.PickList.Count);

      PickListListBox.Invalidate;
      end; // CodeCaption
   plGrid:
     begin
        PickListListBox.Visible := True;
        // at the first rows we wait for headers of cols...
        Sep := Trim(PickListEdit.PickListSeparator);
        If Sep = '' then Sep := ' ';
        S:=PickListEdit.PickList[0];
        ParseString(S,Sep[1],'',FastList1);
        If FastList1.Count = 0 then
           begin
           ShowError(sesPickList_DividerError);
           PickListListBox.Enabled := False;
           Exit;
           end;

        PickListListBox.DefaultColWidth := 120;
        PickListListBox.ColCount := FastList1.Count;
        // extend the last column
        N := PickListListBox.ColCount - 1;
        W := 120 * N; // total width of ColCount-1 columns
        PickListListBox.ColWidths[N] := PickListListBox.Width - W;
        PickListListBox.RowCount := PickListEdit.PickList.Count;
        PickListListBox.FixedRows:=1;

//        PickListListBox.BeginUpdate;
        // fill the headers
        for J:=0 to FastList1.Count-1 do
            PickListListBox.Cells[J,0] := FastList1[J];

        N:=PickListEdit.PickList.Count-1;
        for I:=1 to N do
            begin
            S:=PickListEdit.PickList[I];
            ParseString(S,Sep[1],'', FastList2);
            If FastList2.Count = 0 then
               begin
               ShowError(sesPickList_DividerError);
               PickListListBox.Enabled := False;
               Exit;
               end;
            // fill the cols in I+1 row
            for J:=0 to FastList2.Count-1 do
                PickListListBox.Cells[J,I] := FastList2[J];

            // get the Code value in the S
            S:=FastList2[0]; // Code must be the FIRST always!
            If S = PickListEdit.Text then
               begin
               Founded := I;
               end;
            end;

//      PickListListBox.Cols[0].EndUpdate;
      PickListListBox.Row:= 1;
      PickListListBox.Col:= 0;

      PickListListBox.Invalidate;
      PickListRec.Caption := sesTotal+': '+IntToStr(PickListEdit.PickList.Count-1);

      end; // Grid
    plDataSet:
      begin
      If PickListEdit.PickDataSet = nil then
         begin
         ShowError(sesPickList_DataSetIsNotAssigned);
         Exit;
         end;
      If PickListEdit.PickDataSet.Active = False then
         begin
         ShowError(sesPickList_DataSetIsClosed);
         Exit;
         end;
      If PickListEdit.PickDataSet.RecordCount = 0 then
         begin
         ShowError(sesPickList_DataSetIsEmpty);
         Exit;
         end;
      try
      DataSource1.DataSet := PickListEdit.PickDataSet;
      // extract the key field name:
      S := DataSource1.DataSet.Fields[0].FieldName;
      except
      ShowError(sesPickList_DataSetIsInvalid);
      Exit;
      end;
      DBGrid1.Visible := True;
      PickListEnabled:=True;
      try
      If PickListEdit.Text <> '' then
      begin
      V := PickListEdit.Value;
      If DataSource1.DataSet.Locate(S,V,[]) then
         Founded := DataSource1.DataSet.RecNo
         else
         Founded := -1;
      end
      else
      Founded := -1;
      except
      Founded := -1;
      end;
      If Founded > -1 then
           begin
           FoundPanel.Caption := sesPickList_Found;
           FoundPanel.Color := clSilver;
           end
           else
           begin
           FoundPanel.Caption := sesPickList_NotFound;
           FoundPanel.Color := clInfoBk;
           end;

      end; // DataSet

    end; // Case PickListEdit.PickListKind
    Case PickListEdit.PickListKind Of
    plStandard,plCodeCaption,plGrid:
        begin
        If Founded > -1 then
           begin
           PickListListBox.Col:=0;
           PickListListBox.Row:=Founded;
           FoundPanel.Caption := sesPickList_Found;
           FoundPanel.Color := clSilver;
           end
           else
           begin
           PickListListBox.Row:=PickListListBox.FixedRows;
           PickListListBox.Col:=0;
           FoundPanel.Caption := sesPickList_NotFound;
           FoundPanel.Color := clInfoBk;
           end;
        PickListListBox.Enabled := True;
        PickListEnabled:=True;
        PickListListBox.Col:=0;
        end;
    end; // Case PickListEdit.PickListKind

    finally
    end;

    end;

procedure TsesPickList.ApplyPickListClick(Sender: TObject);
begin
Self.PickListEdit.Text := PickListSelectedValue.Text;
end;


procedure TsesPickList.PickListListBoxDblClick(Sender: TObject);
begin
If (PickListEnabled) and (not Self.PickListEdit.ReadOnly)  then
Self.PickListEdit.Text := PickListSelectedValue.Text;
GetParentForm(Self).ModalResult := mrRetry;
end;

procedure TsesPickList.PickListListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   Case Key Of
   VK_RETURN:
                begin
                  GetParentForm(Self).ModalResult := mrRetry;
                  If PickListEnabled then
                  sesPickList.PickListEdit.Text := sesPickList.PickListSelectedValue.Text;
                  Key:=0;
                  Exit;
                  end;

   end; // Case Of Key

end;

procedure TsesPickList.PickListSelectedValueKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
Case Key Of
VK_UP,VK_DOWN:
               begin
               If PickListEnabled then
                  begin
                  If PickListEdit.PickListKind <> plDataSet then
                        begin
                        PickListListBox.SetFocus;
                        FoundPanel.Caption := sesPickList_SelectedItem;
                        SelectItem(PickListListBox.Col,PickListListBox.Row);
                        end
                        else
                        begin
                        DBGrid1.SetFocus;
                        end;
                  end;
               end;
end; // Case Key Of
end;

procedure TsesPickList.PickListListBoxSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
If not PickListEnabled then Exit;

If not (ARow >= PickListListBox.FixedRows) then
   begin
   CanSelect := False;
   Exit;
   end
   else
   CanSelect := True;
SelectItem(ACol,ARow);
end;

procedure TsesPickList.SelectItem(const ACol,ARow:Integer);
begin
If not PickListEnabled then Exit;
PickListSelected := True;

Case PickListEdit.PickListKind Of
plStandard:
begin
   PickListSelectedValue.Text :=
   PickListListBox.Cells[0,ARow];
PickListRec.Caption := IntToStr(ARow+1) + sesFrom+
       IntToStr(PickListListBox.RowCount);

end; // Standard - one column
plCodeCaption:
begin
   PickListSelectedValue.Text :=
   PickListListBox.Cells[0,ARow];
PickListRec.Caption := IntToStr(ARow) + sesFrom+
       IntToStr(PickListListBox.RowCount-1);

end; // Standard - one column
plGrid:
begin
   PickListSelectedValue.Text :=
   PickListListBox.Cells[0,ARow];
PickListRec.Caption := IntToStr(ARow) + sesFrom+
       IntToStr(PickListListBox.RowCount-1);

end; // Standard - one column

end; // Case PickListEdit.PickListKind Of

end;

procedure TsesPickList.DataSource1DataChange(Sender: TObject;
  Field: TField);
begin
If PickListEdit.PickListKind = plDataSet then
   begin
   try
   PickListSelectedValue.Text := DataSource1.DataSet.Fields[0].AsString;
   If DBGrid1.Focused then
      PickListSelected := True
      else
      PickListSelected := False;
   PickListRec.Caption := IntToStr(DataSource1.DataSet.RecNo)+':'+
                          IntToStr(DataSource1.DataSet.RecordCount);
   except
   PickListSelected := False;
   end;
   end;
end;

procedure TsesPickList.DBGrid1Enter(Sender: TObject);
begin
If PickListEdit.PickListKind = plDataSet then
   begin
   try
   PickListSelectedValue.Text := DataSource1.DataSet.Fields[0].AsString;
   PickListSelected := True;
   PickListRec.Caption := IntToStr(DataSource1.DataSet.RecNo)+':'+
                          IntToStr(DataSource1.DataSet.RecordCount);
   except
   PickListSelected := False;
   end;
   end;

end;

end.
