unit sesSystem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IniFiles,Math,Menus,buttons,stdctrls,ExtCtrls;

const
// Global constants


// Boolean consts for  data type = ftBoolean
sesFalse = '0';
sesTrue = '1';


//DefaultDecimalDisplayPreci
FloatNull=0.00000001; // float null for comparison oparations


// internal const
{Colors}
//mauve
HelperBK1 = TColor(15258872);
HelperBK2 = TColor(14201087);
// yellow
HelperBK3 = TColor(11595000);
HelperBK4 = TColor(12644600);
// gray
HelperBK5 = TColor(15262952);
HelperBK6 = TColor(14736608); {!}
HelperBK7 = TColor(14211288); {!}
HelperBK8 = TColor(13685968); {!}

// blue
HelperBK9 = TColor(16762056); {!}
HelperBK10 = TColor(16762056); {!}


// broadcasting operations consts
// CE will use VK_ range above VK_CE_Min:
VK_CE_Min = 1000;
// these consts will be passed as Operation for CEBroadcast and CharCode parameter of TWMKey
VK_IsEditCompleted = VK_CE_Min + 1;
VK_SetFocusIfNotEditCompleted = VK_CE_Min + 2;

//     
ORword='';
OnBooleanErrorCaption='   '+#13+#10+'  ...';
OnBooleanErrorAdvice='      : ';


MaxWidthErrorWindow=300;



type

// Defines a type of the result returning by the CheckText function,
// which validates the TsesEdit Text value
TEditErrorType =(ceOK,ceChar,ceNumber,ceBoolean,
                 ceRange,cePickList,ceDate,ceTime,ceUser,ceRequired);
{where:
 ceOK       - the data of the TsesEdit Text property is valid;
 ceChar     - the invalid key was pressed;
 ceNumber   - the invalid number format;
 ceBoolean  - the Text is not equal whether True or False value, given by
              sesData.RangeMaxOrTrue and sesData.RangeMinOrFalse properties;
 ceRange    - the data of a (cdtCardinal,cdtInteger,cdtFloat) type is out of Range, see above;
 cePickList - the Text value is not belong to the list of the PickList values;
 ceDate     - the Text value is invalid date;
 ceTime     - the Text value is invalid time;
 ceUser     - the Text value was rejected by the User program;
 ceRequired - the Text value must not be empty due to the TsesEdit Required property is True.
}



// open dialog property editor type:
// all properties as TsesFileName will be edited by open dialog
TsesFileName = String;


// Date types
TParsedDate = record
  // Year field
  Year:Word;
  sYear:String; // yy
  nYear:Word; // field order in Source String

  // Month field
  Month:Word;
  sMonth:String;  // mm
  nMonth:Word;
  ShortName:String;

  // Day field
  DaysInMonth:Word;
  Day:Word;
  sDay:String;  // dd
  nDay:Word;
  end;

TParsedTime = record
 Hour:Word;
 sHour,h1,h2:String;

 Minutes:Word;
 sMinutes,m1,m2:String;
 Seconds:Word;
 sSeconds,ss1,ss2:String;

 end;

  TWMCE = record
    Msg: Integer;
    Keys: Word;
    LParam:LongInt;
    Result: Longint;
  end;

  PointerToRecord = ^TtagTPMPARAMS;
  TtagTPMPARAMS = packed record
    cbSize: UINT;     { Size of structure }
    rcExclude: TRect; { Screen coordinates of rectangle to exclude when positioning }
  end;


TPopUpMessage = record
   MessageType:Integer;
{
0 - Input Error
}
   Caption:String;
   PointToError:String;
   Advise:String; // really long string - strings
   end;

TEditButtonKind =(ebkNone,ebkCustom,ebkToggle,ebkDropDown,ebkForm,ebkOpen);

{    :
1.    ;
2.     ;
3.    .
}
TClassicDataType = (cdtString, cdtCardinal, cdtInteger,
cdtBoolean, cdtFloat, cdtDate,cdtTime);

TCharSet = set of Char;

TErrorSound=(essNone, essBeep, essSystemExclamation, essSystemQuestion);

// ""      
TFastList = class(TObject)
      private
      FList:array of String;
      FCount:Integer;
      FCapacity:Integer;
      FPosition:Integer;
      protected
      function Get(Index: Integer): string;
      procedure Put(Index: Integer; const S: string);
      public
      property Strings[Index: Integer]: string read Get write Put; default;
      property Count:Integer read FCount write FCount;
      constructor Create;
      destructor Destroy;override;
      function Add(const S:String):Integer;
      procedure Insert(Index:Integer; const S:String);
      procedure Delete(Index:Integer);
      function IndexOf(const S:String):Integer;
      procedure Clear;
      end;
//* ""      
//    
//TWorkList = TStringList;
TWorkList = TFastList;

// defines the ancestor class for ses Ini files
TsesIniFileClass = TIniFile;

{TsesIniFile}
TsesIniFile = class(TsesIniFileClass)
        public
        // reads the entire strings from Section into Strings replacing
        // the sign "=' by OldFieldSeparator, then replaces the OldFieldSeparator by NewFieldSeparator
        procedure ReadSectionStrings(const Section: string;
                  const OldFieldSeparator,NewFieldSeparator:String; Strings: TStrings);
        // writes the entire strings from Strings into Section,
        // each input string will be formatted as "Field1=Field2+NewFieldSeparator+...Fieldn"
        procedure WriteSectionStrings(const Section: string;
        const OldFieldSeparator,NewFieldSeparator:String;Strings: TStrings);
        end;

//       aSource,
//    aSeparator,
//    List.  ,  aMissingStr <> '',
//       aMissingStr.
//   (  List.Count)
function ParseString(aSource:String; aSeparator:Char; aMissingStr:String;
List:TWorkList):Integer;


//     
// User data edit form functions

//       
// TCustomClassicEdit   WinControls  Container
// Check up the edit result of the all components of TCustomClassicEdit type,
// which exist in the WinControls chain of the Container
// Returns:
//       True if the all edits, which have Container in the patrents chain,
//       had finished editions OnExit without any errors;
//       False, if there a edits with errors completion.
function IsEditCompleted(const Container:TWinControl):Boolean;

// set focus on the first notcompleted edit in the WinControls chain of Containter
function SetFocusIfNotEditCompleted(const Container:TWinControl):Boolean;

// Sends broadcasting message to all TWinControl controls on the aContainer
function CEBroadcast(const aContainer: TWinControl; Operation:Word):Integer;


//    X    Precision  
// :  RoundExtended(123.345678, 3)=123.346;
//  RoundExtended(456.95678,0)=457.0; RoundExtended(678.341, 2)=678.34
// The function rounds the number X with Precision number of digits after
// decimal point
function RoundExtended( X: Extended; Precision : Integer ): Extended;

//        {try ... exception}
//    

// All functions returns Integer as:
{
 -1   - aSource is Empty
 0    - OK
 n[1...m]    - number of a error symbol in the aSource
}

//       ( Cardinal)
// The function tests aSource as Cardinal type(unsigned 32-bit) number
function IsStringCardinal(aSource:String):Integer;

//     ( Integer)
// The function tests aSource as Integer type(signed 32-bit) number
function IsStringInteger(aSource:String):Integer;

//       ( Float(Real))
// The function tests aSource as Real type(signed) number with floating-point notation
function IsStringFloat(aSource:String):Integer;

// The function tests aSource as valid TDate type
// Supports only Three classic date SHORT type:
{ dd.mm.yy
  mm.dd.yy
  yy.mm.dd
or: m/d/y, d/m/y, and y/m/d
ATTENTION: the function DOES NOT SUPPORT format without YEAR!!!
}
{returns:
0 - the aSource contains valid date
-1 there is only One DateSeparator
-2 the aSource is empty there is not any DateSeparator in the aSource
-3 there are too many DateSeparators(> 2)
n (1,2,3) - a field number as a part of the aSource with invalid content: year or month or day,
  it depends on the current ShortDateFormat value...
}
function IsStringDate(const aSource:String; var ParsedDate:TParsedDate ):Integer;

// The function tests aSource as valid TTime type: hh:mm:ss (LongTimeFormat) & hh:mm (ShortTime)
// milliseconds does not support!
{returns:
0 - the aSource contains valid Time
-1 there is only One TimeSeparator
-2 the aSource is empty there is not any TimeSeparator in the aSource
-3 there are too many TimeSeparators(> 2)
n (1,2,3) - a field number as a part of the aSource with invalid content: hh or mm or ss...
}
function IsStringTime(aSource:String; var ParsedTime:TParsedTime):Integer;

//*

// Range check up functions

// Returns True, if aSource consists of a Integer belonging to range {aMin,aMax) including.
function IsIntegerInRange(aSource,aMin,aMax:String):Boolean;

// Returns True, if aSource consists of a Float belonging to range {aMin,aMax) including.
function IsFloatInRange(aSource,aMin,aMax:String):Boolean;

//*

//     PopUp   aWidth   aHeight
//    ///   Sender As TWinControl.
// The function returns the right screen position of a PopUp window with
// aWidth and aHeight for allocation under/up/left/right from Sender As TWinControl.
function GetPopUpScreenPos(Sender:TObject; aHeight,aWidth:Integer):TPoint;


var

// Date,Time control section

// If True, Date, Time Pickers will replace empty or "dirty" string Date() or Time()
IsSetNow:Boolean = True;

FloatSymbolSet:TCharSet=['+', '-', '0'..'9'];
CardinalSymbolSet:TCharSet=['0'..'9'];
IntegerSymbolSet:TCharSet=['+', '-', '0'..'9'];
//[+,-,0,1,2,3,4,5,6,7,8,9];
DateSymbolSet:TCharSet=['0'..'9'];
TimeSymbolSet:TCharSet=['0'..'9'];

LoseFocusAllowed:Boolean = False;
LogFieldSeparator:String = '=';
PickListFieldSeparator:String='|';
//  ""   
FastListLength:Integer=300;

// working fast lists
FastList1,FastList2:TFastList;

// Init Edit value by default(if inassigned)
abracadabra:String ='abracadabra';

{ Color sesState's pallette
TopColor is used to draw left and top sides of the Editor's border,
while  right and bottom sides will be rendered by
BottomColor
}
sesState_Init_TopColor :TColor = TColor(16762056);//TColor(16744576);
sesState_Init_BottomColor :TColor = clBlack;//TColor(16760767);


sesState_Complete_TopColor :TColor =   clWhite ;//TColor(14211288);
sesState_Complete_BottomColor :TColor = clBlack; //TColor(13685968);

sesState_Error_TopColor :TColor =    TColor(7368816);
sesState_Error_BottomColor :TColor = TColor(8388863);

sesState_ReadOnly_TopColor :TColor =    TColor(9961171);
sesState_ReadOnly_BottomColor :TColor = clBlack;//TColor(15263952);

sesState_Edit_TopColor :TColor =    TColor(7368816);
sesState_Edit_BottomColor :TColor = cl3DLight;//TColor(16762056);


implementation

var
DateList:TFastList=nil;
// ""      
constructor TFastList.Create;
begin
inherited Create;
    SetLength(FList, FastListLength);
FCount:=0;
FCapacity := High(FList);
FPosition:=-1;
end;

function TFastList.Get(Index: Integer): string;
begin
Result := FList[Index];
end;

procedure TFastList.Put(Index: Integer; const S: string);
begin
FList[Index] := S;
end;

function TFastList.Add(const S:String):Integer;
begin
Result := -1;

If (FPosition + 1) <= FCapacity then
   begin
   FPosition := FPosition + 1;
   FCount:=FCount+1;
   Put(FPosition,S);
   Result:=FPosition;
   end;

end;
procedure TFastList.Delete(Index:Integer);
var
i1:Integer;
begin
If FCount = 0 then Exit;
If (Index > -1) And (Index <= FCount-1) then
   begin
   If FCount = 1 then
      begin
      Clear;
      Exit;
      end;
   i1:=Index;
   While i1 <= FCount-1 do
      begin
      If (i1+1) <= FCount-1 then
          FList[i1]:=FList[i1+1];
      i1:=i1+1;
      end;
   FPosition := FPosition - 1;
   FCount:=FCount-1;
   end;
end;

procedure TFastList.Insert(Index:Integer; const S:String);
var
i1:Integer;
begin
If FCount = 0 then
   begin
   Add(S);
   Exit;
   end;

If ((FPosition + 1) <= FCapacity) And ((Index >=0) And (Index <= FCapacity)) then
   begin
   FPosition := FPosition + 1;
   FCount:=FCount+1;
   i1:=FPosition;
   While i1 > Index do
      begin
      FList[i1]:=FList[i1-1];
      i1:=i1-1;
      end;
   FList[Index]:=S;
   end;
end;

function TFastList.IndexOf(const S:String):Integer;
begin
  for Result := 0 to FCount - 1 do
    if AnsiCompareText(FList[Result], S) = 0 then Exit;
  Result := -1;

end;

procedure TFastList.Clear;
begin
FCount:=0;
FPosition:=-1;
end;

destructor TFastList.Destroy;
begin
FList:=nil;
inherited Destroy;
end;

//* ""      

//       aSource,
//    aSeparator,
//    List.  ,  aMissingStr <> '',
//       aMissingStr.
//   (  List.Count)
function ParseString(aSource:String; aSeparator:Char; aMissingStr:String;
List:TWorkList):Integer;
var
I,M:Integer;
S:String;
c:Char;
begin
Result:=0;
If List = nil then Exit;
M:=Length(aSource);
If M = 0 then
   begin
   List.Clear;
   Exit;
   end;

List.Clear;

I:=1;
S:='';
While I <= M do
        begin
        c:=aSource[I];
        If c=aSeparator then
           begin
           If (S='') And (aMissingStr <> '') then
               List.Add(aMissingStr)
               else
               begin
               List.Add(S);
               S:='';
               end;
           end
           else
           begin
           S:=S+c;
           end;
        I:=I+1;
        end;
If S <> '' then
   List.Add(S);
Result:=List.Count;
end;


// Sends broadcasting message to all TWinControl controls on the aContainer
function CEBroadcast(const aContainer: TWinControl; Operation:Word):Integer;
var
BroadCastingMessage:TWMKey;
begin
BroadCastingMessage.Msg := CM_DIALOGKEY;
BroadCastingMessage.CharCode := Operation;
//BroadCastingMessage.Unused := Operation;
BroadCastingMessage.KeyData:=0;
BroadCastingMessage.Result := 0;
aContainer.Broadcast(BroadCastingMessage);
Result := BroadCastingMessage.Result;
end;

//       
// TCustomClassicEdit,  ""  UserForm
// Check up the edit result of the all components of TCustomClassicEdit type,
// Container owned
function IsEditCompleted(const Container:TWinControl):Boolean;
begin
// query the all edits for a state of editing
Result := (CEBroadcast(Container, VK_IsEditCompleted) = 0);
end;

// set focus on the first notcompleted edit in the WinControls chain of Containter:
// True, if focused else False.
function SetFocusIfNotEditCompleted(const Container:TWinControl):Boolean;
begin
Result := (CEBroadcast(Container, VK_SetFocusIfNotEditCompleted) > 0);
end;


//     PopUp   aWidth   aHeight
//    ///   Sender As TWinControl.
// The function returns the right screen position of a PopUp window with
// aWidth and aHeight for allocation under/up/left/right from Sender As TWinControl.
function GetPopUpScreenPos(Sender:TObject; aHeight,aWidth:Integer):TPoint;
var
WinControl,ParentControl:TWinControl;
WCWidth,WCHeight:Integer;
ScreenHeight,ScreenWidth:Integer;
ScrLeftTop,ScrLeftBottom, ScrRightTop,ScrRightBottom:TPoint;
Rect:TRect;
begin
Result.x:=0;
Result.y:=0;

SystemParametersInfo(SPI_GETWORKAREA,0,@Rect,0);
ScreenHeight:=Rect.Bottom - Rect.Top;
ScreenWidth := Rect.Right - Rect.Left;

WinControl:=TWinControl(Sender);
ParentControl := WinControl.Parent;
WCWidth:=WinControl.Width;
WCHeight:=WinControl.Height;

// calculate coordinates of corners
ScrLeftTop.x:= WinControl.Left;
ScrLeftTop.y:= WinControl.Top;
ScrLeftTop :=ParentControl.ClientToScreen(ScrLeftTop);

ScrLeftBottom.x:= WinControl.Left;
ScrLeftBottom.y:= WinControl.Top + WCHeight;
ScrLeftBottom :=ParentControl.ClientToScreen(ScrLeftBottom);

ScrRightTop.x:= WinControl.Left + WCWidth;
ScrRightTop.y:= WinControl.Top;
ScrRightTop :=ParentControl.ClientToScreen(ScrRightTop);

ScrRightBottom.x:= WinControl.Left + WCWidth;
ScrRightBottom.y:= WinControl.Top + WCHeight;
ScrRightBottom :=ParentControl.ClientToScreen(ScrRightBottom);

//1. try to show at bottom side below  the WinControl
If ((ScrLeftBottom.y + aHeight) < ScreenHeight)  then
   begin
   If ((ScrLeftBottom.x + aWidth) < ScreenWidth) then
       begin
       Result := ScrLeftBottom;
       Exit;
       end
       else
       begin
       If ((ScrLeftBottom.x - aWidth) < ScreenWidth) and ((ScrLeftBottom.x - aWidth) >= 0) then
           begin
           Result.y:=ScrLeftBottom.y;
           Result.x := ScrLeftBottom.x - aWidth;
           Exit;
           end
           else
           begin
           Exit;
           end;
       end;
   end; // below

//2. try to show at (Left,Bottom) from above the WinControl
If ((ScrLeftTop.y - aHeight) >= 0)  then
   begin
   If ((ScrLeftTop.x + aWidth) < ScreenWidth) then
       begin
       Result.x := ScrLeftTop.x;
       Result.y := ScrLeftTop.y - aHeight;
       Exit;
       end
       else
       begin
       If ((ScrLeftTop.x - aWidth) < ScreenWidth) and ((ScrLeftTop.x - aWidth) >= 0) then
           begin
           Result.y:= ScrLeftTop.y - aHeight;;
           Result.x := ScrLeftTop.x - aWidth;
           Exit;
           end
           else
           begin
           Exit;
           end;
       end;
   end; // from above

end;

//    X    Precision  
// :  RoundExtended(123.345678, 3)=123.346;
//  RoundExtended(456.95678,0)=457.0; RoundExtended(678.341, 2)=678.34
function RoundExtended( X: Extended; Precision : Integer ): Extended;
{Precision :     :
0 -  
1 -  
2 -  
...
}
var
//        
ScaleFractPart : Extended;

//  
Temp : Extended;
//   ,       
PrecisionScale : Integer;

//    
begin
// : X=6234.86789,   =6234.87
// Precision = 2
//       
If Precision = 0 Then
PrecisionScale := 1 //       
Else
begin
PrecisionScale := Trunc(IntPower(10.0,Precision));
//  : 10 ^ 2 = 100
end;

// Frac(X)     X
//        
//         .
// Precision=2
ScaleFractPart := Frac(X)*PrecisionScale;
// Frac(X) =0.86789
// ScaleFractPart=0.86789 * 100=86.789

//  Temp   , ., 0.789
Temp := Frac(ScaleFractPart);
// 0.789

//     ScaleFractPart  :
//
ScaleFractPart := Int(ScaleFractPart);
// 86.0
//          Temp
//      :
//   >= 0.5,       
if Temp >= 0.5 then ScaleFractPart := ScaleFractPart + 1;
//     Temp=0.789 > 0.5,  ScaleFractPart:=87.0
//          
if Temp <= -0.5 then ScaleFractPart := ScaleFractPart - 1;
// ,   ,    < 0.5  ScaleFractPart  ,
// ..,    Temp  !

//      :
// 1.    (6234.00)
// 2.    ScaleFractPart(87.0),     
//          Precision - 0.87
Result := Int(X) + ScaleFractPart/PrecisionScale;
// ,   6234.0 + 0.87 = 6234.87
end;
//  


function IsStringCardinal(aSource:String):Integer;
var
i,n,Digits:Integer;
S:String;
begin
Result := -1;
S:=Trim(aSource);
n:= Length(S);
If n=0 then Exit;

Digits:=0;
// number of Integer' digits must be greate, than 0...

// test an each symbol: it must be in "0..9" only...
for i:=1 to n do
 begin
 If (S[i] < '0') or (S[i] > '9') then
        begin
        Result:=i;
        Exit;
        end;
 Digits:=Digits+1;
 end;
 If (Digits > 0)then
     begin
     Result := 0;
     end;

end;

function IsStringInteger(aSource:String):Integer;
var
i,n,Digits:Integer;
S:String;
begin
Result := -1;
S:=Trim(aSource);
n:= Length(S);
If n=0 then Exit;
// check up the first symbol of the Integer: it must be "+" or "-" or "0..9"
If not ((S[1]='+') or (S[1]='-') or  ((S[1] >= '0') and (S[1] <= '9'))) then
    begin
    Result := 1;
    Exit;
    end;


If (S[1] >= '0') and (S[1] <= '9') then
   Digits:=1
   else
   begin
   // the first symbol is not digit
   If n=1 then
        begin
        Result := 1;
        Exit; // Wrong Integer =+ or -
        end;
   Digits:=0;
   end;
   // number of Integer' digits must be greate, than 0...

// test an each symbol: it must be in "0..9" only...
for i:=2 to n do
 begin
 If (S[i] < '0') or (S[i] > '9') then
        begin
        Result := i;
        Exit;
        end;
 Digits:=Digits+1;
 end;
 If (Digits > 0)then
     begin
     Result := 0;
     end;

end;

// The function tests aSource as Real type(signed) number with floating-point notation
function IsStringFloat(aSource:String):Integer;
var
i,n:Integer;
DC,Digits:Integer;
S:String;
Dcc:Char;
begin
Result := -1;
S:=Trim(aSource);
n:= Length(S);
If n=0 then Exit;
Dcc := DecimalSeparator;
// check up the first symbol of the Integer: it must be DecimalSeparator or "+" or "-" or "0..9"
If not ( (S[1]=Dcc) or (S[1]='+') or (S[1]='-') or  ((S[1] >= '0')
and (S[1] <= '9'))) then
        begin
        Result := 1;
        Exit;
        end;

If (S[1] >= '0') and (S[1] <= '9') then
   begin
   Digits:=1;
   DC:=0;
   end
   else
   begin
   // the first symbol is not digit
   If n=1 then
                begin
                Result := 1;
                Exit; // Wrong Float = . or + or -
                end;
   If (S[1] = Dcc) then
       DC:=1
       else
       DC:=0;
   Digits:=0;
   end;
   // number of Float' digits must be greate, than 0...

for i:=2 to n do
 begin
 If S[i] = Dcc then
    begin
    DC:=DC+1;
    If DC > 1 then
                begin
                Result := i;
                Exit;
                end;
    Continue;
    end;
 If (S[i] < '0') or (S[i] > '9') then
                    begin
                    Result := i;
                    Exit;
                    end;
 Digits:=Digits+1;
 end;
 If (Digits > 0)  then Result := 0;

end;

// The function tests aSource as valid TDate type
// Supports only Three classic date SHORT type:
{ dd.mm.yy
  mm.dd.yy
  yy.mm.dd
or: m/d/y, d/m/y, and y/m/d
ATTENTION: the function DOES NOT SUPPORT format without YEAR!!!
}
{returns:
0 - the aSource contains valid date
-1 there is only One DateSeparator
-2 the aSource is empty there is not any DateSeparator in the aSource
-3 there are too many DateSeparators(> 2)
n (1,2,3) - a field number as a part of the aSource with invalid content: year or month or day,
  it depends on the current ShortDateFormat value...
}
function IsStringDate(const aSource:String; var ParsedDate:TParsedDate ):Integer;
var
Year,Month,Day,ValidMonthDays:Word;
S:String;
I,J:Integer;
        //returns always the two last symbols from String sD
        function GetTwoSymbols(sD:String):String;
        begin
        Case Length(sD) Of
        0: Result := '00';
        1: Result := '0' + sD;
        2: Result := sD;
        3: Result := Copy(sD,2,2);
        4: Result := Copy(sD,3,2);
         else
         Result := Copy(sD,Length(sD)-1,2);
        end; // case
        end;
begin
    ValidMonthDays := 0;
    ParsedDate.Year := 0;
    ParsedDate.sYear := '00';
    ParsedDate.nYear := 0;

    ParsedDate.Month := 0;
    ParsedDate.sMonth := '00';
    ParsedDate.nMonth := 0;
    ParsedDate.DaysInMonth := 31;
    ParsedDate.ShortName := '';
    ParsedDate.Day := 0;
    ParsedDate.sDay := '00';
    ParsedDate.nDay := 0;

Result := -2; // empty string or there is not any DateSeparator
If Length(Trim(aSource)) = 0 then Exit;
ParseString(aSource,DateSeparator,'', DateList);
If DateList.Count = 0 then Exit;
If DateList.Count < 3 then
   begin
   Result := -1; // there is One DateSeparator
   Exit;
   end;
If DateList.Count > 3 then
   begin
   Result := -3; // there are too many DateSeparators
   Exit;
   end;
// tests the last char as DateSeparator
I:= Length(aSource);
J := Length(DateSeparator);
If Copy(aSource,I,J) = DateSeparator then
   begin
   Result := -3; // there are too many DateSeparators
   Exit;
   end;

// at last we have only two right DateSeparators in the aSource and
// three fields
// test they as cardinal numbers:
for I := 0 to 2 do
    begin
    If (IsStringCardinal(DateList[I]) <> 0) then
       begin
       Result := I+1; // number of invalid field
       Exit;
       end;
    end;
// test each field value depend on date format
S:=ANSIUpperCase(ShortDateFormat);
Case S[1] of
'Y': // y/m/d
    begin
    Year := StrToInt(DateList[0]);
    ParsedDate.Year := Year;
    ParsedDate.sYear := GetTwoSymbols(Trim(DateList[0]));
    ParsedDate.nYear := 1;
    Month := StrToInt(DateList[1]);
    If (Month < 1) or (Month > 12) then
       begin
       Result := 2;
       Exit;
       end;
    ParsedDate.Month := Month;
    ParsedDate.sMonth := GetTwoSymbols(Trim(DateList[1]));
    ParsedDate.nMonth := 2;
    ParsedDate.DaysInMonth := ValidMonthDays;
    ParsedDate.ShortName := ShortMonthNames[Month];

    Day := StrToInt(DateList[2]);
    ParsedDate.Day := Day;
    ParsedDate.sDay := GetTwoSymbols(Trim(DateList[2]));
    ParsedDate.nDay := 3;

    ValidMonthDays := MonthDays[IsLeapYear(Year), Month];
    If (Day < 1) or (Day > ValidMonthDays) then
       begin
       Result := 3;
       Exit;
       end;




    end;
'M': // m/d/y
    begin
    Year := StrToInt(DateList[2]);
    ParsedDate.Year := Year;
    ParsedDate.sYear := GetTwoSymbols(Trim(DateList[2]));
    ParsedDate.nYear := 3;

    Month := StrToInt(DateList[0]);
    If (Month < 1) or (Month > 12) then
       begin
       Result := 1;
       Exit;
       end;
    ParsedDate.Month := Month;
    ParsedDate.sMonth := GetTwoSymbols(Trim(DateList[0]));
    ParsedDate.nMonth := 1;
    ParsedDate.DaysInMonth := ValidMonthDays;
    ParsedDate.ShortName := ShortMonthNames[Month];

    Day := StrToInt(DateList[1]);
    ParsedDate.Day := Day;
    ParsedDate.sDay := GetTwoSymbols(Trim(DateList[1]));
    ParsedDate.nDay := 2;

    ValidMonthDays := MonthDays[IsLeapYear(Year), Month];
    If (Day < 1) or (Day > ValidMonthDays) then
       begin
       Result := 2;
       Exit;
       end;



    end;
'D': // d/m/y
    begin
    Year := StrToInt(DateList[2]);
    ParsedDate.Year := Year;
    ParsedDate.sYear := GetTwoSymbols(Trim(DateList[2]));
    ParsedDate.nYear := 3;

    Month := StrToInt(DateList[1]);
    If (Month < 1) or (Month > 12) then
       begin
       Result := 2;
       Exit;
       end;
    ParsedDate.Month := Month;
    ParsedDate.sMonth := GetTwoSymbols(Trim(DateList[1]));
    ParsedDate.nMonth := 2;
    ParsedDate.DaysInMonth := ValidMonthDays;
    ParsedDate.ShortName := ShortMonthNames[Month];

    Day := StrToInt(DateList[0]);
    ValidMonthDays := MonthDays[IsLeapYear(Year), Month];
    ParsedDate.Day := Day;
    ParsedDate.sDay := GetTwoSymbols(Trim(DateList[0]));
    ParsedDate.nDay := 1;

    If (Day < 1) or (Day > ValidMonthDays) then
       begin
       Result := 1;
       Exit;
       end;

    end;
else
begin
    Year := StrToInt(DateList[2]);
    ParsedDate.Year := Year;
    ParsedDate.sYear := GetTwoSymbols(Trim(DateList[2]));
    ParsedDate.nYear := 3;

    Month := StrToInt(DateList[0]);
    If (Month < 1) or (Month > 12) then
       begin
       Result := 1;
       Exit;
       end;
    ParsedDate.Month := Month;
    ParsedDate.sMonth := GetTwoSymbols(Trim(DateList[0]));
    ParsedDate.nMonth := 1;
    ParsedDate.DaysInMonth := ValidMonthDays;
    ParsedDate.ShortName := ShortMonthNames[Month];

    Day := StrToInt(DateList[1]);
    ParsedDate.Day := Day;
    ParsedDate.sDay := GetTwoSymbols(Trim(DateList[1]));
    ParsedDate.nDay := 2;

    ValidMonthDays := MonthDays[IsLeapYear(Year), Month];
    If (Day < 1) or (Day > ValidMonthDays) then
       begin
       Result := 2;
       Exit;
       end;

end;
end; // Case ShortDateFormat[1] of

// at last, the aSource has passed all tests and contain valid date:
Result := 0;

end;

// The function tests aSource as valid TTime type: hh:mm:ss (LongTimeFormat) & hh:mm (ShortTime)
// milliseconds does not support!
{returns:
0 - the aSource contains valid Time
-1 there is only one fields in the aSource and there is not any TimeSeparator in the aSource
-2 the aSource is empty
-3 there are too many TimeSeparators(> 2)
n (1,2,3) - a field number as a part of the aSource with invalid content: hh or mm or ss...
}
function IsStringTime(aSource:String; var ParsedTime:TParsedTime):Integer;
var
S:String;
I:Integer;
        //returns always the two last symbols from String sD
        function GetTwoSymbols(sD:String):String;
        begin
        Case Length(sD) Of
        0: Result := '00';
        1: Result := '0' + sD;
        2: Result := sD;
        3: Result := Copy(sD,2,2);
        4: Result := Copy(sD,3,2);
         else
         Result := Copy(sD,Length(sD)-1,2);
        end; // case
        end;

begin
Result := -2;
With ParsedTime do
     begin
     Hour:= 0;
     sHour := '00';
     h1:='0';
     h2:='0';

     Minutes:= 0;
     sMinutes := '00';
     m1:='0';
     m2:='0';

     Seconds:= 0;
     sSeconds := '00';
     ss1:='0';
     ss2:='0';
     end;
S := Trim(aSource);
If Length(S) = 0 then Exit;
ParseString(S,TimeSeparator,'', DateList);
If DateList.Count = 0 then Exit;
If DateList.Count < 2 then
   begin
   Result := -1; // there is no TimeSeparator
   Exit;
   end;
If DateList.Count > 3 then
   begin
   Result := -3; // there are too many TimeSeparators
   Exit;
   end;
If DateList.Count = 2 then
   // may be ShortFormat - hh:mm
   DateList.Add('00');

// test fields as cardinal numbers:
for I := 0 to 2 do
    begin
    If (IsStringCardinal(DateList[I]) <> 0) then
       begin
       Result := I+1; // number of invalid field
       Exit;
       end;
    end;
With ParsedTime do
  begin
  Hour := StrToInt(DateList[0]);
  sHour := Trim(DateList[0]);
  sHour := GetTwoSymbols(sHour);
  h1:= Copy(sHour,1,1);
  h2:= Copy(sHour,2,1);

  Minutes := StrToInt(DateList[1]);
  sMinutes := Trim(DateList[1]);
  sMinutes := GetTwoSymbols(sMinutes);
  m1:= Copy(sMinutes,1,1);
  m2:= Copy(sMinutes,2,1);

  Seconds := StrToInt(DateList[2]);
  sSeconds := Trim(DateList[2]);
  sSeconds := GetTwoSymbols(sSeconds);
  ss1:= Copy(sSeconds,1,1);
  ss2:= Copy(sSeconds,2,1);
  If (Hour > 23) then
    begin
    Result := 1;
    Exit;
    end;
  If (Minutes > 59) then
    begin
    Result := 2;
    Exit;
    end;
  If (Seconds > 59) then
    begin
    Result := 3;
    Exit;
    end;

  end;
Result := 0;
end;

//***
// Returns True, if aSource consists of a Integer belonging to range {aMin,aMax) including.
function IsIntegerInRange(aSource,aMin,aMax:String):Boolean;
var
ISource,IMin,IMax:Integer;
begin
// to simplify the function, we need to use {try...}
Result := False;
try
If not (IsStringInteger(aSource)=0) then Exit;
If not (IsStringInteger(aMin)=0) then Exit;
If not (IsStringInteger(aMax)=0) then Exit;

ISource := StrToInt(aSource);
IMin := StrToInt(aMin);
IMax := StrToInt(aMax);
Result := ((ISource >= IMin) and (ISource <= IMax));
except
Result := False;
Exit;
end; // try
end;

// Returns True, if aSource consists of a Float belonging to range {aMin,aMax) including.
function IsFloatInRange(aSource,aMin,aMax:String):Boolean;
var
DSource,DMin,DMax:Extended;

begin
// to simplify the function, we need to use {try...}
Result := False;
try
If not (IsStringFloat(aSource)=0) then Exit;
If not (IsStringFloat(aMin)=0) then Exit;
If not (IsStringFloat(aMax)=0) then Exit;
DSource := StrToFloat(aSource);
DMin := StrToFloat(aMin);
DMax := StrToFloat(aMax);
Result := ((DSource >= DMin) and (DSource <= DMax));
except
Result := False;
Exit;
end; // try
end;

{TsesIniFile}
// reads the entire strings from Section into Strings replacing
// the sign "=' by OldFieldSeparator, then replaces the OldFieldSeparator by NewFieldSeparator
procedure TsesIniFile.ReadSectionStrings(const Section: string;
      const OldFieldSeparator,NewFieldSeparator:String; Strings: TStrings);
var
  KeyList: TStringList;
  I: Integer;
  S:String;
begin
  KeyList := TStringList.Create;
  try
    ReadSection(Section, KeyList);
    Strings.Clear;
    If KeyList.Count = 0 then Exit;
    Strings.BeginUpdate;
    try
      for I := 0 to KeyList.Count - 1 do
        begin
        S:= KeyList[I]+OldFieldSeparator+ReadString(Section, KeyList[I], '');
        S := StringReplace(S, OldFieldSeparator,NewFieldSeparator,[rfReplaceAll]);
        Strings.Add(S);
        end;
    finally
      Strings.EndUpdate;
    end;
  finally
    KeyList.Free;
  end;
end;

// writes the entire strings from Strings into Section,
// each input string will be formatted as "Field1=Field2+NewFieldSeparator+...Fieldn"
// writes the entire strings from Strings into Section,
// each input string will be formatted as "Field1=Field2+NewFieldSeparator+...Fieldn"
procedure TsesIniFile.WriteSectionStrings(const Section: string;
        const OldFieldSeparator,NewFieldSeparator:String;Strings: TStrings);
var
  I,J: Integer;
  S,Key,Value:String;
begin
  try
  If SectionExists(Section) then
     EraseSection(Section);
  except
  end;
    try
      for I := 0 to Strings.Count - 1 do
        begin
        S := Strings[I];
        J := Pos(OldFieldSeparator,S);
        If J = 0 then
           begin
           Key:=S;
           Value:='';
           end
           else
           begin
           Key:=Copy(S,1,J-1);
           Value := Copy(S,J+1,1024);
           Value := StringReplace(Value, OldFieldSeparator,NewFieldSeparator,[rfReplaceAll]);
           end;
        WriteString(Section,Key,Value);
        end;
    except
    end;
end;


initialization
begin
System.Include(FloatSymbolSet, DecimalSeparator);
System.Include(DateSymbolSet, DateSeparator);
System.Include(TimeSymbolSet, TimeSeparator);
DateList := TFastList.Create;
end;
finalization
begin
DateList.Free;
end;

end.
