unit sesTimePickerUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sesSystem,sesStrings,sesEditUnit,StdCtrls, ExtCtrls, CheckLst, Buttons,
  Grids;

type

TTimeControl = record
 TimeText:String;
 ValidTime:Boolean;
 ParsedTime:TParsedTime;
 end;

  TsesTimePicker = class(TFrame)
    Panel1: TPanel;
    P1: TPanel;
    E1: TEdit;
    E2: TEdit;
    P2: TPanel;
    E3: TEdit;
    E4: TEdit;
    P3: TPanel;
    E5: TEdit;
    E6: TEdit;
    bSetNow: TSpeedButton;
    sgS: TStringGrid;
    sgM: TStringGrid;
    sgH: TStringGrid;
    Lh: TPanel;
    Lm: TPanel;
    Ls: TPanel;
    procedure sgHSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure sgMSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure sgSSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure bSetNowClick(Sender: TObject);
    procedure E1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure E2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure E3KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure E4KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure E5KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure E6KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure E1KeyPress(Sender: TObject; var Key: Char);
    procedure E2KeyPress(Sender: TObject; var Key: Char);
    procedure E3KeyPress(Sender: TObject; var Key: Char);
    procedure E4KeyPress(Sender: TObject; var Key: Char);
    procedure E5KeyPress(Sender: TObject; var Key: Char);
    procedure E6KeyPress(Sender: TObject; var Key: Char);

  private
    { Private declarations }
    RefreshTime:Boolean;
    procedure TimeChange;

    procedure FillGrid(Sender:TStringGrid; Cols,Rows:Word);
    procedure TimeDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);

  procedure RefreshButtons;
  public
    { Public declarations }
  Edit:TsesCustomEdit;
  Editor:TsesCustomEditor;
  TimeControl:TTimeControl;
  procedure Init;
  procedure SetTimeValue(const Value:String; SetNow:Boolean);
  function GetTimeValue:String;
  function IsTimeValid:Boolean;
  end;



var
 sesTimePicker:TsesTimePicker;
 Days_1:set of char = [];
 Days_2:set of char = [];
 Month_1:set of char = [];
 Month_2:set of char = [];


implementation
{$R *.DFM}

function TsesTimePicker.IsTimeValid:Boolean;
begin
Result := TimeControl.ValidTime;
end;

function TsesTimePicker.GetTimeValue:String;
begin
If TimeControl.ValidTime then
   Result := TimeControl.TimeText
   else
   Result := '';
end;



procedure TsesTimePicker.SetTimeValue(const Value:String; SetNow:Boolean);
var
S:String;
Res:Integer;
begin
TimeControl.TimeText := Value;

Res := IsStringTime(Value,TimeControl.ParsedTime);
If (Res < 0) and (SetNow) then
   begin
   S:=TimeToStr(Time);
   Res := IsStringTime(S,TimeControl.ParsedTime);
   TimeControl.TimeText := S;
   end;

E1.Text := TimeControl.ParsedTime.h1;
E2.Text := TimeControl.ParsedTime.h2;

E3.Text := TimeControl.ParsedTime.m1;
E4.Text := TimeControl.ParsedTime.m2;

E5.Text := TimeControl.ParsedTime.ss1;
E6.Text := TimeControl.ParsedTime.ss2;


Case Res Of
0:
  begin
  E1.SetFocus;
  end;
else
begin
  Case Res of
  -1,-2,1:
          begin
          E1.Text := '9';
          E2.Text := '9';
          E1.SetFocus;
          end;
  2:
          begin
          E3.Text := '9';
          E4.Text := '9';
          E3.SetFocus;
          end;
  3:
          begin
          E5.Text := '9';
          E6.Text := '9';
          E5.SetFocus;
          end;
  end; // Case ShortTimeFormat[1]

end;
end; // Case Res Of


TimeChange;
RefreshButtons;
end;






procedure TsesTimePicker.TimeChange;
var
Res:Integer;
begin
TimeControl.TimeText := E1.Text + E2.Text + TimeSeparator +
    E3.Text + E4.Text + TimeSeparator +
    E5.Text + E6.Text;
Res :=  IsStringTime(TimeControl.TimeText, TimeControl.ParsedTime);
If Res = 0 then
   TimeControl.ValidTime := True
   else
   TimeControl.ValidTime := False;
end;

procedure TsesTimePicker.TimeDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
g:TStringGrid;
TopColor, BottomColor: TColor;
Flags: Longint;
Text:String;
RectColor:TColor;
bWidth:Word;
begin
bWidth := 1;

g:=TStringGrid(Sender);
Text := g.Cells[ACol,ARow];

If (gdSelected in State) or (gdFocused in State) then
    begin
    RectColor := cl3DLight;
    TopColor := clBtnShadow;
    BottomColor := clBtnHighlight;
    Frame3D(g.Canvas, Rect, TopColor, BottomColor, bWidth);
    end
    else
    begin
    TopColor := clBtnHighlight;
    BottomColor := clBtnShadow;
    RectColor := clBtnface;
    Frame3D(g.Canvas, Rect, TopColor, BottomColor, bWidth);
    end;
  with g.Canvas do
  begin
  Font := g.Font;
  Brush.Color := RectColor;
  FillRect(Rect);

  Flags := DT_SINGLELINE or DT_VCENTER or DT_CENTER;
  DrawText(Handle, PChar(Text), -1, Rect, Flags);
  end; // with

end;


procedure TsesTimePicker.FillGrid(Sender:TStringGrid; Cols,Rows:Word);
var
R,C,Value:Integer;
g:TStringGrid;
S:String;
begin
g:=Sender;
g.ColCount := Cols;
g.RowCount := Rows;
Value := -1;
for R := 0 to Rows - 1 do
    for C := 0 to Cols - 1 do
       begin
       Value := Value + 1;
       S:=IntToStr(Value);
       If Length(S) < 2 then S := '0'+S;
       g.Cells[C,R] := S;
       end;

end;
procedure TsesTimePicker.Init;
begin
RefreshTime := False;
Edit := nil;
Editor:=nil;


   P1.Caption := sesTimePicker_hh;
   Lh.Caption:=  sesTimePicker_hh;
   P2.Caption := sesTimePicker_mm;
   Lm.Caption:=  sesTimePicker_mm;
   P3.Caption := sesTimePicker_ss;
   Ls.Caption:=  sesTimePicker_ss;

bSetNow.Caption:= sesTimePicker_Now;

sgH.OnDrawCell := TimeDrawCell;
sgM.OnDrawCell := TimeDrawCell;
sgS.OnDrawCell := TimeDrawCell;

FillGrid(sgH,12,2);
FillGrid(sgM,15,4);
FillGrid(sgS,15,4);

{
Year.Caption := sesTimePicker_Year;
Month.Caption := sesTimePicker_Month;
Day.Caption := sesTimePicker_Day;
}
{
TimeControl.yE1.OnKeyPress :=yE1KeyPress;
TimeControl.yE2.OnKeyPress :=yE2KeyPress;
TimeControl.yE1.Text := '0';
TimeControl.yE1.Text := '0';

TimeControl.mE1.OnKeyPress :=mE1KeyPress;
TimeControl.mE2.OnKeyPress :=mE2KeyPress;
TimeControl.mE1.Text := '0';
TimeControl.mE1.Text := '0';

TimeControl.dE1.OnKeyPress :=dE1KeyPress;
TimeControl.dE2.OnKeyPress :=dE2KeyPress;
TimeControl.dE1.Text := '0';
TimeControl.dE1.Text := '0';
}
end;





procedure TsesTimePicker.sgHSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
If RefreshTime then Exit;
With sgH do
begin
E1.Text := Copy(Cells[ACol,ARow],1,1);
E2.Text := Copy(Cells[ACol,ARow],2,1);
TimeChange;
end;
end;

procedure TsesTimePicker.sgMSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
If RefreshTime then Exit;
With sgM do
begin
E3.Text := Copy(Cells[ACol,ARow],1,1);
E4.Text := Copy(Cells[ACol,ARow],2,1);
TimeChange;
end;

end;

procedure TsesTimePicker.sgSSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
If RefreshTime then Exit;
With sgS do
begin
E5.Text := Copy(Cells[ACol,ARow],1,1);
E6.Text := Copy(Cells[ACol,ARow],2,1);
TimeChange;
end;

end;

procedure TsesTimePicker.bSetNowClick(Sender: TObject);
var
S:String;
T:TParsedTime;
begin
S:=TimeToStr(Time());
IsStringTime(S,T);
E1.Text := T.h1;
E2.Text := T.h2;

E3.Text := T.m1;
E4.Text := T.m2;

E5.Text := T.ss1;
E6.Text := T.ss2;
TimeChange;
end;

procedure TsesTimePicker.RefreshButtons;
var
C,R:Integer;
S:String;
lBreak:Boolean;
begin
RefreshTime:= True;
S:=TimeControl.ParsedTime.sHour;
With sgH do
begin
Row:=0;
Col:=0;
lBreak := False;
for R:=0 to RowCount-1 do
  begin
  If lBreak then Break;
   for C:=0 to ColCount-1 do
      begin
      If Cells[C,R] = S then
         begin
         lBreak := True;
         Row := R;
         Col := C;
         Break;
         end;
      end; // C
   end; // R
end; // with

S:=TimeControl.ParsedTime.sMinutes;
With sgM do
begin
Row:=0;
Col:=0;
lBreak := False;
for R:=0 to RowCount-1 do
  begin
  If lBreak then Break;
   for C:=0 to ColCount-1 do
      begin
      If Cells[C,R] = S then
         begin
         lBreak := True;
         Row := R;
         Col := C;
         Break;
         end;
      end; // C
   end; // R
end; // with

S:=TimeControl.ParsedTime.sSeconds;
With sgS do
begin
lBreak := False;
Row:=0;
Col:=0;
for R:=0 to RowCount-1 do
  begin
  If lBreak then Break;
   for C:=0 to ColCount-1 do
      begin
      If Cells[C,R] = S then
         begin
         lBreak := True;
         Row := R;
         Col := C;
         Break;
         end;
      end; // C
   end; // R
end; // with

RefreshTime:= False;
sgH.Repaint;
sgM.Repaint;
sgS.Repaint;
end;
procedure TsesTimePicker.E1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
I:Integer;
begin
Case Key Of
VK_Right:
         begin
         E2.SetFocus;
         end;

VK_Left:
         begin
         //E2.SetFocus;
         end;


VK_Up:
         begin
         I:= StrToInt(E1.Text);
         I := I + 1;
         If I <= 2 then
            begin
            E1.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;
VK_Down:
         begin
         I:= StrToInt(E1.Text);
         I := I - 1;
         If I >= 0 then
            begin
            E1.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;

end; // Case Key Of
end;

procedure TsesTimePicker.E2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
I:Integer;
begin
Case Key Of
VK_Right:
         begin
         E3.SetFocus;
         end;

VK_Left:
         begin
         E1.SetFocus;
         end;


VK_Up:
         begin
         I:= StrToInt(E2.Text);
         I := I + 1;
         If I <= 9 then
            begin
            E2.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;
VK_Down:
         begin
         I:= StrToInt(E2.Text);
         I := I - 1;
         If I >= 0 then
            begin
            E2.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;

end; // Case Key Of
end;

procedure TsesTimePicker.E3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
I:Integer;
begin
Case Key Of
VK_Right:
         begin
         E4.SetFocus;
         end;

VK_Left:
         begin
         E2.SetFocus;
         end;


VK_Up:
         begin
         I:= StrToInt(E3.Text);
         I := I + 1;
         If I <= 5 then
            begin
            E3.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;
VK_Down:
         begin
         I:= StrToInt(E3.Text);
         I := I - 1;
         If I >= 0 then
            begin
            E3.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;

end; // Case Key Of
end;

procedure TsesTimePicker.E4KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
I:Integer;
begin
Case Key Of
VK_Right:
         begin
         E5.SetFocus;
         end;

VK_Left:
         begin
         E3.SetFocus;
         end;


VK_Up:
         begin
         I:= StrToInt(E4.Text);
         I := I + 1;
         If I <= 9 then
            begin
            E4.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;
VK_Down:
         begin
         I:= StrToInt(E4.Text);
         I := I - 1;
         If I >= 0 then
            begin
            E4.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;

end; // Case Key Of
end;

procedure TsesTimePicker.E5KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
I:Integer;
begin
Case Key Of
VK_Right:
         begin
         E6.SetFocus;
         end;

VK_Left:
         begin
         E4.SetFocus;
         end;


VK_Up:
         begin
         I:= StrToInt(E5.Text);
         I := I + 1;
         If I <= 5 then
            begin
            E5.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;
VK_Down:
         begin
         I:= StrToInt(E5.Text);
         I := I - 1;
         If I >= 0 then
            begin
            E5.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;

end; // Case Key Of
end;

procedure TsesTimePicker.E6KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
I:Integer;
begin
Case Key Of
VK_Right:
         begin
         E1.SetFocus;
         end;

VK_Left:
         begin
         E5.SetFocus;
         end;


VK_Up:
         begin
         I:= StrToInt(E6.Text);
         I := I + 1;
         If I <= 9 then
            begin
            E6.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;
VK_Down:
         begin
         I:= StrToInt(E6.Text);
         I := I - 1;
         If I >= 0 then
            begin
            E6.Text := IntToStr(I);
            TimeChange;
            RefreshButtons;
            end;
         end;

end; // Case Key Of
end;

procedure TsesTimePicker.E1KeyPress(Sender: TObject; var Key: Char);
begin
Case Key Of
'0'..'2':
          begin
          E1.Text := Key;
          TimeChange;
          RefreshButtons;
          Key:=#0;
          E2.SetFocus;
          end;
end; // Case Key Of
end;

procedure TsesTimePicker.E2KeyPress(Sender: TObject; var Key: Char);
begin
Case Key Of
'0'..'9':
          begin
          E2.Text := Key;
          TimeChange;
          RefreshButtons;
          Key:=#0;
          E3.SetFocus;
          end;
end; // Case Key Of

end;

procedure TsesTimePicker.E3KeyPress(Sender: TObject; var Key: Char);
begin
Case Key Of
'0'..'5':
          begin
          E3.Text := Key;
          TimeChange;
          RefreshButtons;
          Key:=#0;
          E4.SetFocus;
          end;
end; // Case Key Of

end;

procedure TsesTimePicker.E4KeyPress(Sender: TObject; var Key: Char);
begin
Case Key Of
'0'..'9':
          begin
          E4.Text := Key;
          TimeChange;
          RefreshButtons;
          Key:=#0;
          E5.SetFocus;
          end;
end; // Case Key Of

end;

procedure TsesTimePicker.E5KeyPress(Sender: TObject; var Key: Char);
begin
Case Key Of
'0'..'5':
          begin
          E5.Text := Key;
          TimeChange;
          RefreshButtons;
          Key:=#0;
          E6.SetFocus;
          end;
end; // Case Key Of

end;

procedure TsesTimePicker.E6KeyPress(Sender: TObject; var Key: Char);
begin
Case Key Of
'0'..'9':
          begin
          E6.Text := Key;
          TimeChange;
          RefreshButtons;
          Key:=#0;
          E1.SetFocus;
          end;
end; // Case Key Of

end;

end.
